<?php

class Api_Leads_Leadapitokens extends Api_Service_Abstract
{

    /**
     * Lead secure token
     */
    const LEADS_SECURE_TOKEN = 'LeadsToken';

    /**
     * System response helper
     *
     * @var null
     */
    protected $_responseHelper = null;

    /**
     * System session helper
     *
     * @var null
     */
    protected $_sessionHelper = null;

    /**
     * Mandatory fields
     *
     * @var array
     */
    protected $_mandatoryParams = array();


    /**
     * @var array Access Control List
     */
    protected $_accessList = array(
        Tools_Security_Acl::ROLE_SUPERADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Tools_Security_Acl::ROLE_ADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        )
    );

    public function init()
    {
        parent::init();
        $this->_responseHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('response');
        $this->_sessionHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('session');
    }

    /**
     *
     * Resource:
     * : /api/leads/leadapitokens/
     *
     * HttpMethod:
     * : GET
     *
     * @return JSON
     */
    public function getAction()
    {
    }

    /**
     *
     * * * Resource:
     * : /api/leads/leadapitokens/
     *
     * @return array
     */
    public function postAction()
    {


    }

    public function putAction()
    {

    }

    /**
     * Delete record
     *
     * * * Resource:
     * : /api/leads/leadapitokens/
     *
     * @return array
     */
    public function deleteAction()
    {
        $translator = Zend_Registry::get('Zend_Translate');
        $secureToken = $this->_request->getParam('secureToken', false);
        $tokenValid = Tools_System_Tools::validateToken($secureToken, Leads::LEADS_SECURE_TOKEN);
        if ($tokenValid !== true) {
            $this->_error(array(
                'status' => 'error',
                'message' => $translator->translate(Leads::TRANSLATION_PREFIX.'Access denied'),
                'errorCode' => '1'
            ), 200);
        }

        $id = filter_var($this->_request->getParam('id'), FILTER_SANITIZE_NUMBER_INT);

        $leadsUsersApiAccessMapper = Leads_Mapper_LeadsUsersApiAccessMapper::getInstance();
        $leadsUsersApiAccessModel = $leadsUsersApiAccessMapper->find($id);
        if (!$leadsUsersApiAccessModel instanceof Leads_Model_LeadsUsersApiAccessModel) {
            $this->_error(array(
                'status' => 'error',
                'message' => $translator->translate(Leads::TRANSLATION_PREFIX.'Record not found'),
                'errorCode' => '1'
            ), 200);
        }

        $leadsUsersApiTokensMapper = Leads_Mapper_LeadsUsersApiTokensMapper::getInstance();
        $leadsUsersApiTokensMapper->deleteByApiUserId($id);

        return array('error' => '0', 'message' => $translator->translate(Leads::TRANSLATION_PREFIX.'Access tokens have been deleted'));
    }

}
