<?php

class Api_Leads_Leadprofilevisit extends Api_Service_Abstract
{


    /**
     * Lead secure token
     */
    const LEADS_SECURE_TOKEN = 'LeadsToken';

    /**
     * System response helper
     *
     * @var null
     */
    protected $_responseHelper = null;

    /**
     * Mandatory fields
     *
     * @var array
     */
    protected $_mandatoryParams = array();


    /**
     * @var array Access Control List
     */
    protected $_accessList = array(
        Tools_Security_Acl::ROLE_SUPERADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Tools_Security_Acl::ROLE_ADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Shopping::ROLE_SALESPERSON => array(
            'allow' => array('get', 'post', 'put', 'delete')
        )
    );

    public function init()
    {
        parent::init();
        $this->_responseHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('response');
    }


    /**
     * Get lead profile visit
     *
     * Resource:
     * : /api/leads/leadprofilevisit/
     *
     * HttpMethod:
     * : GET
     *
     * @return JSON
     */
    public function getAction()
    {

        $limit = filter_var($this->_request->getParam('limit'), FILTER_SANITIZE_NUMBER_INT);
        $offset = filter_var($this->_request->getParam('offset'), FILTER_SANITIZE_NUMBER_INT);
        $sortOrder = filter_var($this->_request->getParam('order'), FILTER_SANITIZE_STRING);
        $userProfileLogId = filter_var($this->_request->getParam('userProfileLogId'), FILTER_SANITIZE_NUMBER_INT);
        $leadsProfileVisitMapper = Leads_Mapper_LeadsIpUserProfileLogActionDetailsMapper::getInstance();
        if ($userProfileLogId) {
            $where = $leadsProfileVisitMapper->getDbTable()->getAdapter()->quoteInto('pliuplad.user_profile_log_id = ?', $userProfileLogId);
            $filterParams = filter_var_array($this->_request->getParam('filter', array()), FILTER_SANITIZE_STRING);
            if (!empty($filterParams)) {

            }
            if (empty($sortOrder)) {
                $sortOrder = 'pliuplad.action_datetime DESC';
            }
            $data = $leadsProfileVisitMapper->fetchAllForGrid($where, $sortOrder, $limit, $offset);
        }

        if (empty($data)) {
            $data = array();
        }

        if (!empty($data)) {

        }

        return $data;
    }

    /**
     *
     * Resource:
     * : /api/leads/leadprofilevisit/
     *
     * HttpMethod:
     * : POST
     *
     * @return JSON
     */
    public function postAction()
    {

    }

    /**
     * Resource:
     * : /api/leads/leadprofilevisit/
     *
     * HttpMethod:
     * : PUT
     *
     * ## Parameters:
     * id (type integer)
     *
     * @return JSON
     */
    public function putAction()
    {

    }

    /**
     *
     * Resource:
     * : /api/leads/leadprofilevisit/
     *
     * HttpMethod:
     * : DELETE
     *
     * ## Parameters:
     *
     * @return JSON
     */
    public function deleteAction()
    {

    }

}
