<?php

class Api_Leads_Leadreports extends Api_Service_Abstract
{

    /**
     * Lead report by owner
     */
    const LEAD_REPORT_BY_REP = 'byRep';

    /**
     *
     * Lead report opportunities count per owner
     *
     */
    const LEAD_REPORT_OPPORTUNITIES_COUNT_PER_REP = 'opportunitiesCountPerRep';

    /**
     *
     * Lead report opportunities amount per owner
     *
     */
    const LEAD_REPORT_OPPORTUNITIES_AMOUNT_PER_REP = 'opportunitiesAmountPerRep';

    /**
     *
     * Lead report opportunities stage per owner
     *
     *
     */
    const LEAD_REPORT_OPPORTUNITIES_STAGE_PER_REP = 'opportunitiesStagePerRep';

    /**
     *
     * Lead report activities stage per owner
     *
     *
     */
    const LEAD_REPORT_ACTIVITIES_PER_REP = 'activitiesPerRep';

    /**
     *
     * Lead report tasks per owner
     *
     */
    const LEAD_REPORT_TASKS_COUNT_PER_REP = 'tasksCountPerRep';

    /**
     * Lead report by group
     */
    const LEAD_REPORT_BY_GROUP = 'byGroup';

    /**
     * Lead report lifecycle by group
     */
    const LEAD_REPORT_LIFECYCLE_BY_GROUP = 'lifecycleByGroup';

    /**
     * Opportunity count per group
     */
    const LEAD_REPORT_OPPORTUNITY_COUNT_PER_GROUP = 'opportunityCountPerGroup';

    /**
     * Opportunity amount by group
     */
    const LEAD_REPORT_OPPORTUNITY_AMOUNT_BY_GROUP = 'opportunityAmountByGroup';

    /**
     * Opportunity stage per group
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_GROUP = 'opportunityStagePerGroup';

    /**
     * Lead report opportunity by source
     */
    const LEAD_REPORT_OPPORTUNITY_BY_SOURCE = 'bySource';

    /**
     * Lead report opportunity per source
     */
    const LEAD_REPORT_OPPORTUNITY_COUNT_PER_SOURCE = 'opportunityCountPerSource';

    /**
     * Lead report opportunity amount by source
     */
    const LEAD_REPORT_OPPORTUNITY_AMOUNT_BY_SOURCE = 'opportunityAmountBySource';

    /**
     * Lead report stage per source
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE = 'opportunityStagePerSource';

    /**
     * Lead report opportunity stage original
     */
    const LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_ORIGINAL = 'opportunityStageFunnelOriginal';

    /**
     * Lead report opportunity stage funnel compare
     */
    const LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_COMPARE = 'opportunityStageFunnelCompare';

    /**
     * Lead report opportunity stage pie original
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PIE_ORIGINAL = 'opportunityStagePieOriginal';

    /**
     * Lead report opportunity stage pie compare
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PIE_COMPARE = 'opportunityStagePieCompare';

    /**
     * Lead report opportunity stage per rep sale sale
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_REP_SALE = 'opportunityStagePerRepSale';

    /**
     * Lead report opportunity stage per source sale sale
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE_SALE = 'opportunityStagePerSourceSale';

    /**
     * Lead report opportunity stage per tag sale
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_TAG_SALE = 'opportunityStagePerTagSale';

    /**
     * Lead report opportunity stage per group sale sale
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_GROUP_SALE = 'opportunityStagePerGroupSale';

    /**
     * Lead report online sales stage pie
     */
    const LEAD_REPORT_ONLINE_SALES_STAGE_PIE_ORIGINAL = 'onlineSalesStagePieOriginal';

    /**
     * Lead report online sales stage pie compare
     */
    const LEAD_REPORT_ONLINE_SALES_STAGE_PIE_COMPARE = 'onlineSalesStagePieCompare';

    /**
     * Lead report by lifecycle
     */
    const LEAD_REPORT_BY_LIFECYCLE = 'byLifecycle';

    const LEAD_REPORT_MARKETING_EMAILS_COUNT_PER_OPEN = 'marketingEmailsCountPerOpen';

    const LEAD_REPORT_MARKETING_EMAILS_COUNT_PER_SEND = 'marketingEmailsCountPerSend';

    const LEAD_REPORT_MARKETING_SMS_COUNT_PER_SEND = 'marketingSMSCountPerSend';

    /**
     * Lead reports secure token
     */
    const LEAD_REPORTS_SECURE_TOKEN = 'LeadsToken';

    /**
     * System response helper
     *
     * @var null
     */
    protected $_responseHelper = null;

    /**
     * Mandatory fields
     *
     * @var array
     */
    protected $_mandatoryParams = array();


    public static $_opportunityStagesWithoutLostAndWon = array('10', '20', '30', '40', '50', '60', '70', '80', '90');

    /**
     * @var array Access Control List
     */
    protected $_accessList = array(
        Tools_Security_Acl::ROLE_SUPERADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Tools_Security_Acl::ROLE_ADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Shopping::ROLE_SALESPERSON => array(
            'allow' => array('get', 'post', 'put', 'delete')
        )
    );

    public function init()
    {
        parent::init();
        $this->_responseHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('response');
    }


    /**
     *
     * Resource:
     * : /api/leads/leadreports/
     *
     * HttpMethod:
     * : GET
     *
     * @return JSON
     */
    public function getAction()
    {

        $leadId = filter_var($this->_request->getParam('leadId'), FILTER_SANITIZE_NUMBER_INT);
        $graphTypes = $this->_request->getParam('graphTypes');
        $tabContentName = filter_var($this->_request->getParam('tabContentName'), FILTER_SANITIZE_STRING);
        $leadReportsCompare = filter_var($this->_request->getParam('leadReportsCompare'), FILTER_SANITIZE_NUMBER_INT);
        $leadReportsFilterStartDateOrigin = filter_var($this->_request->getParam('leadReportsFilterStartDate'), FILTER_SANITIZE_STRING);
        $leadReportsFilterEndDateOrigin = filter_var($this->_request->getParam('leadReportsFilterEndDate'), FILTER_SANITIZE_STRING);
        $leadReportsCompareFilterStartDateOrigin = filter_var($this->_request->getParam('leadReportsCompareFilterStartDate'), FILTER_SANITIZE_STRING);
        $leadReportsCompareFilterEndDateOrigin = filter_var($this->_request->getParam('leadReportsCompareFilterEndDate'), FILTER_SANITIZE_STRING);
        $translator = Zend_Registry::get('Zend_Translate');

        $leadReportsFilterStartDateOriginForLabel = $leadReportsFilterStartDateOrigin;
        if (empty($leadReportsFilterStartDateOriginForLabel)) {
            $leadReportsFilterStartDateOriginForLabel = Tools_System_Tools::convertDateFromTimezone('now');
        }
        $leadReportsFilterEndDateOriginForLabel = $leadReportsFilterEndDateOrigin;
        if (empty($leadReportsFilterEndDateOriginForLabel)) {
            $leadReportsFilterEndDateOriginForLabel = Tools_System_Tools::convertDateFromTimezone('now');
        }

        $leadReportsCompareFilterStartDateOriginForLabel = $leadReportsCompareFilterStartDateOrigin;
        if (empty($leadReportsCompareFilterStartDateOriginForLabel)) {
            $leadReportsCompareFilterStartDateOriginForLabel = Tools_System_Tools::convertDateFromTimezone('now');
        }

        $leadReportsCompareFilterEndDateOriginForLabel = $leadReportsCompareFilterEndDateOrigin;
        if (empty($leadReportsCompareFilterEndDateOriginForLabel)) {
            $leadReportsCompareFilterEndDateOriginForLabel = Tools_System_Tools::convertDateFromTimezone('now');
        }

        $leadReportsFilterDateOriginForLabel = date('d-M-Y', strtotime($leadReportsFilterStartDateOriginForLabel)).' to '. date('d-M-Y', strtotime($leadReportsFilterEndDateOriginForLabel));
        $leadReportsFilterDateCompareForLabel = date('d-M-Y', strtotime($leadReportsCompareFilterStartDateOriginForLabel)).' to '. date('d-M-Y', strtotime($leadReportsCompareFilterEndDateOriginForLabel));

        $leadReportsMapper = Leads_Mapper_LeadsReportsMapper::getInstance();

        $leadReportsFilterStartDate = Tools_System_Tools::convertDateFromTimezone($leadReportsFilterStartDateOrigin. ' 00:00:00', false, 'UTC', 'Y-m-d H:i:s');
        $leadReportsFilterEndDate = Tools_System_Tools::convertDateFromTimezone($leadReportsFilterEndDateOrigin. ' 23:59:59', false, 'UTC', 'Y-m-d H:i:s');
        $leadReportsCompareFilterStartDate = Tools_System_Tools::convertDateFromTimezone($leadReportsCompareFilterStartDateOrigin. ' 00:00:00', false, 'UTC', 'Y-m-d H:i:s');
        $leadReportsCompareFilterEndDate = Tools_System_Tools::convertDateFromTimezone($leadReportsCompareFilterEndDateOrigin. ' 23:59:59', false, 'UTC', 'Y-m-d H:i:s');

        $currency = Zend_Registry::get('Zend_Currency');

        $data = array();

//////////////////////////////////////////Alternative version for counting bar graph///////////////////////////////////////////////////////////////////////
//      $ownersData = $leadReportsMapper->getLeadsByOwnerCount($leadReportsFilterStartDate, $leadReportsFilterEndDate);
//      if (!empty($leadReportsCompare) && !empty($leadReportsCompareFilterStartDate) && !empty($leadReportsCompareFilterEndDate)) {
//          $ownersDataCompare = $leadReportsMapper->getLeadsByOwnerCount($leadReportsCompareFilterStartDate,
//          $leadReportsCompareFilterEndDate);
//          $ownersDataReportResult = Tools_LeadReportsTools::prepareLeadOwnersData($ownersData, $ownersDataCompare);
//      } else{
//          $ownersDataReportResult = Tools_LeadReportsTools::prepareLeadOwnersData($ownersData);
//      }

        $restrictedUserId = Tools_LeadTools::getUserIdIfActionNotAllowed(Shopping::ROLE_SALESPERSON);

        if (in_array(self::LEAD_REPORT_BY_REP, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_LEADS_BY_REP;
            if (!empty($leadReportsCompare)) {
                $ownersData = $leadReportsMapper->getLeadsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $ownersDataReportResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($ownersData, true, $graphResultLabel);
            } else {
                $ownersData = $leadReportsMapper->getLeadsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $ownersDataReportResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($ownersData, false, $graphResultLabel);
            }

            if (!empty($ownersDataReportResult)) {
                //$ownersDataReportResult['title'] = $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_LEADS_BY_REP);
                if (!empty($ownersDataReportResult['data'])) {
                    $ownersDataReportResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($ownersDataReportResult['dataToCompare'])) {
                    $ownersDataReportResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_BY_REP] = $ownersDataReportResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITIES_COUNT_PER_REP, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_OPPORTUNITIES_COUNT_BAR;
            if (!empty($leadReportsCompare)) {
                $opportunitiesLeadsOwnerData = $leadReportsMapper->getOpportunitiesByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $ownersOpportunitiesDataReportResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($opportunitiesLeadsOwnerData, true, $graphResultLabel);
            } else {
                $opportunitiesLeadsOwnerData = $leadReportsMapper->getOpportunitiesByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $ownersOpportunitiesDataReportResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($opportunitiesLeadsOwnerData, false, $graphResultLabel);
            }

            if (!empty($ownersOpportunitiesDataReportResult)) {
                //$ownersOpportunitiesDataReportResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_COUNT_BAR);
                if (!empty($ownersOpportunitiesDataReportResult['data'])) {
                    $ownersOpportunitiesDataReportResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($ownersOpportunitiesDataReportResult['dataToCompare'])) {
                    $ownersOpportunitiesDataReportResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITIES_COUNT_PER_REP] = $ownersOpportunitiesDataReportResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITIES_AMOUNT_PER_REP, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_OPPORTUNITIES_AMOUNT_BAR;
            if (!empty($leadReportsCompare)) {
                $opportunitiesLeadsOwnerAmountData = $leadReportsMapper->getOpportunitiesByOwnerAmountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $ownersOpportunitiesAmountDataReportResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($opportunitiesLeadsOwnerAmountData, true, $graphResultLabel);
            } else {
                $opportunitiesLeadsOwnerAmountData = $leadReportsMapper->getOpportunitiesByOwnerAmountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $ownersOpportunitiesAmountDataReportResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($opportunitiesLeadsOwnerAmountData, false, $graphResultLabel);
            }

            if (!empty($ownersOpportunitiesAmountDataReportResult)) {
                //$ownersOpportunitiesAmountDataReportResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_AMOUNT_BAR);
                if (!empty($ownersOpportunitiesAmountDataReportResult['data'])) {
                    $ownersOpportunitiesAmountDataReportResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($ownersOpportunitiesAmountDataReportResult['dataToCompare'])) {
                    $ownersOpportunitiesAmountDataReportResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITIES_AMOUNT_PER_REP] = $ownersOpportunitiesAmountDataReportResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITIES_STAGE_PER_REP, $graphTypes)) {
            if (!empty($leadReportsCompare)) {
                $opportunitiesStagesLeadsOwnerCountData = $leadReportsMapper->getOpportunitiesStageByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, array('1'), false, $restrictedUserId);
                $ownersOpportunitiesStagesCountDataReportResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesLeadsOwnerCountData, true);
            } else {
                $opportunitiesStagesLeadsOwnerCountData = $leadReportsMapper->getOpportunitiesStageByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, array('1'), false, $restrictedUserId);
                $ownersOpportunitiesStagesCountDataReportResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesLeadsOwnerCountData);
            }

            if (!empty($ownersOpportunitiesStagesCountDataReportResult)) {
                //$ownersOpportunitiesStagesCountDataReportResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_BAR_AGGREGATED);
                $ownersOpportunitiesStagesCountDataReportResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $ownersOpportunitiesStagesCountDataReportResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
            }
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITIES_STAGE_PER_REP] = $ownersOpportunitiesStagesCountDataReportResult;
        }

        if (in_array(self::LEAD_REPORT_ACTIVITIES_PER_REP, $graphTypes)) {
            $outboundEmailsDescription = $translator->translate(Leads::TRANSLATION_PREFIX.'Outbound emails');
            $outboundCallsDescription = $translator->translate(Leads::TRANSLATION_PREFIX.'Outbound calls');
            $outboundMeetingsDescription = $translator->translate(Leads::TRANSLATION_PREFIX.'Outbound meetings');
            if (!empty($leadReportsCompare)) {
                $activitiesOutboundEmailsLeadsOwnerData = $leadReportsMapper->getActivitiesOutboundEmailsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $outboundEmailsDescription, $restrictedUserId);
                $activitiesOutboundCallsLeadsOwnerData = $leadReportsMapper->getActivitiesOutboundCallsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $outboundCallsDescription, $restrictedUserId);
                $activitiesOutboundMeetingsLeadsOwnerData = $leadReportsMapper->getActivitiesOutboundMeetingsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $outboundMeetingsDescription, $restrictedUserId);

                $activitiesLeadsOwnerDataResult = array_merge($activitiesOutboundEmailsLeadsOwnerData, $activitiesOutboundCallsLeadsOwnerData, $activitiesOutboundMeetingsLeadsOwnerData);
                $ownersActivitiesDataReportResult = Tools_LeadReportsTools::prepareLeadsDataAggregatedBar($activitiesLeadsOwnerDataResult,
                    Tools_LeadReportsTools::$_tasksBarColorsFrom, true, Tools_LeadReportsTools::$_tasksBarColorsTo,
                    false, '20', array('activity_id'));
            } else {
                $activitiesOutboundEmailsLeadsOwnerData = $leadReportsMapper->getActivitiesOutboundEmailsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, '', '', $outboundEmailsDescription, $restrictedUserId);
                $activitiesOutboundCallsLeadsOwnerData = $leadReportsMapper->getActivitiesOutboundCallsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, '', '', $outboundCallsDescription, $restrictedUserId);
                $activitiesOutboundMeetingsLeadsOwnerData = $leadReportsMapper->getActivitiesOutboundMeetingsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, '', '', $outboundMeetingsDescription, $restrictedUserId);

                $activitiesLeadsOwnerDataResult = array_merge($activitiesOutboundEmailsLeadsOwnerData, $activitiesOutboundCallsLeadsOwnerData, $activitiesOutboundMeetingsLeadsOwnerData);
                $ownersActivitiesDataReportResult = Tools_LeadReportsTools::prepareLeadsDataAggregatedBar($activitiesLeadsOwnerDataResult, Tools_LeadReportsTools::$_tasksBarColorsFrom, false, array(), false, '0', array('activity_id'));
            }

            if (!empty($ownersActivitiesDataReportResult)) {
                //$ownersActivitiesDataReportResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_ACTIVITIES_BAR_AGGREGATED);
                $ownersActivitiesDataReportResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $ownersActivitiesDataReportResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
            }

            $data['graphs'][self::LEAD_REPORT_ACTIVITIES_PER_REP] = $ownersActivitiesDataReportResult;

        }

        if (in_array(self::LEAD_REPORT_TASKS_COUNT_PER_REP, $graphTypes)) {
            $newlyAssignedTasksDescription = $translator->translate(Leads::TRANSLATION_PREFIX.'Newly assigned tasks');
            $closedTasksDescription = $translator->translate(Leads::TRANSLATION_PREFIX.'Closed assigned tasks');
            $pendingTasksDescription = $translator->translate(Leads::TRANSLATION_PREFIX.'Pending tasks');
            if (!empty($leadReportsCompare)) {
                $tasksLeadsOwnerData = $leadReportsMapper->getTasksByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $newlyAssignedTasksDescription, $restrictedUserId);
                $tasksLeadsOwnerDataCompleted = $leadReportsMapper->getCompletedTasksByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $closedTasksDescription, $restrictedUserId);
                $tasksLeadsOwnerDataFromBeginning = $leadReportsMapper->getTasksByOwnerCountAggregatedFromBeginning($leadReportsFilterEndDate, $pendingTasksDescription, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $tasksLeadsOwnerDataResult = array_merge($tasksLeadsOwnerData, $tasksLeadsOwnerDataCompleted, $tasksLeadsOwnerDataFromBeginning);
                $ownersTasksDataReportResult = Tools_LeadReportsTools::prepareLeadsDataAggregatedBar($tasksLeadsOwnerDataResult,
                    Tools_LeadReportsTools::$_tasksBarColorsFrom, true, Tools_LeadReportsTools::$_tasksBarColorsTo,
                    false, '20');
            } else {
                $tasksLeadsOwnerData = $leadReportsMapper->getTasksByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, '', '', $newlyAssignedTasksDescription, $restrictedUserId);
                $tasksLeadsOwnerDataCompleted = $leadReportsMapper->getCompletedTasksByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, '', '', $closedTasksDescription, $restrictedUserId);
                $tasksLeadsOwnerDataFromBeginning = $leadReportsMapper->getTasksByOwnerCountAggregatedFromBeginning($leadReportsFilterEndDate, $pendingTasksDescription, '', $restrictedUserId);
                $tasksLeadsOwnerDataResult = array_merge($tasksLeadsOwnerData, $tasksLeadsOwnerDataCompleted, $tasksLeadsOwnerDataFromBeginning);
                $ownersTasksDataReportResult = Tools_LeadReportsTools::prepareLeadsDataAggregatedBar($tasksLeadsOwnerDataResult,
                    Tools_LeadReportsTools::$_tasksBarColorsFrom);
            }

            if (!empty($ownersTasksDataReportResult)) {
                //$ownersTasksDataReportResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_RESULT_LABEL_TASKS_COUNT_BAR);
                $ownersTasksDataReportResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $ownersTasksDataReportResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
            }

            $data['graphs'][self::LEAD_REPORT_TASKS_COUNT_PER_REP] = $ownersTasksDataReportResult;
        }

        if (in_array(self::LEAD_REPORT_BY_GROUP, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_LEADS_BY_GROUP;
            if (!empty($leadReportsCompare)) {
                $leadsByGroupData = $leadReportsMapper->getLeadsByGroupCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $leadsByGroupResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsByGroupData, true, $graphResultLabel);
            } else {
                $leadsByGroupData = $leadReportsMapper->getLeadsByGroupCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $leadsByGroupResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsByGroupData, false, $graphResultLabel);
            }

            if (!empty($leadsByGroupResult)) {
                //$leadsByGroupResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_LEADS_BY_GROUP);
                if (!empty($leadsByGroupResult['data'])) {
                    $leadsByGroupResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($leadsByGroupResult['dataToCompare'])) {
                    $leadsByGroupResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_BY_GROUP] = $leadsByGroupResult;
        }

        if (in_array(self::LEAD_REPORT_LIFECYCLE_BY_GROUP, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_LEADS_LIFECYCLE_BY_GROUP;
            if (!empty($leadReportsCompare)) {
                $leadsLifecycleByGroupData = $leadReportsMapper->getLeadsLifecycleByGroupCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $leadsLifecycleByGroupResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsLifecycleByGroupData, true, $graphResultLabel, false, array('stage_id'));
            } else {
                $leadsLifecycleByGroupData = $leadReportsMapper->getLeadsLifecycleByGroupCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $leadsLifecycleByGroupResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsLifecycleByGroupData, false, $graphResultLabel, false, array('stage_id'));
            }

            if (!empty($leadsLifecycleByGroupResult)) {
                //$leadsLifecycleByGroupResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_LEADS_LIFECYCLE_BY_GROUP);
                if (!empty($leadsLifecycleByGroupResult['data'])) {
                    $leadsLifecycleByGroupResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($leadsLifecycleByGroupResult['dataToCompare'])) {
                    $leadsLifecycleByGroupResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_LIFECYCLE_BY_GROUP] = $leadsLifecycleByGroupResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_COUNT_PER_GROUP, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_OPPORTUNITIES_COUNT_PER_GROUP;
            if (!empty($leadReportsCompare)) {
                $leadsByGroupOpportunityDataCount = $leadReportsMapper->getLeadsByGroupOpportunitiesCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $leadsByGroupOpportunityDataCountResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsByGroupOpportunityDataCount, true, $graphResultLabel);
            } else {
                $leadsByGroupOpportunityDataCount = $leadReportsMapper->getLeadsByGroupOpportunitiesCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $leadsByGroupOpportunityDataCountResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsByGroupOpportunityDataCount, false, $graphResultLabel);
            }

            if (!empty($leadsByGroupOpportunityDataCountResult)) {
                //$leadsByGroupOpportunityDataCountResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_COUNT_PER_GROUP);
                if (!empty($leadsByGroupOpportunityDataCountResult['data'])) {
                    $leadsByGroupOpportunityDataCountResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($leadsByGroupOpportunityDataCountResult['dataToCompare'])) {
                    $leadsByGroupOpportunityDataCountResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_COUNT_PER_GROUP] = $leadsByGroupOpportunityDataCountResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_AMOUNT_BY_GROUP, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_OPPORTUNITIES_AMOUNT_BY_GROUP;
            if (!empty($leadReportsCompare)) {
                $leadsByGroupOpportunityDataAmount = $leadReportsMapper->getLeadsByGroupOpportunitiesAmountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $leadsByGroupOpportunityDataAmountResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsByGroupOpportunityDataAmount, true, $graphResultLabel);
            } else {
                $leadsByGroupOpportunityDataAmount = $leadReportsMapper->getLeadsByGroupOpportunitiesAmountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $leadsByGroupOpportunityDataAmountResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsByGroupOpportunityDataAmount, false, $graphResultLabel);
            }

            if (!empty($leadsByGroupOpportunityDataAmountResult)) {
                //$leadsByGroupOpportunityDataAmountResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_AMOUNT_BY_GROUP);
                if (!empty($leadsByGroupOpportunityDataAmountResult['data'])) {
                    $leadsByGroupOpportunityDataAmountResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($leadsByGroupOpportunityDataAmountResult['dataToCompare'])) {
                    $leadsByGroupOpportunityDataAmountResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_AMOUNT_BY_GROUP] = $leadsByGroupOpportunityDataAmountResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_GROUP, $graphTypes)) {
            if (!empty($leadReportsCompare)) {
                $opportunitiesStagesPerGroup = $leadReportsMapper->getOpportunitiesStageByGroupCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate,  array('1', '100'), false, $restrictedUserId);
                $opportunitiesStagesPerGroupResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerGroup, true);
            } else {
                $opportunitiesStagesPerGroup = $leadReportsMapper->getOpportunitiesStageByGroupCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, array('1', '100'), false, $restrictedUserId);
                $opportunitiesStagesPerGroupResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerGroup);
            }

            if (!empty($opportunitiesStagesPerGroupResult)) {
                //$opportunitiesStagesPerGroupResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_BAR_AGGREGATED_BY_GROUP);
                $opportunitiesStagesPerGroupResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesPerGroupResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_GROUP] = $opportunitiesStagesPerGroupResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_BY_SOURCE, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_LEADS_BY_SOURCE;
            if (!empty($leadReportsCompare)) {
                $leadsBySourceData = $leadReportsMapper->getLeadsBySourceCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $leadsBySourceResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsBySourceData, true, $graphResultLabel, true);
            } else {
                $leadsBySourceData = $leadReportsMapper->getLeadsBySourceCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $leadsBySourceResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsBySourceData, false, $graphResultLabel);
            }

            if (!empty($leadsBySourceResult)) {
                //$leadsBySourceResult['title'] = $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_LEADS_BY_SOURCE);
                if (!empty($leadsBySourceResult['data'])) {
                    $leadsBySourceResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($leadsBySourceResult['dataToCompare'])) {
                    $leadsBySourceResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_BY_SOURCE] = $leadsBySourceResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_COUNT_PER_SOURCE, $graphTypes)) {

            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_OPPORTUNITIES_COUNT_PER_SOURCE;
            if (!empty($leadReportsCompare)) {
                $leadsBySourceOpportunityDataCount = $leadReportsMapper->getLeadsBySourceOpportunitiesCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $leadsBySourceOpportunityDataCountResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsBySourceOpportunityDataCount, true, $graphResultLabel);
            } else {
                $leadsBySourceOpportunityDataCount = $leadReportsMapper->getLeadsBySourceOpportunitiesCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $leadsBySourceOpportunityDataCountResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsBySourceOpportunityDataCount, false, $graphResultLabel);
            }

            if (!empty($leadsBySourceOpportunityDataCountResult)) {
                //$leadsBySourceOpportunityDataCountResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_COUNT_PER_SOURCE);
                if (!empty($leadsBySourceOpportunityDataCountResult['data'])) {
                    $leadsBySourceOpportunityDataCountResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($leadsBySourceOpportunityDataCountResult['dataToCompare'])) {
                    $leadsBySourceOpportunityDataCountResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_COUNT_PER_SOURCE] = $leadsBySourceOpportunityDataCountResult;
        }


        if (in_array(self::LEAD_REPORT_OPPORTUNITY_AMOUNT_BY_SOURCE, $graphTypes)) {

            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_OPPORTUNITIES_AMOUNT_BY_SOURCE;
            if (!empty($leadReportsCompare)) {
                $leadsBySourceOpportunityDataAmount = $leadReportsMapper->getLeadsBySourceOpportunitiesAmountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $leadsBySourceOpportunityDataAmountResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsBySourceOpportunityDataAmount, true, $graphResultLabel);
            } else {
                $leadsBySourceOpportunityDataAmount = $leadReportsMapper->getLeadsBySourceOpportunitiesAmountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $leadsBySourceOpportunityDataAmountResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsBySourceOpportunityDataAmount, false, $graphResultLabel);
            }

            if (!empty($leadsBySourceOpportunityDataAmountResult)) {
                //$leadsBySourceOpportunityDataAmountResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_AMOUNT_BY_SOURCE);
                if (!empty($leadsBySourceOpportunityDataAmountResult['data'])) {
                    $leadsBySourceOpportunityDataAmountResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($leadsBySourceOpportunityDataAmountResult['dataToCompare'])) {
                    $leadsBySourceOpportunityDataAmountResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_AMOUNT_BY_SOURCE] = $leadsBySourceOpportunityDataAmountResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE, $graphTypes)) {

            if (!empty($leadReportsCompare)) {
                $opportunitiesStagesPerSource = $leadReportsMapper->getOpportunitiesStageBySourceCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate,  array('1'), false, $restrictedUserId);
                $opportunitiesStagesPerSourceResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerSource, true);
            } else {
                $opportunitiesStagesPerSource = $leadReportsMapper->getOpportunitiesStageBySourceCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, array('1'), false , $restrictedUserId);
                $opportunitiesStagesPerSourceResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerSource);
            }

            if (!empty($opportunitiesStagesPerSourceResult)) {
                //$opportunitiesStagesPerSourceResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_BAR_AGGREGATED_BY_SOURCE);
                $opportunitiesStagesPerSourceResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesPerSourceResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE] = $opportunitiesStagesPerSourceResult;
        }

        $funnelDateRangeType = filter_var($this->_request->getParam('funnelDateRangeType'), FILTER_SANITIZE_STRING);


        if (in_array(self::LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_ORIGINAL, $graphTypes)) {
            $dateRangeType = 'expected';
            if (!empty($funnelDateRangeType) && $funnelDateRangeType === 'changed') {
                $dateRangeType = 'changed';
            }
            if (!empty($funnelDateRangeType) && $funnelDateRangeType === 'created') {
                $dateRangeType = 'created';
            }
            $opportunitiesStagesFunnelDataOriginal = $leadReportsMapper->getOpportunitiesStage($leadReportsFilterStartDate, $leadReportsFilterEndDate, $dateRangeType, array('1', '100'), $restrictedUserId);
            $opportunitiesStagesFunnelResult = Tools_LeadReportsTools::prepareOpportunityStageFunnel($opportunitiesStagesFunnelDataOriginal);
            $salesExpectation = Tools_LeadReportsTools::prepareSalesExpectation($opportunitiesStagesFunnelDataOriginal);
            if (!empty($opportunitiesStagesFunnelResult)) {
                //$opportunitiesStagesFunnelResult['title'] = $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITY_FUNNEL_STAGE);
                $opportunitiesStagesFunnelResult['filterPeriod'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesFunnelResult['salesExpectation'] = $salesExpectation;

                $moneyFormat = Tools_LeadTools::getCurrencyFormat();
                $opportunitiesStagesFunnelResult['moneyFormat'] = json_encode($moneyFormat);

                foreach ($opportunitiesStagesFunnelDataOriginal as $key => $opportunitiesStages) {
                    $opportunitiesStagesFunnelResult['axesAdditionalInfo'][] = $key;
                }
            }
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_ORIGINAL] = $opportunitiesStagesFunnelResult;
        }
        if (in_array(self::LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_COMPARE, $graphTypes) && !empty($leadReportsCompare)) {
            $dateRangeType = 'expected';
            if (!empty($funnelDateRangeType) && $funnelDateRangeType === 'changed') {
                $dateRangeType = 'changed';
            }
            if (!empty($funnelDateRangeType) && $funnelDateRangeType === 'created') {
                $dateRangeType = 'created';
            }
            $opportunitiesStagesFunnelDataCompare = $leadReportsMapper->getOpportunitiesStage($leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $dateRangeType, array('1', '100'), $restrictedUserId);
            $opportunitiesStagesFunnelResult = Tools_LeadReportsTools::prepareOpportunityStageFunnel($opportunitiesStagesFunnelDataCompare);
            $salesExpectation = Tools_LeadReportsTools::prepareSalesExpectation($opportunitiesStagesFunnelDataCompare);
            if (!empty($opportunitiesStagesFunnelResult)) {
                //$opportunitiesStagesFunnelResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITY_FUNNEL_STAGE);
                $opportunitiesStagesFunnelResult['filterPeriod'] = $leadReportsFilterDateCompareForLabel;
                $opportunitiesStagesFunnelResult['salesExpectation'] = $salesExpectation;

                $moneyFormat = Tools_LeadTools::getCurrencyFormat();
                $opportunitiesStagesFunnelResult['moneyFormat'] = json_encode($moneyFormat);

                foreach ($opportunitiesStagesFunnelDataCompare as $key => $opportunitiesStages) {
                    $opportunitiesStagesFunnelResult['axesAdditionalInfo'][] = $key;
                }
            }
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_COMPARE] = $opportunitiesStagesFunnelResult;
        }

        if (!empty($leadReportsCompare) && isset($opportunitiesStagesFunnelDataOriginal) && isset($opportunitiesStagesFunnelDataCompare)) {
            $comparisonFunnelData = $leadReportsMapper->getOpportunitiesStageCompare($leadReportsFilterStartDate,
                $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate,
                array('1', '100'), $restrictedUserId);
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_COMPARE]['comparisonData'] = Tools_LeadReportsTools::prepareComparisonForFunnelData($comparisonFunnelData);
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_STAGE_PIE_ORIGINAL, $graphTypes)) {
            $opportunitiesStagesPieData = $leadReportsMapper->getOpportunitiesStageAmount($leadReportsFilterStartDate, $leadReportsFilterEndDate, self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
            $opportunitiesStagesPieDataResult = Tools_LeadReportsTools::prepareOpportunityStagePie($opportunitiesStagesPieData);
            if (!empty($opportunitiesStagesPieDataResult)) {
                //$opportunitiesStagesPieDataResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_PIE_OPPORTUNITY);
                $opportunitiesStagesPieDataResult['filterPeriod'] = $leadReportsFilterDateOriginForLabel;
            }
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PIE_ORIGINAL] = $opportunitiesStagesPieDataResult;
        }
        if (in_array(self::LEAD_REPORT_OPPORTUNITY_STAGE_PIE_COMPARE, $graphTypes) && !empty($leadReportsCompare)) {
            $opportunitiesStagesPieData = $leadReportsMapper->getOpportunitiesStageAmount($leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
            $opportunitiesStagesPieDataResult = Tools_LeadReportsTools::prepareOpportunityStagePie($opportunitiesStagesPieData);
            if (!empty($opportunitiesStagesPieDataResult)) {
                //$opportunitiesStagesPieDataResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_PIE_OPPORTUNITY);
                $opportunitiesStagesPieDataResult['filterPeriod'] = $leadReportsFilterDateCompareForLabel;
            }
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PIE_COMPARE] = $opportunitiesStagesPieDataResult;
        }

        if (!empty($leadReportsCompare) && isset($opportunitiesStagesPieData) && isset($opportunitiesStagesPieData)) {
            $comparisonPieData = $leadReportsMapper->getOpportunitiesStageCompareAmount($leadReportsFilterStartDate,
                $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate,
                self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PIE_COMPARE]['comparisonData'] = Tools_LeadReportsTools::prepareComparisonForFunnelData($comparisonPieData);
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_REP_SALE, $graphTypes)) {
            if (!empty($leadReportsCompare)) {
                $opportunitiesStagesPerRepSaleData = $leadReportsMapper->getOpportunitiesStageByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
                $opportunitiesStagesPerRepSaleResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerRepSaleData, true, true);
            } else {
                $opportunitiesStagesPerRepSaleData = $leadReportsMapper->getOpportunitiesStageByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
                $opportunitiesStagesPerRepSaleResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerRepSaleData, false, true);
            }

            if (!empty($opportunitiesStagesPerRepSaleResult)) {
                //$opportunitiesStagesPerRepSaleResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_SALES_BAR_AGGREGATED);
                $opportunitiesStagesPerRepSaleResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesPerRepSaleResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
                $opportunitiesStagesPerRepSaleResult['roughData'] = $opportunitiesStagesPerRepSaleData;

            }
            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_REP_SALE] = $opportunitiesStagesPerRepSaleResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_GROUP_SALE, $graphTypes)) {
            if (!empty($leadReportsCompare)) {
                $opportunitiesStagesPerGroupSaleData = $leadReportsMapper->getOpportunitiesStageByGroupCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate,  self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
                $opportunitiesStagesPerGroupSaleDataResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerGroupSaleData, true, true);
            } else {
                $opportunitiesStagesPerGroupSaleData = $leadReportsMapper->getOpportunitiesStageByGroupCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
                $opportunitiesStagesPerGroupSaleDataResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerGroupSaleData, false, true);
            }

            if (!empty($opportunitiesStagesPerGroupSaleDataResult)) {
                //$opportunitiesStagesPerGroupSaleDataResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_SALES_BAR_AGGREGATED_BY_GROUP);
                $opportunitiesStagesPerGroupSaleDataResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesPerGroupSaleDataResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
                $opportunitiesStagesPerGroupSaleDataResult['roughData'] = $opportunitiesStagesPerGroupSaleData;

            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_GROUP_SALE] = $opportunitiesStagesPerGroupSaleDataResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE_SALE, $graphTypes)) {
            if (!empty($leadReportsCompare)) {
                $opportunitiesStagesPerSourceSaleData = $leadReportsMapper->getOpportunitiesStageBySourceCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate,  self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
                $opportunitiesStagesPerSourceSaleResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerSourceSaleData, true, true);
            } else {
                $opportunitiesStagesPerSourceSaleData = $leadReportsMapper->getOpportunitiesStageBySourceCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
                $opportunitiesStagesPerSourceSaleResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerSourceSaleData, false, true);
            }

            if (!empty($opportunitiesStagesPerSourceSaleResult)) {
                //$opportunitiesStagesPerSourceSaleResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_SALES_BAR_AGGREGATED_BY_SOURCE);
                $opportunitiesStagesPerSourceSaleResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesPerSourceSaleResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
                $opportunitiesStagesPerSourceSaleResult['roughData'] = $opportunitiesStagesPerSourceSaleData;
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE_SALE] = $opportunitiesStagesPerSourceSaleResult;
        }

        if (in_array(self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_TAG_SALE, $graphTypes)) {
            if (!empty($leadReportsCompare)) {
                $opportunitiesStagesPerTagSaleData = $leadReportsMapper->getOpportunitiesStageByTagCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate,  self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
                $opportunitiesStagesPerTagSaleResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerTagSaleData, true, true);
            } else {
                $opportunitiesStagesPerTagSaleData = $leadReportsMapper->getOpportunitiesStageByTagCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, self::$_opportunityStagesWithoutLostAndWon, true, $restrictedUserId);
                $opportunitiesStagesPerTagSaleResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerTagSaleData, false, true);
            }

            if (!empty($opportunitiesStagesPerTagSaleResult)) {
                //$opportunitiesStagesPerTagSaleResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_SALES_BAR_AGGREGATED_BY_TAG);
                $opportunitiesStagesPerTagSaleResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesPerTagSaleResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
                $opportunitiesStagesPerTagSaleResult['roughData'] = $opportunitiesStagesPerTagSaleData;
            }

            $data['graphs'][self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_TAG_SALE] = $opportunitiesStagesPerTagSaleResult;
        }

        if (in_array(self::LEAD_REPORT_ONLINE_SALES_STAGE_PIE_ORIGINAL, $graphTypes)) {
            $onlineSalesStagesPieData = array();
            $onlineSalesStagesPieDataResult = array();
            $onlineSalesStagesPieDataAmount = $leadReportsMapper->salesamountByTypeSalesCart($leadReportsFilterStartDate, $leadReportsFilterEndDate);

            if(!empty($onlineSalesStagesPieDataAmount['amount'])) {
                $onlineSalesStagesPieData['100'] = $onlineSalesStagesPieDataAmount;
                $onlineSalesStagesPieData['100']['opportunityStageId'] = '100';
                $onlineSalesStagesPieDataResult = Tools_LeadReportsTools::prepareOnlineSalesStagePie($onlineSalesStagesPieData);
                $onlineSalesStagesPieDataResult['filterPeriod'] = $leadReportsFilterDateOriginForLabel;
                /*if (!empty($onlineSalesStagesPieDataResult)) {
                    $onlineSalesStagesPieDataResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_PIE_ONLINE_SALES);
                }*/
            }

            $data['graphs'][self::LEAD_REPORT_ONLINE_SALES_STAGE_PIE_ORIGINAL] = $onlineSalesStagesPieDataResult;
        }

        if (in_array(self::LEAD_REPORT_ONLINE_SALES_STAGE_PIE_COMPARE, $graphTypes) && !empty($leadReportsCompare)) {
            $onlineSalesStagesPieCompareData = array();
            $onlineSalesStagesPieCompareDataResult = array();
            $onlineSalesStagesPieCompareDataAmount = $leadReportsMapper->salesamountByTypeSalesCart($leadReportsCompareFilterStartDateOrigin, $leadReportsCompareFilterEndDateOrigin);

            if(!empty($onlineSalesStagesPieCompareDataAmount['amount'])) {
                $onlineSalesStagesPieCompareData['100'] = $onlineSalesStagesPieCompareDataAmount;
                $onlineSalesStagesPieCompareData['100']['opportunityStageId'] = '100';
                $onlineSalesStagesPieCompareDataResult = Tools_LeadReportsTools::prepareOnlineSalesStagePie($onlineSalesStagesPieCompareData);
                $onlineSalesStagesPieCompareDataResult['filterPeriod'] = $leadReportsFilterDateCompareForLabel;
                /*if (!empty($onlineSalesStagesPieCompareDataResult)) {
                    $onlineSalesStagesPieCompareDataResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_PIE_ONLINE_SALES);
                }*/
            }

            $data['graphs'][self::LEAD_REPORT_ONLINE_SALES_STAGE_PIE_COMPARE] = $onlineSalesStagesPieCompareDataResult;
        }

        if (in_array(self::LEAD_REPORT_BY_LIFECYCLE, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_LEADS_LIFECYCLE_BY_SOURCE;
            if (!empty($leadReportsCompare)) {
                $leadsBySourceAndLifecycleData = $leadReportsMapper->getLeadsByLifecycleCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $leadsBySourceAndLifecycleResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsBySourceAndLifecycleData, true, $graphResultLabel, true,  array('stage_id'));
            } else {
                $leadsBySourceAndLifecycleData = $leadReportsMapper->getLeadsByLifecycleCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $leadsBySourceAndLifecycleResult = Tools_LeadReportsTools::prepareLeadOwnersDataAggregated($leadsBySourceAndLifecycleData, false, $graphResultLabel, false, array('stage_id'));
            }

            if (!empty($leadsBySourceAndLifecycleResult)) {
                //$leadsBySourceAndLifecycleResult['title'] = $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_LEADS_BY_LIFECYCLE);
                if (!empty($leadsBySourceAndLifecycleResult['data'])) {
                    $leadsBySourceAndLifecycleResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($leadsBySourceAndLifecycleResult['dataToCompare'])) {
                    $leadsBySourceAndLifecycleResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_BY_LIFECYCLE] = $leadsBySourceAndLifecycleResult;
        }

        if (!empty($leadReportsCompare) && isset($onlineSalesStagesPieDataAmount) && isset($onlineSalesStagesPieCompareDataAmount)) {
            $onlineSalesComparisonData = Tools_LeadReportsTools::prepareCompareOnlineSalesData($onlineSalesStagesPieDataAmount, $onlineSalesStagesPieCompareDataAmount);
            $data['graphs'][self::LEAD_REPORT_ONLINE_SALES_STAGE_PIE_COMPARE]['comparisonData'] = $onlineSalesComparisonData;
        }

        if (in_array(self::LEAD_REPORT_MARKETING_EMAILS_COUNT_PER_OPEN, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_EMAILS_COUNT_BAR_OPEN;
            if (!empty($leadReportsCompare)) {
                $sequencesData = $leadReportsMapper->getSequenceOpenSendEmailsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId, 'open');
                $sequencesDataReportResult = Tools_LeadReportsTools::prepareSequenceOpenEmailsAndSendSmsByOwnerDataAggregated($sequencesData, true, $graphResultLabel);
            } else {
                $sequencesData = $leadReportsMapper->getSequenceOpenSendEmailsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId, 'open');
                $sequencesDataReportResult = Tools_LeadReportsTools::prepareSequenceOpenEmailsAndSendSmsByOwnerDataAggregated($sequencesData, false, $graphResultLabel);
            }

            if (!empty($sequencesDataReportResult)) {
                //$sequencesDataReportResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_EMAILS_COUNT_BAR_OPEN);
                if (!empty($sequencesDataReportResult['data'])) {
                    $sequencesDataReportResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($sequencesDataReportResult['dataToCompare'])) {
                    $sequencesDataReportResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_MARKETING_EMAILS_COUNT_PER_OPEN] = $sequencesDataReportResult;
        }

        if (in_array(self::LEAD_REPORT_MARKETING_EMAILS_COUNT_PER_SEND, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_EMAILS_COUNT_BAR_SEND;
            if (!empty($leadReportsCompare)) {
                $sequencesData = $leadReportsMapper->getSequenceOpenSendEmailsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId, 'send');
                $sequencesDataReportResult = Tools_LeadReportsTools::prepareSequenceOpenEmailsAndSendSmsByOwnerDataAggregated($sequencesData, true, $graphResultLabel);
            } else {
                $sequencesData = $leadReportsMapper->getSequenceOpenSendEmailsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId, 'send');
                $sequencesDataReportResult = Tools_LeadReportsTools::prepareSequenceOpenEmailsAndSendSmsByOwnerDataAggregated($sequencesData, false, $graphResultLabel);
            }

            if (!empty($sequencesDataReportResult)) {
                //$sequencesDataReportResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_EMAILS_COUNT_BAR_SEND);
                if (!empty($sequencesDataReportResult['data'])) {
                    $sequencesDataReportResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($sequencesDataReportResult['dataToCompare'])) {
                    $sequencesDataReportResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_MARKETING_EMAILS_COUNT_PER_SEND] = $sequencesDataReportResult;
        }

        if (in_array(self::LEAD_REPORT_MARKETING_SMS_COUNT_PER_SEND, $graphTypes)) {
            $graphResultLabel = Tools_LeadReportsTools::GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_SMS_COUNT_BAR_SEND;
            if (!empty($leadReportsCompare)) {
                $sequencesData = $leadReportsMapper->getSequenceSendSmsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, $leadReportsCompareFilterStartDate, $leadReportsCompareFilterEndDate, $restrictedUserId);
                $sequencesDataReportResult = Tools_LeadReportsTools::prepareSequenceOpenEmailsAndSendSmsByOwnerDataAggregated($sequencesData, true, $graphResultLabel);
            } else {
                $sequencesData = $leadReportsMapper->getSequenceSendSmsByOwnerCountAggregated($leadReportsFilterStartDate, $leadReportsFilterEndDate, false, false, $restrictedUserId);
                $sequencesDataReportResult = Tools_LeadReportsTools::prepareSequenceOpenEmailsAndSendSmsByOwnerDataAggregated($sequencesData, false, $graphResultLabel);
            }

            if (!empty($sequencesDataReportResult)) {
                //$sequencesDataReportResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_SMS_COUNT_BAR_SEND);
                if (!empty($sequencesDataReportResult['data'])) {
                    $sequencesDataReportResult['data'][0] = $leadReportsFilterDateOriginForLabel;
                }

                if (!empty($sequencesDataReportResult['dataToCompare'])) {
                    $sequencesDataReportResult['dataToCompare'][0] = $leadReportsFilterDateCompareForLabel;
                }
            }

            $data['graphs'][self::LEAD_REPORT_MARKETING_SMS_COUNT_PER_SEND] = $sequencesDataReportResult;
        }

        $data['tabContentName'] = $tabContentName;
        $data['currencySymbol'] = preg_replace('~[\w]~', '', $currency->getSymbol());
        $moneyFormat = Tools_LeadTools::getCurrencyFormat();
        $data['moneyFormat'] = json_encode($moneyFormat);

        return $data;
    }

    /**
     * Resource:
     * : /api/leads/leadreports/
     *
     * HttpMethod:
     * : POST
     *
     * @return JSON
     */
    public function postAction()
    {
    }

    /**
     *
     * Resource:
     * : /api/leads/leadreports/
     *
     * HttpMethod:
     * : PUT
     *
     * ## Parameters:
     * id (type integer)
     *
     * @return JSON
     */
    public function putAction()
    {

    }

    /**
     *
     * Resource:
     * : /api/leads/leadreports/
     *
     * HttpMethod:
     * : DELETE
     *
     * ## Parameters:
     * id (type integer)
     *
     * @return JSON
     */
    public function deleteAction()
    {
    }

}
