<?php

class Api_Leads_Leadsrecentlyviewed extends Api_Service_Abstract
{

    const RECENTLY_VIEWED_LIMIT = '10';

    /**
     * @var array Access Control List
     */
    protected $_accessList = array(
        Tools_Security_Acl::ROLE_SUPERADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Tools_Security_Acl::ROLE_ADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Shopping::ROLE_SALESPERSON => array(
            'allow' => array('get', 'post', 'put', 'delete')
        )
    );

    public function init()
    {
        parent::init();
        $this->_responseHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('response');
    }


    /**
     * Get lead recently viewed
     *
     * Resource:
     * : /api/leads/leadsrecentlyviewed/
     *
     * HttpMethod:
     * : GET
     *
     * @return JSON
     */
    public function getAction()
    {

        $offset = filter_var($this->_request->getParam('offset'), FILTER_SANITIZE_NUMBER_INT);
        $sortOrder = 'pllv.viewed_at DESC';

        $session = Zend_Controller_Action_HelperBroker::getStaticHelper('session');
        $userId = $session->getCurrentUser()->getId();
        $lastViewedLeadsAndOrgMapper = Leads_Mapper_LeadsLastViewedMapper::getInstance();
        $where = $lastViewedLeadsAndOrgMapper->getDbTable()->getAdapter()->quoteInto('pllv.user_id = ?', $userId);
        $data = $lastViewedLeadsAndOrgMapper->fetchAll($where, $sortOrder, self::RECENTLY_VIEWED_LIMIT, $offset);

        return $data;
    }

    public function postAction()
    {
    }

    public function putAction()
    {
    }


    public function deleteAction()
    {
    }

}
