<?php

class Api_Leadsopportunities_Welcomescreen extends Api_Service_Abstract
{


    /**
     * Lead secure token
     */
    const LEADS_SECURE_TOKEN = 'LeadsToken';

    /**
     * System response helper
     *
     * @var null
     */
    protected $_responseHelper = null;

    /**
     * Mandatory fields
     *
     * @var array
     */
    protected $_mandatoryParams = array();

    /**
     * User restricted id access
     *
     * @var null
     */
    protected $_restrictedUserId = null;

    /**
     * @var array Access Control List
     */
    protected $_accessList = array(
        Tools_Security_Acl::ROLE_SUPERADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Tools_Security_Acl::ROLE_ADMIN => array(
            'allow' => array('get', 'post', 'put', 'delete')
        ),
        Shopping::ROLE_SALESPERSON => array(
            'allow' => array('get', 'post', 'put', 'delete')
        )
    );

    public function init()
    {
        parent::init();
        $this->_responseHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('response');
        $this->_restrictedUserId = Tools_LeadTools::getUserIdIfActionNotAllowed(Shopping::ROLE_SALESPERSON);
        $this->_loggedUserRoleId = Zend_Controller_Action_HelperBroker::getStaticHelper('session')->getCurrentUser()->getRoleId();

    }


    /**
     * Welcome screen
     *
     * Resource:
     * : /api/leadsopportunities/welcomescreen/
     *
     * HttpMethod:
     * : GET
     *
     * @return JSON
     */

    public function getAction()
    {
        $id = filter_var($this->_request->getParam('id'), FILTER_SANITIZE_NUMBER_INT);

        $where = null;
        if (!empty($id)) {

        }

        $leadOwners = Leads_Mapper_LeadsMapper::getInstance()->getLeadOwnersFullList(0, array(), true);

        $data = array();
        if (empty($ownersData)) {
            $data['data'] = array();
        } else {
            $data['data'] = $ownersData;
        }

        $loggedUserId = Zend_Controller_Action_HelperBroker::getStaticHelper('session')->getCurrentUser()->getId();

        unset($leadOwners[$loggedUserId]);

        $currency = Zend_Registry::get('Zend_Currency');
        $currencySymbol = preg_replace('~[\w]~', '', $currency->getSymbol());

        $leadsOpportunityTypeMapper = Leads_Mapper_LeadsOpportunityTypeMapper::getInstance();
        $opportunityTypes = $leadsOpportunityTypeMapper->getOpportunityTypes();
        $restrictedAccess = Tools_LeadWelcomeScreenTools::isRestrictedAccess();
        $data['currencyInfo'] = Tools_LeadWelcomeScreenTools::getCurrencyInfo();
        $fiscalYearStartMonth =  Models_Mapper_ShoppingConfig::getInstance()->getConfigParam('fiscalYearStart');

        $data['additionalInfo'] = array(
            'opportunityTypes' => $opportunityTypes,
            'currencySymbol' => $currencySymbol,
            'leadOwners' => $leadOwners,
            'restrictedAccess' => $restrictedAccess,
            'loggedUserId' =>  $loggedUserId,
            'userDate' =>  Tools_System_Tools::convertDateFromTimezone('now'),
            'fiscalYearStartMonth' => $fiscalYearStartMonth
        );

        return $data;
    }

    /**
     *
     * Resource:
     *
     * HttpMethod:
     * : POST
     *
     * @return JSON
     */
    public function postAction()
    {

    }

    /**
     *
     * Resource:
     *
     * HttpMethod:
     * : PUT
     *
     * ## Parameters:
     * id (source integer)
     *
     * @return JSON
     */
    public function putAction()
    {

    }

    /**
     *
     * Resource:
     *
     * HttpMethod:
     * : DELETE
     *
     * ## Parameters:
     * id (source integer)
     *
     * @return JSON
     */
    public function deleteAction()
    {


    }

}
