<?php

/**
 * Leads config dbTable
 *
 * Class Leads_DbTable_LeadsConfigDbTable
 */
class Leads_DbTable_LeadsConfigDbTable extends Zend_Db_Table_Abstract
{

    protected $_name = 'plugin_leads_config';

    /**
     * Update single param
     *
     * @param string $name
     * @param string $value
     * @return bool|mixed
     * @throws Zend_Db_Table_Exception
     */
    public function updateParam($name, $value)
    {
        if ($value === null) {
            return false;
        }
        $rowSet = $this->find($name);
        $row = $rowSet->current();
        if ($row === null) {
            $row = $this->createRow(array(
                'name' => $name,
                'value' => $value
            ));
        } else {
            $row->value = $value;
        }

        return $row->save();
    }

    /**
     * @return array
     */
    public function selectConfig()
    {
        return $this->getAdapter()->fetchPairs($this->select()->from($this->_name));
    }

}

