<?php

/**
 * LeadsApiRequestLogMapper.php
 *
 *
 * @method Leads_Mapper_LeadsApiRequestLogMapper   getInstance()   getInstance()   Returns an instance of itself
 * @method Zend_Db_Table    getDbTable()    getDbTable()    Returns an instance of DbTable
 */
class Leads_Mapper_LeadsApiRequestLogMapper extends Application_Model_Mappers_Abstract
{

    protected $_model = 'Leads_Model_LeadsApiRequestLogModel';

    protected $_dbTable = 'Leads_DbTable_LeadsApiRequestLogDbTable';

    /**
     * Save action log model
     * @param $model Leads_Model_LeadsApiRequestLogModel
     * @return Leads_Model_LeadsApiRequestLogModel
     */
    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            $model = new $this->_model($model);
        }

        $data = array(
            'token' => $model->getToken(),
            'request' => $model->getRequest(),
            'endpoint' => $model->getEndpoint(),
            'request_type' => $model->getRequestType(),
            'api_user_id' => $model->getApiUserId(),
            'created_at' => $model->getCreatedAt(),
            'ip_address' => $model->getIpAddress()
        );

        $id = $model->getId();
        if (!empty($id)) {
            $where = $this->getDbTable()->getAdapter()->quoteInto('id = ?', $id);
            $this->getDbTable()->update($data, $where);
        } else {
            $id = $this->getDbTable()->insert($data);
            $model->setId($id);
        }

        return $model;
    }



}
