<?php

/**
 * LeadsCleanUpFieldsLogMapper.php
 *
 *
 * @method Leads_Mapper_LeadsCleanUpFieldsLogMapper   getInstance()   getInstance()   Returns an instance of itself
 * @method Zend_Db_Table    getDbTable()    getDbTable()    Returns an instance of DbTable
 */
class Leads_Mapper_LeadsCleanUpFieldsLogMapper extends Application_Model_Mappers_Abstract
{

    protected $_model = 'Leads_Model_LeadsCleanUpFieldsLogModel';

    protected $_dbTable = 'Leads_DbTable_LeadsCleanUpFieldsLogDbTable';

    /**
     * Save action log model
     * @param $model Leads_Model_LeadsCleanUpFieldsLogModel
     * @return Leads_Model_LeadsCleanUpFieldsLogModel
     */
    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            $model = new $this->_model($model);
        }

        $data = array(
            'created_at'         => $model->getCreatedAt(),
            'logged_user_id'     => $model->getLoggedUserId(),
            'type'               => $model->getType(),
            'ip_address'         => $model->getIpAddress(),
            'deleted_items_info' => $model->getDeletedItemsInfo()
        );

        $id = $model->getId();
        if (!empty($id)) {
            $where = $this->getDbTable()->getAdapter()->quoteInto('id = ?', $id);
            $this->getDbTable()->update($data, $where);
        } else {
            $id = $this->getDbTable()->insert($data);
            $model->setId($id);
        }

        return $model;
    }


}
