<?php

/**
 * LeadsConfigMapper.php
 *
 *
 * @method Leads_Mapper_LeadsConfigMapper   getInstance()   getInstance()   Returns an instance of itself
 * @method Zend_Db_Table    getDbTable()    getDbTable()    Returns an instance of DbTable
 */
class Leads_Mapper_LeadsConfigMapper extends Application_Model_Mappers_Abstract
{

    protected $_dbTable = 'Leads_DbTable_LeadsConfigDbTable';

    protected $_model = 'Leads_Model_LeadsConfigModel';

    /**
     * @param array $config config params data
     * @throws Exceptions_SeotoasterPluginException
     */
    public function save($config)
    {
        if (!is_array($config) || empty ($config)) {
            throw new Exceptions_SeotoasterPluginException('Given parameter should be non empty array');
        }

        array_walk($config, function ($value, $key, $dbTable) {
            $dbTable->updateParam($key, $value);
        }, $this->getDbTable());


    }

    /**
     * @return mixed
     */
    public function getConfigParams()
    {
        return $this->getDbTable()->selectConfig();
    }

    /**
     * Get param by name
     *
     * @param string $name param name
     * @return null|string
     * @throws Zend_Db_Table_Exception
     */
    public function getConfigParam($name)
    {
        if (!$name) {
            return null;
        }

        $row = $this->getDbTable()->find($name);
        if ($row = $row->current()) {
            return $row->value;
        }

        return null;
    }


}

