<?php

class Leads_Mapper_LeadsCustomTabsHasCustomParamsMapper extends Application_Model_Mappers_Abstract
{

    protected $_dbTable = 'Leads_DbTable_LeadsCustomTabsHasCustomParamsDbTable';

    protected $_model = 'Leads_Model_LeadsCustomTabsHasCustomParamsModel';

    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            $model = new $this->_model($model);
        }

        $data = array(
            'tab_id'          => $model->getTabId(),
            'custom_param_id' => $model->getCustomParamId()
        );

        $sequenceModel = $this->getTabCustomParams($data['tab_id'], $data['custom_param_id']);
        if (!$sequenceModel instanceof Leads_Model_LeadsCustomTabsHasCustomParamsModel) {
            $this->getDbTable()->insert($data);
        }

        return $model;
    }

    public function getTabCustomParams($tabId, $customParamId)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('tab_id = ?', $tabId);
        $where .= ' AND ' . $this->getDbTable()->getAdapter()->quoteInto('custom_param_id = ?', $customParamId);

        return $this->_findWhere($where);
    }

    public function getSelectedCustomTabsParams($tabId, $tabType) {
        if(!empty($tabId)) {
            $select = $this->getDbTable()->select(Zend_Db_Table::SELECT_WITHOUT_FROM_PART)
                ->setIntegrityCheck(false)
                ->from(
                    array('ctc' => 'plugin_leads_custom_tabs_config'), array(
                        'customParamId' => 'lcpc.id',
                        'customParamLabel' => 'lcpc.param_name'
                    )
                )
                ->join(array('cthcp' => 'plugin_leads_custom_tabs_has_custom_params'), 'ctc.id = cthcp.tab_id', array(''));

            if($tabType == Api_Leads_Leadcustomtabsfields::CUSTOM_TAB_TYPE_LEAD) {
                $select->join(array('lcpc' => 'plugin_leads_lead_custom_params_config'), 'cthcp.custom_param_id = lcpc.id', array(''));
            } elseif ($tabType == Api_Leads_Leadcustomtabsfields::CUSTOM_TAB_TYPE_ORGANIZATION) {
                $select->join(array('lcpc' => 'plugin_leads_organization_custom_params_config'), 'cthcp.custom_param_id = lcpc.id', array(''));
            }

            $where = $this->getDbTable()->getAdapter()->quoteInto('ctc.id = ?', $tabId);
            $select->where($where);

            return $this->getDbTable()->getAdapter()->fetchPairs($select);
        }

        return array();
    }

    public function delete($id, $customParamId)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('tab_id = ?', $id);
        $where .= ' AND ' . $this->getDbTable()->getAdapter()->quoteInto('custom_param_id = ?', $customParamId);

        return $this->getDbTable()->getAdapter()->delete('plugin_leads_custom_tabs_has_custom_params', $where);
    }
}

