<?php

/**
 * LeadsHashedAddressCoordinatesMapper.php
 *
 *
 * @method Leads_Mapper_LeadsHashedAddressCoordinatesMapper   getInstance()   getInstance()   Returns an instance of itself
 * @method Zend_Db_Table    getDbTable()    getDbTable()    Returns an instance of DbTable
 */
class Leads_Mapper_LeadsHashedAddressCoordinatesMapper extends Application_Model_Mappers_Abstract
{

    protected $_model = 'Leads_Model_LeadsHashedAddressCoordinatesModel';

    protected $_dbTable = 'Leads_DbTable_LeadsHashedAddressCoordinatesDbTable';

    /**
     * Save email log model to DB
     * @param $model Leads_Model_LeadsEmailLogModel
     * @return Leads_Model_LeadsEmailLogModel
     */
    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            $model = new $this->_model($model);
        }

        $data = array(
            'address_hash' => $model->getAddressHash(),
            'lat' => $model->getLat(),
            'lng' => $model->getLng()
        );

        $recordExists =  $this->findByHash($data['address_hash']);
        if ($recordExists instanceof Leads_Model_LeadsHashedAddressCoordinatesModel) {
            $where = $this->getDbTable()->getAdapter()->quoteInto('address_hash = ?', $data['address_hash']);
            $this->getDbTable()->update($data, $where);
        } else {
            $id = $this->getDbTable()->insert($data);
            $model->setId($id);
        }

        return $model;
    }

    /**
     * Find by address hash
     *
     * @param int $addressHash address hash
     * @return null
     */
    public function findByHash($addressHash)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('address_hash = ?', $addressHash);
        return $this->_findWhere($where);
    }

}
