<?php

class Leads_Mapper_LeadsHiddenOpportunitiesMapper extends Application_Model_Mappers_Abstract
{

    protected $_model = 'Leads_Model_LeadsHiddenOpportunitiesModel';

    protected $_dbTable = 'Leads_DbTable_LeadsHiddenOpportunitiesDbTable';

    /**
     * Save lead opportunity model to DB
     * @param $model Leads_Model_LeadsOpportunityModel
     * @return Leads_Model_LeadsOpportunityModel
     */
    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            $model = new $this->_model($model);
        }

        $data = array(
            'opportunity_id' => $model->getOpportunityId()
        );

        $id = $model->getId();
        if (!empty($id)) {
            $where = $this->getDbTable()->getAdapter()->quoteInto('id = ?', $id);
            $this->getDbTable()->update($data, $where);
        } else {
            $id = $this->getDbTable()->insert($data);
            $model->setId($id);
        }

        return $model;
    }

    /**
     * @param null $where
     * @param array $order
     * @return array|null
     * @throws Exception
     */
    public function fetchAll($where = null, $order = array())
    {
        $select = $this->getDbTable()->getAdapter()->select()
            ->from(array('plho' => 'plugin_leads_hidden_opportunities'),
                array(
                    'plho.opportunity_id'
                )
            );

        if(!empty($where)) {
            $select->where($where);
        }
        return $this->getDbTable()->getAdapter()->fetchAll($select);
    }

}
