<?php

class Leads_Mapper_LeadsTemplatesAndDirectoriesConfigMapper extends Application_Model_Mappers_Abstract
{

    protected $_model = 'Leads_Model_LeadsTemplatesAndDirectoriesConfigModel';

    protected $_dbTable = 'Leads_DbTable_LeadsTemplatesAndDirectoriesConfigDbtable';

    public function save($model)
    {
        if (!$model instanceof $this->_model) {
            $model = new $this->_model($model);
        }

        $data = array(
            'type' => $model->getType(),
            'item_name' => $model->getItemName()
        );

        $id = $model->getId();
        if (!empty($id)) {
            $where = $this->getDbTable()->getAdapter()->quoteInto('id = ?', $id);
            $this->getDbTable()->update($data, $where);
        } else {
            $id = $this->getDbTable()->insert($data);
            $model->setId($id);
        }

        return $model;
    }

    /**
     * @param $type
     * @param $itemName
     * @return null
     */
    public function findRow($type, $itemName)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('type = ?', $type);
        $where .= ' AND ' . $this->getDbTable()->getAdapter()->quoteInto('item_name = ?', $itemName);
        return $this->_findWhere($where);
    }

    /**
     * @param $type
     * @return mixed
     */
    public function findByType($type)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('type = ?', $type);
        $select = $this->getDbTable()->select()->from('plugin_leads_templates_and_directories_config', array(
            'id',
            'item_name'
        ))->where($where);

        $result = $this->getDbTable()->getAdapter()->fetchPairs($select);
        return $result;

    }

    /***
     * @param $id
     * @return null
     */
    public function find($id)
    {
        return parent::find($id);
    }

    /**
     * @param $id
     * @return mixed
     */
    public function delete($id)
    {
        $where = $this->getDbTable()->getAdapter()->quoteInto('id = ?', $id);

        return $this->getDbTable()->getAdapter()->delete('plugin_leads_templates_and_directories_config', $where);
    }

}
