<?php

class Leads_Model_LeadsActionLogModel extends Application_Model_Models_Abstract
{
    /**
     * Action types
     */
    const ACTION_TYPE_INBOUND = 'inbound';

    const ACTION_TYPE_OUTBOUND = 'outbound';

    /**
     * Log action types
     */
    const ACTION_FORM = 'form';

    const ACTION_QUOTE = 'quote';

    const ACTION_CALL = 'call';

    const ACTION_SMS = 'sms';

    const ACTION_TASK = 'task';

    const ACTION_TASK_COMPLETED = 'task_completed';

    const ACTION_MEETING = 'meeting';

    const ACTION_EMAIL = 'email';

    const ACTION_PURCHASE = 'purchase';

    const ACTION_REGISTRATION = 'registration';

    const ACTION_DOWNLOAD = 'download';

    const ACTION_VISIT = 'visit';

    const ACTION_QUOTE_VIEW = 'quote_view';

    const ACTION_QUOTE_DELETED = 'quote_deleted';

    const ACTION_EXTERNAL = 'external';

    const ACTION_QUIZZ = 'quizz';

    const ACTION_CHAT = 'chat';

    /**
     * Event log types
     */
    const EVENT_LOG_EXPIRED = 'expired';

    const EVENT_LOG_UPCOMING = 'upcoming';


    /**
     * Allowed log actions types
     *
     * @var array
     */
    public static $_allowedActions = array(
        self::ACTION_FORM,
        self::ACTION_SMS,
        self::ACTION_QUOTE,
        self::ACTION_CALL,
        self::ACTION_TASK,
        self::ACTION_MEETING,
        self::ACTION_EMAIL,
        self::ACTION_PURCHASE,
        self::ACTION_REGISTRATION,
        self::ACTION_DOWNLOAD,
        self::ACTION_VISIT,
        self::ACTION_EXTERNAL,
        self::ACTION_CHAT
    );

    protected $_type = '';

    protected $_leadId = '';

    protected $_createdAt = '';

    protected $_actionType = '';

    protected $_additionalContent = '';

    protected $_eventType = self::EVENT_LOG_EXPIRED;

    protected $_leadType = '';

    /**
     * @return string
     */
    public function getType()
    {
        return $this->_type;
    }

    /**
     * @param string $type
     * @return string
     */
    public function setType($type)
    {
        $this->_type = $type;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadId()
    {
        return $this->_leadId;
    }

    /**
     * @param string $leadId
     * @return string
     */
    public function setLeadId($leadId)
    {
        $this->_leadId = $leadId;

        return $this;
    }

    /**
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->_createdAt;
    }

    /**
     * @param string $createdAt
     * @return string
     */
    public function setCreatedAt($createdAt)
    {
        $this->_createdAt = $createdAt;

        return $this;
    }

    /**
     * @return string
     */
    public function getActionType()
    {
        return $this->_actionType;
    }

    /**
     * @param string $actionType
     * @return string
     */
    public function setActionType($actionType)
    {
        $this->_actionType = $actionType;

        return $this;
    }

    /**
     * @return string
     */
    public function getAdditionalContent()
    {
        return $this->_additionalContent;
    }

    /**
     * @param string $additionalContent
     * @return string
     */
    public function setAdditionalContent($additionalContent)
    {
        $this->_additionalContent = $additionalContent;

        return $this;
    }

    /**
     * @return null
     */
    public function getEventType()
    {
        return $this->_eventType;
    }

    /**
     * @param null $eventType
     * @return null
     */
    public function setEventType($eventType)
    {
        $this->_eventType = $eventType;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadType()
    {
        return $this->_leadType;
    }

    /**
     * @param string $leadType
     * @return string
     */
    public function setLeadType($leadType)
    {
        $this->_leadType = $leadType;

        return $this;
    }


}