<?php

class Leads_Model_LeadsCallLogModel extends Application_Model_Models_Abstract
{

    const TYPE_CALL = 'call';

    const TYPE_SMS = 'sms';

    /**
     * Call lead device type mobile
     */
    const LEAD_CALL_DEVICE_TYPE_MOBILE = 'mobile';

    /**
     * Call lead device type desktop
     */
    const LEAD_CALL_DEVICE_TYPE_DESKTOP = 'desktop';

    /**
     * Call lead device voip phone
     */
    const LEAD_CALL_DEVICE_TYPE_VOIP_PHONE = 'voip-phone';


    const LEAD_CALL_SMS_SUBTYPE_SMS_WIDGET = 'smsWidget';


    protected $_callSid = '';

    protected $_creatorId = '';

    protected $_type = '';

    protected $_accountSid = '';

    protected $_caller = '';

    protected $_timestamp = null;

    protected $_status = '';

    protected $_score = '';

    protected $_link = '';

    protected $_actionLogId = '';

    protected $_callDuration = '';

    protected $_leadId = null;

    protected $_details = '';

    protected $_callSource = '';

    protected $_receiver = '';

    protected $_isVoip = '0';

    protected $_subType = null;

    /**
     * @return string
     */
    public function getCallSid()
    {
        return $this->_callSid;
    }

    /**
     * @param string $callSid
     * @return string
     */
    public function setCallSid($callSid)
    {
        $this->_callSid = $callSid;

        return $this;
    }

    /**
     * @return string
     */
    public function getCreatorId()
    {
        return $this->_creatorId;
    }

    /**
     * @param string $creatorId
     * @return string
     */
    public function setCreatorId($creatorId)
    {
        $this->_creatorId = $creatorId;

        return $this;
    }

    /**
     * @return string
     */
    public function getType()
    {
        return $this->_type;
    }

    /**
     * @param string $type
     * @return string
     */
    public function setType($type)
    {
        $this->_type = $type;

        return $this;
    }

    /**
     * @return string
     */
    public function getAccountSid()
    {
        return $this->_accountSid;
    }

    /**
     * @param string $accountSid
     * @return string
     */
    public function setAccountSid($accountSid)
    {
        $this->_accountSid = $accountSid;

        return $this;
    }

    /**
     * @return string
     */
    public function getCaller()
    {
        return $this->_caller;
    }

    /**
     * @param string $caller
     * @return string
     */
    public function setCaller($caller)
    {
        $this->_caller = $caller;

        return $this;
    }

    /**
     * @return null
     */
    public function getTimestamp()
    {
        return $this->_timestamp;
    }

    /**
     * @param null $timestamp
     * @return null
     */
    public function setTimestamp($timestamp)
    {
        $this->_timestamp = $timestamp;

        return $this;
    }

    /**
     * @return string
     */
    public function getStatus()
    {
        return $this->_status;
    }

    /**
     * @param string $status
     * @return string
     */
    public function setStatus($status)
    {
        $this->_status = $status;

        return $this;
    }

    /**
     * @return string
     */
    public function getScore()
    {
        return $this->_score;
    }

    /**
     * @param string $score
     * @return string
     */
    public function setScore($score)
    {
        $this->_score = $score;

        return $this;
    }

    /**
     * @return string
     */
    public function getLink()
    {
        return $this->_link;
    }

    /**
     * @param string $link
     * @return string
     */
    public function setLink($link)
    {
        $this->_link = $link;

        return $this;
    }

    /**
     * @return string
     */
    public function getActionLogId()
    {
        return $this->_actionLogId;
    }

    /**
     * @param string $actionLogId
     * @return string
     */
    public function setActionLogId($actionLogId)
    {
        $this->_actionLogId = $actionLogId;

        return $this;
    }

    /**
     * @return string
     */
    public function getCallDuration()
    {
        return $this->_callDuration;
    }

    /**
     * @param string $callDuration
     * @return string
     */
    public function setCallDuration($callDuration)
    {
        $this->_callDuration = $callDuration;

        return $this;
    }

    /**
     * @return null
     */
    public function getLeadId()
    {
        return $this->_leadId;
    }

    /**
     * @param null $leadId
     * @return null
     */
    public function setLeadId($leadId)
    {
        $this->_leadId = $leadId;

        return $this;
    }

    /**
     * @return string
     */
    public function getDetails()
    {
        return $this->_details;
    }

    /**
     * @param string $details
     * @return string
     */
    public function setDetails($details)
    {
        $this->_details = $details;

        return $this;
    }

    /**
     * @return string
     */
    public function getCallSource()
    {
        return $this->_callSource;
    }

    /**
     * @param string $callSource
     * @return string
     */
    public function setCallSource($callSource)
    {
        $this->_callSource = $callSource;

        return $this;
    }

    /**
     * @return string
     */
    public function getReceiver()
    {
        return $this->_receiver;
    }

    /**
     * @param string $receiver
     * @return string
     */
    public function setReceiver($receiver)
    {
        $this->_receiver = $receiver;

        return $this;
    }

    /**
     * @return string
     */
    public function getIsVoip()
    {
        return $this->_isVoip;
    }

    /**
     * @param string $isVoip
     * @return string
     */
    public function setIsVoip($isVoip)
    {
        $this->_isVoip = $isVoip;

        return $this;
    }

    /**
     * @return null
     */
    public function getSubType()
    {
        return $this->_subType;
    }

    /**
     * @param null $subType
     * @return null
     */
    public function setSubType($subType)
    {
        $this->_subType = $subType;

        return $this;
    }

}