<?php

class Leads_Model_LeadsEmailLogModel extends Application_Model_Models_Abstract
{

    const EMAIL_STATUS_SENT = 'sent';

    const EMAIL_STATUS_OPENED = 'opened';

    const EMAIL_STATUS_OPENED_ATTACHMENT = 'openattachment';

    const EMAIL_STATUS_CLICK = 'click';

    const EMAIL_STATUS_BOUNCE = 'bounce';

    const EMAIL_STATUS_DEFERRED = 'deferred';

    const EMAIL_STATUS_DROPPED = 'dropped';

    const EMAIL_STATUS_RECEIVED = 'received';

    const EMAIL_STATUS_UNSUBSCRIBED = 'unsubscribed';

    const EMAIL_SOURCE_TYPE_INTERNAL = 'internal';

    const EMAIL_SOURCE_TYPE_EXTERNAL = 'external';

    protected $_emailSubject = '';

    protected $_content = '';

    protected $_emailFrom = '';

    protected $_emailFromName = '';

    protected $_emailTo = '';

    protected $_emailTemplate = '';

    protected $_followUpSequencesId = null;

    protected $_actionLogId = '';

    protected $_leadId = null;

    protected $_emailStatus = self::EMAIL_STATUS_SENT;

    protected $_trackingCode = '';

    protected $_emailBcc = '';

    protected $_attachmentId = null;

    protected $_emailSourceType = self::EMAIL_SOURCE_TYPE_INTERNAL;

    protected $_campaignName = null;

    protected $_listNames = null;

    protected $_externalServiceName = null;

    protected $_creatorId = null;

    protected $_messageId = null;

    protected $_replyId = null;

    protected $_references = null;

    protected $_uid = null;

    protected $_messageNumber = null;

    protected $_accountId = '';

    protected $_receivedAt = '';

    protected $_encodedContent = '';

    /**
     * @return string
     */
    public function getEmailSubject()
    {
        return $this->_emailSubject;
    }

    /**
     * @param string $emailSubject
     * @return string
     */
    public function setEmailSubject($emailSubject)
    {
        $this->_emailSubject = $emailSubject;

        return $this;
    }

    /**
     * @return string
     */
    public function getContent()
    {
        return $this->_content;
    }

    /**
     * @param string $content
     * @return string
     */
    public function setContent($content)
    {
        $this->_content = $content;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailFrom()
    {
        return $this->_emailFrom;
    }

    /**
     * @param string $emailFrom
     * @return string
     */
    public function setEmailFrom($emailFrom)
    {
        $this->_emailFrom = $emailFrom;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailFromName()
    {
        return $this->_emailFromName;
    }

    /**
     * @param string $emailFromName
     * @return string
     */
    public function setEmailFromName($emailFromName)
    {
        $this->_emailFromName = $emailFromName;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailTo()
    {
        return $this->_emailTo;
    }

    /**
     * @param string $emailTo
     * @return string
     */
    public function setEmailTo($emailTo)
    {
        $this->_emailTo = $emailTo;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailTemplate()
    {
        return $this->_emailTemplate;
    }

    /**
     * @param string $emailTemplate
     * @return string
     */
    public function setEmailTemplate($emailTemplate)
    {
        $this->_emailTemplate = $emailTemplate;

        return $this;
    }

    /**
     * @return string
     */
    public function getFollowUpSequencesId()
    {
        return $this->_followUpSequencesId;
    }

    /**
     * @param string $followUpSequencesId
     * @return string
     */
    public function setFollowUpSequencesId($followUpSequencesId)
    {
        $this->_followUpSequencesId = $followUpSequencesId;

        return $this;
    }

    /**
     * @return string
     */
    public function getActionLogId()
    {
        return $this->_actionLogId;
    }

    /**
     * @param string $actionLogId
     * @return string
     */
    public function setActionLogId($actionLogId)
    {
        $this->_actionLogId = $actionLogId;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadId()
    {
        return $this->_leadId;
    }

    /**
     * @param string $leadId
     * @return string
     */
    public function setLeadId($leadId)
    {
        $this->_leadId = $leadId;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailStatus()
    {
        return $this->_emailStatus;
    }

    /**
     * @param string $emailStatus
     * @return string
     */
    public function setEmailStatus($emailStatus)
    {
        $this->_emailStatus = $emailStatus;

        return $this;
    }

    /**
     * @return string
     */
    public function getTrackingCode()
    {
        return $this->_trackingCode;
    }

    /**
     * @param string $trackingCode
     * @return string
     */
    public function setTrackingCode($trackingCode)
    {
        $this->_trackingCode = $trackingCode;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailBcc()
    {
        return $this->_emailBcc;
    }

    /**
     * @param string $emailBcc
     * @return string
     */
    public function setEmailBcc($emailBcc)
    {
        $this->_emailBcc = $emailBcc;

        return $this;
    }

    /**
     * @return string
     */
    public function getAttachmentId()
    {
        return $this->_attachmentId;
    }

    /**
     * @param string $attachmentId
     * @return string
     */
    public function setAttachmentId($attachmentId)
    {
        $this->_attachmentId = $attachmentId;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailSourceType()
    {
        return $this->_emailSourceType;
    }

    /**
     * @param string $emailSourceType
     * @return string
     */
    public function setEmailSourceType($emailSourceType)
    {
        $this->_emailSourceType = $emailSourceType;

        return $this;
    }

    /**
     * @return null
     */
    public function getCampaignName()
    {
        return $this->_campaignName;
    }

    /**
     * @param null $campaignName
     * @return null
     */
    public function setCampaignName($campaignName)
    {
        $this->_campaignName = $campaignName;

        return $this;
    }

    /**
     * @return null
     */
    public function getListNames()
    {
        return $this->_listNames;
    }

    /**
     * @param null $listNames
     * @return null
     */
    public function setListNames($listNames)
    {
        $this->_listNames = $listNames;

        return $this;
    }


    /**
     * @return null
     */
    public function getExternalServiceName()
    {
        return $this->_externalServiceName;
    }

    /**
     * @param null $externalServiceName
     * @return null
     */
    public function setExternalServiceName($externalServiceName)
    {
        $this->_externalServiceName = $externalServiceName;

        return $this;
    }

    /**
     * @return null
     */
    public function getMessageId()
    {
        return $this->_messageId;
    }

    /**
     * @param null $messageId
     * @return null
     */
    public function setMessageId($messageId)
    {
        $this->_messageId = $messageId;

        return $this;
    }

    /**
     * @return null
     */
    public function getReplyId()
    {
        return $this->_replyId;
    }

    /**
     * @param null $replyId
     * @return null
     */
    public function setReplyId($replyId)
    {
        $this->_replyId = $replyId;

        return $this;
    }

    /**
     * @return null
     */
    public function getReferences()
    {
        return $this->_references;
    }

    /**
     * @param null $references
     * @return null
     */
    public function setReferences($references)
    {
        $this->_references = $references;

        return $this;
    }

    /**
     * @return null
     */
    public function getUid()
    {
        return $this->_uid;
    }

    /**
     * @param null $uid
     * @return null
     */
    public function setUid($uid)
    {
        $this->_uid = $uid;

        return $this;
    }

    /**
     * @return null
     */
    public function getMessageNumber()
    {
        return $this->_messageNumber;
    }

    /**
     * @param null $messageNumber
     * @return null
     */
    public function setMessageNumber($messageNumber)
    {
        $this->_messageNumber = $messageNumber;

        return $this;
    }

    public function getCreatorId()
    {
        return $this->_creatorId;
    }

    /**
     * @param null $creatorId
     */
    public function setCreatorId($creatorId)
    {
        $this->_creatorId = $creatorId;
    }

    /**
     * @return string
     */
    public function getAccountId()
    {
        return $this->_accountId;
    }

    /**
     * @param string $accountId
     * @return string
     */
    public function setAccountId($accountId)
    {
        $this->_accountId = $accountId;

        return $this;
    }

    /**
     * @return string
     */
    public function getReceivedAt()
    {
        return $this->_receivedAt;
    }

    /**
     * @param string $receivedAt
     * @return string
     */
    public function setReceivedAt($receivedAt)
    {
        $this->_receivedAt = $receivedAt;

        return $this;
    }

    /**
     * @return string
     */
    public function getEncodedContent()
    {
        return $this->_encodedContent;
    }

    /**
     * @param string $encodedContent
     * @return string
     */
    public function setEncodedContent($encodedContent)
    {
        $this->_encodedContent = $encodedContent;

        return $this;
    }


}