<?php

class Leads_Model_LeadsEventRulesActionModel extends Application_Model_Models_Abstract
{

    const ACTION_TYPE_ASSIGN_OWNER = 'assign_owner';

    const ACTION_TYPE_ASSIGN_TASK = 'assign_task';

    const ACTION_TYPE_ASSIGN_TAGS = 'assign_tags';

    const ACTION_TYPE_ASSIGN_LIFECYCLE = 'assign_lifecycle';

    const ACTION_TYPE_ASSIGN_SEQUENCE = 'assign_sequence';

    const ACTION_TYPE_ASSIGN_EMAIL_LIST = 'assign_email_list';

    const ACTION_TYPE_ASSIGN_EMAIL_COPY = 'assign_email_copy';

    /**
     * Allowed action types
     *
     * @var array
     */
    public static $_allowedActionTypes = array(
        self::ACTION_TYPE_ASSIGN_OWNER,
        self::ACTION_TYPE_ASSIGN_TASK,
        self::ACTION_TYPE_ASSIGN_LIFECYCLE,
        self::ACTION_TYPE_ASSIGN_TAGS,
        self::ACTION_TYPE_ASSIGN_SEQUENCE,
        self::ACTION_TYPE_ASSIGN_EMAIL_LIST,
        self::ACTION_TYPE_ASSIGN_EMAIL_COPY
    );

    protected $_ruleId = '';

    protected $_actionType = '';

    /**
     * Serialized action config data
     *
     * @var string
     */
    protected $_actionConfig = '';

    /**
     * @return string
     */
    public function getRuleId()
    {
        return $this->_ruleId;
    }

    /**
     * @param string $ruleId
     * @return string
     */
    public function setRuleId($ruleId)
    {
        $this->_ruleId = $ruleId;

        return $this;
    }

    /**
     * @return string
     */
    public function getActionType()
    {
        return $this->_actionType;
    }

    /**
     * @param string $actionType
     * @return string
     */
    public function setActionType($actionType)
    {
        $this->_actionType = $actionType;

        return $this;
    }

    /**
     * @return string
     */
    public function getActionConfig()
    {
        return $this->_actionConfig;
    }

    /**
     * @param string $actionConfig
     * @return string
     */
    public function setActionConfig($actionConfig)
    {
        $this->_actionConfig = $actionConfig;

        return $this;
    }


}