<?php

class Leads_Model_LeadsMeetingModel extends Application_Model_Models_Abstract
{

    const LEAD_MEETING_PROCESS_PATH = 'plugins/leads/system/cronscript/processMeetingNotifications.php';

    const LEAD_MEETING_TYPE_AUTO = 'auto';

    const LEAD_MEETING_TYPE_MANUAL = 'manual';

    protected $_leadId = '';

    protected $_startTimeDate = '';

    protected $_endTimeDate = '';

    protected $_location = '';

    protected $_inviteAttendees = '';

    protected $_period = '';

    protected $_subject = '';

    protected $_details = '';

    protected $_googleCalendar = '';

    protected $_creatorId = '';

    protected $_firstNotificationDate = '';

    protected $_firstNotificationIsSent = '0';

    protected $_firstNotificationSentDate = '';

    protected $_secondNotificationDate = '';

    protected $_secondNotificationIsSent = '0';

    protected $_secondNotificationSentDate = '';

    protected $_sendNotificationSms = '0';

    protected $_sendSms = '0';

    protected $_meetingType = 'auto';

    /**
     * @return string
     */
    public function getLeadId()
    {
        return $this->_leadId;
    }

    /**
     * @param string $leadId
     * @return string
     */
    public function setLeadId($leadId)
    {
        $this->_leadId = $leadId;

        return $this;
    }

    /**
     * @return string
     */
    public function getStartTimeDate()
    {
        return $this->_startTimeDate;
    }

    /**
     * @param string $startTimeDate
     * @return string
     */
    public function setStartTimeDate($startTimeDate)
    {
        $this->_startTimeDate = $startTimeDate;

        return $this;
    }

    /**
     * @return string
     */
    public function getEndTimeDate()
    {
        return $this->_endTimeDate;
    }

    /**
     * @param string $endTimeDate
     * @return string
     */
    public function setEndTimeDate($endTimeDate)
    {
        $this->_endTimeDate = $endTimeDate;

        return $this;
    }

    /**
     * @return string
     */
    public function getLocation()
    {
        return $this->_location;
    }

    /**
     * @param string $location
     * @return string
     */
    public function setLocation($location)
    {
        $this->_location = $location;

        return $this;
    }

    /**
     * @return string
     */
    public function getInviteAttendees()
    {
        return $this->_inviteAttendees;
    }

    /**
     * @param string $inviteAttendees
     * @return string
     */
    public function setInviteAttendees($inviteAttendees)
    {
        $this->_inviteAttendees = $inviteAttendees;

        return $this;
    }

    /**
     * @return string
     */
    public function getPeriod()
    {
        return $this->_period;
    }

    /**
     * @param string $period
     * @return string
     */
    public function setPeriod($period)
    {
        $this->_period = $period;

        return $this;
    }

    /**
     * @return string
     */
    public function getSubject()
    {
        return $this->_subject;
    }

    /**
     * @param string $subject
     * @return string
     */
    public function setSubject($subject)
    {
        $this->_subject = $subject;

        return $this;
    }

    /**
     * @return string
     */
    public function getDetails()
    {
        return $this->_details;
    }

    /**
     * @param string $details
     * @return string
     */
    public function setDetails($details)
    {
        $this->_details = $details;

        return $this;
    }

    /**
     * @return string
     */
    public function getGoogleCalendar()
    {
        return $this->_googleCalendar;
    }

    /**
     * @param string $googleCalendar
     * @return string
     */
    public function setGoogleCalendar($googleCalendar)
    {
        $this->_googleCalendar = $googleCalendar;

        return $this;
    }

    /**
     * @return string
     */
    public function getCreatorId()
    {
        return $this->_creatorId;
    }

    /**
     * @param string $creatorId
     * @return string
     */
    public function setCreatorId($creatorId)
    {
        $this->_creatorId = $creatorId;

        return $this;
    }

    /**
     * @return string
     */
    public function getFirstNotificationDate()
    {
        return $this->_firstNotificationDate;
    }

    /**
     * @param string $firstNotificationDate
     * @return string
     */
    public function setFirstNotificationDate($firstNotificationDate)
    {
        $this->_firstNotificationDate = $firstNotificationDate;

        return $this;
    }

    /**
     * @return string
     */
    public function getFirstNotificationIsSent()
    {
        return $this->_firstNotificationIsSent;
    }

    /**
     * @param string $firstNotificationIsSent
     * @return string
     */
    public function setFirstNotificationIsSent($firstNotificationIsSent)
    {
        $this->_firstNotificationIsSent = $firstNotificationIsSent;

        return $this;
    }

    /**
     * @return string
     */
    public function getFirstNotificationSentDate()
    {
        return $this->_firstNotificationSentDate;
    }

    /**
     * @param string $firstNotificationSentDate
     * @return string
     */
    public function setFirstNotificationSentDate($firstNotificationSentDate)
    {
        $this->_firstNotificationSentDate = $firstNotificationSentDate;

        return $this;
    }

    /**
     * @return string
     */
    public function getSecondNotificationDate()
    {
        return $this->_secondNotificationDate;
    }

    /**
     * @param string $secondNotificationDate
     * @return string
     */
    public function setSecondNotificationDate($secondNotificationDate)
    {
        $this->_secondNotificationDate = $secondNotificationDate;

        return $this;
    }

    /**
     * @return string
     */
    public function getSecondNotificationIsSent()
    {
        return $this->_secondNotificationIsSent;
    }

    /**
     * @param string $secondNotificationIsSent
     * @return string
     */
    public function setSecondNotificationIsSent($secondNotificationIsSent)
    {
        $this->_secondNotificationIsSent = $secondNotificationIsSent;

        return $this;
    }

    /**
     * @return string
     */
    public function getSecondNotificationSentDate()
    {
        return $this->_secondNotificationSentDate;
    }

    /**
     * @param string $secondNotificationSentDate
     * @return string
     */
    public function setSecondNotificationSentDate($secondNotificationSentDate)
    {
        $this->_secondNotificationSentDate = $secondNotificationSentDate;

        return $this;
    }

    /**
     * @return string
     */
    public function getSendNotificationSms()
    {
        return $this->_sendNotificationSms;
    }

    /**
     * @param string $sendNotificationSms
     * @return string
     */
    public function setSendNotificationSms($sendNotificationSms)
    {
        $this->_sendNotificationSms = $sendNotificationSms;

        return $this;
    }

    /**
     * @return string
     */
    public function getSendSms()
    {
        return $this->_sendSms;
    }

    /**
     * @param string $sendSms
     * @return string
     */
    public function setSendSms($sendSms)
    {
        $this->_sendSms = $sendSms;

        return $this;
    }

    /**
     * @return string
     */
    public function getMeetingType()
    {
        return $this->_meetingType;
    }

    /**
     * @param string $meetingType
     * @return string
     */
    public function setMeetingType($meetingType)
    {
        $this->_meetingType = $meetingType;

        return $this;
    }



}