<?php

class Leads_Model_LeadsModel extends Application_Model_Models_Abstract
{

    const CREATION_TYPE_LOCAL = 'local';

    const CREATION_TYPE_USER = 'user';

    const CREATION_TYPE_IMPORT = 'import';

    const CREATION_TYPE_API = 'api';

    const EMAIL_VALIDATED_STATUS_NOT_VERIFIED = 'not_verified';

    const EMAIL_VALIDATED_STATUS_VALID = 'valid';

    const EMAIL_VALIDATED_STATUS_INVALID = 'invalid';

    const EMAIL_VALIDATED_STATUS_RISKY = 'risky';

    protected $_leadFirstName = '';

    protected $_leadLastName = '';

    protected $_leadEmail = null;

    protected $_leadPhone = null;

    protected $_leadSource = '';

    protected $_leadNotes = '';

    protected $_userId = null;

    protected $_stageId = null;

    protected $_customerGroupId = null;

    protected $_organizationId = null;

    protected $_createdAt = '';

    protected $_updatedAt = '';

    protected $_productIds = '';

    protected $_leadZip = '';

    protected $_leadAddress = '';

    protected $_leadAddress1 = '';

    protected $_ownerId = '';

    protected $_lastActivity = '';

    protected $_leadTypeId = null;

    protected $_leadMobile = null;

    protected $_leadPosition = '';

    protected $_leadCountryCode = null;

    protected $_leadStateCode = null;

    protected $_middleName = '';

    protected $_prefix = '';

    protected $_leadPhoneCountryCode = '';

    protected $_leadPhoneCountryCodeValue = null;

    protected $_leadMobileCountryCode = '';

    protected $_leadMobileCountryCodeValue = null;

    protected $_leadPhoneExtension = '';

    protected $_leadTags = array();

    protected $_leadCity = '';

    protected $_externalId = '';

    protected $_creationType = self::CREATION_TYPE_LOCAL;

    protected $_lastActivityTypeId = null;

    protected $_useOrganizationAddress = '0';

    protected $_lastActivitySubtype = '';

    protected $_lastActivityOutbound = '';

    protected $_score = '';

    protected $_score_processed_at = '';

    protected $_remoteAuthorizationToken = '';

    protected $_leadSecondaryEmail = '';

    protected $_emailValidatedStatus = self::EMAIL_VALIDATED_STATUS_NOT_VERIFIED;

    protected $_emailValidatedDate = '';

    protected $_emailValidatedScore = '';

    protected $_additionalInfo = '';

    protected $_addressHash = '';

    protected $_lat = '';

    protected $_lng = '';

    protected $_lastCoordinatesProcessedDate = '';

    protected $_skipCoordinatesGeneration = false;

    public static $emailValidateStatuses = array(
        self::EMAIL_VALIDATED_STATUS_NOT_VERIFIED,
        self::EMAIL_VALIDATED_STATUS_VALID,
        self::EMAIL_VALIDATED_STATUS_INVALID,
        self::EMAIL_VALIDATED_STATUS_RISKY
    );

    /**
     * @return string
     */
    public function getLeadFirstName()
    {
        return $this->_leadFirstName;
    }

    /**
     * @param string $leadFirstName
     * @return string
     */
    public function setLeadFirstName($leadFirstName)
    {
        if(!empty($leadFirstName)) {
            $leadFirstName = ucfirst($leadFirstName);
        }
        $this->_leadFirstName = $leadFirstName;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadLastName()
    {
        return $this->_leadLastName;
    }

    /**
     * @param string $leadLastName
     * @return string
     */
    public function setLeadLastName($leadLastName)
    {
        if(!empty($leadLastName)) {
            $leadLastName = ucfirst($leadLastName);
        }
        $this->_leadLastName = $leadLastName;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadEmail()
    {
        return $this->_leadEmail;
    }

    /**
     * @param string $leadEmail
     * @return string
     */
    public function setLeadEmail($leadEmail)
    {
        $this->_leadEmail = $leadEmail;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadPhone()
    {
        return $this->_leadPhone;
    }

    /**
     * @param string $leadPhone
     * @return string
     */
    public function setLeadPhone($leadPhone)
    {
        $this->_leadPhone = $leadPhone;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadSource()
    {
        return $this->_leadSource;
    }

    /**
     * @param string $leadSource
     * @return string
     */
    public function setLeadSource($leadSource)
    {
        $this->_leadSource = $leadSource;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadNotes()
    {
        return $this->_leadNotes;
    }

    /**
     * @param string $leadNotes
     * @return string
     */
    public function setLeadNotes($leadNotes)
    {
        $this->_leadNotes = $leadNotes;

        return $this;
    }

    /**
     * @return string
     */
    public function getUserId()
    {
        return $this->_userId;
    }

    /**
     * @param string $userId
     * @return string
     */
    public function setUserId($userId)
    {
        $this->_userId = $userId;

        return $this;
    }

    /**
     * @return string
     */
    public function getStageId()
    {
        return $this->_stageId;
    }

    /**
     * @param string $stageId
     * @return string
     */
    public function setStageId($stageId)
    {
        $this->_stageId = $stageId;

        return $this;
    }

    /**
     * @return string
     */
    public function getCustomerGroupId()
    {
        return $this->_customerGroupId;
    }

    /**
     * @param string $customerGroupId
     * @return string
     */
    public function setCustomerGroupId($customerGroupId)
    {
        $this->_customerGroupId = $customerGroupId;

        return $this;
    }

    /**
     * @return string
     */
    public function getOrganizationId()
    {
        return $this->_organizationId;
    }

    /**
     * @param string $organizationId
     * @return string
     */
    public function setOrganizationId($organizationId)
    {
        $this->_organizationId = $organizationId;

        return $this;
    }

    /**
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->_createdAt;
    }

    /**
     * @param string $createdAt
     * @return string
     */
    public function setCreatedAt($createdAt)
    {
        $this->_createdAt = $createdAt;

        return $this;
    }

    /**
     * @return string
     */
    public function getUpdatedAt()
    {
        return $this->_updatedAt;
    }

    /**
     * @param string $updatedAt
     * @return string
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->_updatedAt = $updatedAt;

        return $this;
    }

    /**
     * @return string
     */
    public function getProductIds()
    {
        return $this->_productIds;
    }

    /**
     * @param string $productIds
     * @return string
     */
    public function setProductIds($productIds)
    {
        $this->_productIds = $productIds;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadZip()
    {
        return $this->_leadZip;
    }

    /**
     * @param string $leadZip
     * @return string
     */
    public function setLeadZip($leadZip)
    {
        $this->_leadZip = $leadZip;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadAddress()
    {
        return $this->_leadAddress;
    }

    /**
     * @param string $leadAddress
     * @return string
     */
    public function setLeadAddress($leadAddress)
    {
        $this->_leadAddress = $leadAddress;

        return $this;
    }

    /**
     * @return string
     */
    public function getOwnerId()
    {
        return $this->_ownerId;
    }

    /**
     * @param string $ownerId
     * @return string
     */
    public function setOwnerId($ownerId)
    {
        $this->_ownerId = $ownerId;

        return $this;
    }

    /**
     * @return string
     */
    public function getLastActivity()
    {
        return $this->_lastActivity;
    }

    /**
     * @param string $lastActivity
     * @return string
     */
    public function setLastActivity($lastActivity)
    {
        $this->_lastActivity = $lastActivity;

        return $this;
    }

    /**
     * @return null
     */
    public function getLeadTypeId()
    {
        return $this->_leadTypeId;
    }

    /**
     * @param null $leadTypeId
     * @return null
     */
    public function setLeadTypeId($leadTypeId)
    {
        $this->_leadTypeId = $leadTypeId;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadMobile()
    {
        return $this->_leadMobile;
    }

    /**
     * @param string $leadMobile
     * @return string
     */
    public function setLeadMobile($leadMobile)
    {
        $this->_leadMobile = $leadMobile;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadPosition()
    {
        return $this->_leadPosition;
    }

    /**
     * @param string $leadPosition
     * @return string
     */
    public function setLeadPosition($leadPosition)
    {
        $this->_leadPosition = $leadPosition;

        return $this;
    }

    /**
     * @return null
     */
    public function getLeadCountryCode()
    {
        return $this->_leadCountryCode;
    }

    /**
     * @param null $leadCountryCode
     * @return null
     */
    public function setLeadCountryCode($leadCountryCode)
    {
        $this->_leadCountryCode = $leadCountryCode;

        return $this;
    }

    /**
     * @return null
     */
    public function getLeadStateCode()
    {
        return $this->_leadStateCode;
    }

    /**
     * @param null $leadStateCode
     * @return null
     */
    public function setLeadStateCode($leadStateCode)
    {
        $this->_leadStateCode = $leadStateCode;

        return $this;
    }

    /**
     * @return string
     */
    public function getMiddleName()
    {
        return $this->_middleName;
    }

    /**
     * @param string $middleName
     * @return string
     */
    public function setMiddleName($middleName)
    {
        $this->_middleName = $middleName;

        return $this;
    }

    /**
     * @return string
     */
    public function getPrefix()
    {
        return $this->_prefix;
    }

    /**
     * @param string $prefix
     * @return string
     */
    public function setPrefix($prefix)
    {
        $this->_prefix = $prefix;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadPhoneCountryCode()
    {
        return $this->_leadPhoneCountryCode;
    }

    /**
     * @param string $leadPhoneCountryCode
     * @return string
     */
    public function setLeadPhoneCountryCode($leadPhoneCountryCode)
    {
        $this->_leadPhoneCountryCode = $leadPhoneCountryCode;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadPhoneCountryCodeValue()
    {
        return $this->_leadPhoneCountryCodeValue;
    }

    /**
     * @param string $leadPhoneCountryCodeValue
     * @return string
     */
    public function setLeadPhoneCountryCodeValue($leadPhoneCountryCodeValue)
    {
        $this->_leadPhoneCountryCodeValue = $leadPhoneCountryCodeValue;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadMobileCountryCode()
    {
        return $this->_leadMobileCountryCode;
    }

    /**
     * @param string $leadMobileCountryCode
     * @return string
     */
    public function setLeadMobileCountryCode($leadMobileCountryCode)
    {
        $this->_leadMobileCountryCode = $leadMobileCountryCode;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadMobileCountryCodeValue()
    {
        return $this->_leadMobileCountryCodeValue;
    }

    /**
     * @param string $leadMobileCountryCodeValue
     * @return string
     */
    public function setLeadMobileCountryCodeValue($leadMobileCountryCodeValue)
    {
        $this->_leadMobileCountryCodeValue = $leadMobileCountryCodeValue;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadPhoneExtension()
    {
        return $this->_leadPhoneExtension;
    }

    /**
     * @param string $leadPhoneExtension
     * @return string
     */
    public function setLeadPhoneExtension($leadPhoneExtension)
    {
        $this->_leadPhoneExtension = $leadPhoneExtension;

        return $this;
    }



    /**
     * @return string
     */
    public function getLeadAddress1()
    {
        return $this->_leadAddress1;
    }

    /**
     * @param string $leadAddress1
     * @return string
     */
    public function setLeadAddress1($leadAddress1)
    {
        $this->_leadAddress1 = $leadAddress1;

        return $this;
    }

    /**
     * @return array
     */
    public function getLeadTags()
    {
        return $this->_leadTags;
    }

    /**
     * @param array $leadTags
     * @return array
     */
    public function setLeadTags($leadTags)
    {
        $this->_leadTags = $leadTags;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadCity()
    {
        return $this->_leadCity;
    }

    /**
     * @param string $leadCity
     * @return string
     */
    public function setLeadCity($leadCity)
    {
        $this->_leadCity = $leadCity;

        return $this;
    }

    /**
     * @return string
     */
    public function getExternalId()
    {
        return $this->_externalId;
    }

    /**
     * @param string $externalId
     */
    public function setExternalId($externalId)
    {
        $this->_externalId = $externalId;
    }

    /**
     * @return string
     */
    public function getCreationType()
    {
        return $this->_creationType;
    }

    /**
     * @param string $creationType
     */
    public function setCreationType($creationType)
    {
        $this->_creationType = $creationType;
    }

    /**
     * @return null
     */
    public function getLastActivityTypeId()
    {
        return $this->_lastActivityTypeId;
    }

    /**
     * @param null $lastActivityTypeId
     * @return null
     */
    public function setLastActivityTypeId($lastActivityTypeId)
    {
        $this->_lastActivityTypeId = $lastActivityTypeId;

        return $this;
    }

    /**
     * @return string
     */
    public function getUseOrganizationAddress()
    {
        return $this->_useOrganizationAddress;
    }

    /**
     * @param string $useOrganizationAddress
     * @return string
     */
    public function setUseOrganizationAddress($useOrganizationAddress)
    {
        $this->_useOrganizationAddress = $useOrganizationAddress;

        return $this;
    }

    /**
     * @return string
     */
    public function getLastActivitySubtype()
    {
        return $this->_lastActivitySubtype;
    }

    /**
     * @param string $lastActivitySubtype
     * @return string
     */
    public function setLastActivitySubtype($lastActivitySubtype)
    {
        $this->_lastActivitySubtype = $lastActivitySubtype;

        return $this;
    }

    /**
     * @return string
     */
    public function getLastActivityOutbound()
    {
        return $this->_lastActivityOutbound;
    }

    /**
     * @param string $lastActivityOutbound
     * @return string
     */
    public function setLastActivityOutbound($lastActivityOutbound)
    {
        $this->_lastActivityOutbound = $lastActivityOutbound;

        return $this;
    }

    /**
     * @return string
     */
    public function getScore()
    {
        return $this->_score;
    }

    /**
     * @param string $score
     * @return string
     */
    public function setScore($score)
    {
        $this->_score = $score;

        return $this;
    }

    /**
     * @return string
     */
    public function getScoreProcessedAt()
    {
        return $this->_score_processed_at;
    }

    /**
     * @param string $score_processed_at
     * @return string
     */
    public function setScoreProcessedAt($score_processed_at)
    {
        $this->_score_processed_at = $score_processed_at;

        return $this;
    }

    /**
     * @return string
     */
    public function getRemoteAuthorizationToken()
    {
        return $this->_remoteAuthorizationToken;
    }

    /**
     * @param string $remoteAuthorizationToken
     * @return string
     */
    public function setRemoteAuthorizationToken($remoteAuthorizationToken)
    {
        $this->_remoteAuthorizationToken = $remoteAuthorizationToken;

        return $this;
    }

    /**
     * @return string
     */
    public function getLeadSecondaryEmail()
    {
        return $this->_leadSecondaryEmail;
    }

    /**
     * @param string $leadSecondaryEmail
     * @return string
     */
    public function setLeadSecondaryEmail($leadSecondaryEmail)
    {
        $this->_leadSecondaryEmail = $leadSecondaryEmail;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailValidatedStatus()
    {
        return $this->_emailValidatedStatus;
    }

    /**
     * @param string $emailValidatedStatus
     * @return string
     */
    public function setEmailValidatedStatus($emailValidatedStatus)
    {
        $this->_emailValidatedStatus = $emailValidatedStatus;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailValidatedDate()
    {
        return $this->_emailValidatedDate;
    }

    /**
     * @param string $emailValidatedDate
     * @return string
     */
    public function setEmailValidatedDate($emailValidatedDate)
    {
        $this->_emailValidatedDate = $emailValidatedDate;

        return $this;
    }

    /**
     * @return string
     */
    public function getEmailValidatedScore()
    {
        return $this->_emailValidatedScore;
    }

    /**
     * @param string $emailValidatedScore
     * @return string
     */
    public function setEmailValidatedScore($emailValidatedScore)
    {
        $this->_emailValidatedScore = $emailValidatedScore;

        return $this;
    }

    /**
     * @return string
     */
    public function getAdditionalInfo()
    {
        return $this->_additionalInfo;
    }

    /**
     * @param string $additionalInfo
     */
    public function setAdditionalInfo($additionalInfo)
    {
        $this->_additionalInfo = $additionalInfo;
    }

    public function getAddressHash()
    {
        return $this->_addressHash;
    }

    /**
     * @param string $addressHash
     */
    public function setAddressHash($addressHash)
    {
        $this->_addressHash = $addressHash;
    }

    /**
     * @return string
     */
    public function getLat()
    {
        return $this->_lat;
    }

    /**
     * @param string $lat
     */
    public function setLat($lat)
    {
        $this->_lat = $lat;
    }

    /**
     * @return string
     */
    public function getLng()
    {
        return $this->_lng;
    }

    /**
     * @param string $lng
     */
    public function setLng($lng)
    {
        $this->_lng = $lng;
    }

    /**
     * @return string
     */
    public function getLastCoordinatesProcessedDate()
    {
        return $this->_lastCoordinatesProcessedDate;
    }

    /**
     * @param string $lastCoordinatesProcessedDate
     */
    public function setLastCoordinatesProcessedDate($lastCoordinatesProcessedDate)
    {
        $this->_lastCoordinatesProcessedDate = $lastCoordinatesProcessedDate;
    }

    /**
     * @return string
     */
    public function getSkipCoordinatesGeneration()
    {
        return $this->_skipCoordinatesGeneration;
    }

    /**
     * @param string $skipCoordinatesGeneration
     */
    public function setSkipCoordinatesGeneration($skipCoordinatesGeneration)
    {
        $this->_skipCoordinatesGeneration = $skipCoordinatesGeneration;
    }


}
