<?php

class Leads_Model_LeadsQuoteLogModel extends Application_Model_Models_Abstract
{

    const QUOTE_ACTION_TYPE_VIEW = 'view';

    const QUOTE_ACTION_TYPE_CHANGE = 'change';

    const QUOTE_ACTION_TYPE_DELETED = 'deleted';

    protected $_quoteId = '';

    protected $_title = '';

    protected $_status = '';

    protected $_createdAt = '';

    protected $_actionLogId = '';

    protected $_creatorId = '';

    protected $_quoteLink = '';

    protected $_quoteActionType = self::QUOTE_ACTION_TYPE_CHANGE;

    protected $_leadId = null;

    protected $_total = '';

    protected $_quoteSent = '0';

    protected $_isDeleted = '0';

    protected $_deletedBy = '';

    protected $_forceDisplay = '0';

    protected $_signedOnlyBy = null;


    /**
     * @return string
     */
    public function getQuoteId()
    {
        return $this->_quoteId;
    }

    /**
     * @param string $quoteId
     * @return string
     */
    public function setQuoteId($quoteId)
    {
        $this->_quoteId = $quoteId;

        return $this;
    }

    /**
     * @return string
     */
    public function getTitle()
    {
        return $this->_title;
    }

    /**
     * @param string $title
     * @return string
     */
    public function setTitle($title)
    {
        $this->_title = $title;

        return $this;
    }


    /**
     * @return string
     */
    public function getStatus()
    {
        return $this->_status;
    }

    /**
     * @param string $status
     * @return string
     */
    public function setStatus($status)
    {
        $this->_status = $status;

        return $this;
    }

    /**
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->_createdAt;
    }

    /**
     * @param string $createdAt
     * @return string
     */
    public function setCreatedAt($createdAt)
    {
        $this->_createdAt = $createdAt;

        return $this;
    }

    /**
     * @return string
     */
    public function getActionLogId()
    {
        return $this->_actionLogId;
    }

    /**
     * @param string $actionLogId
     * @return string
     */
    public function setActionLogId($actionLogId)
    {
        $this->_actionLogId = $actionLogId;

        return $this;
    }

    /**
     * @return string
     */
    public function getCreatorId()
    {
        return $this->_creatorId;
    }

    /**
     * @param string $creatorId
     * @return string
     */
    public function setCreatorId($creatorId)
    {
        $this->_creatorId = $creatorId;

        return $this;
    }

    /**
     * @return string
     */
    public function getQuoteLink()
    {
        return $this->_quoteLink;
    }

    /**
     * @param string $quoteLink
     * @return string
     */
    public function setQuoteLink($quoteLink)
    {
        $this->_quoteLink = $quoteLink;

        return $this;
    }

    /**
     * @return string
     */
    public function getQuoteActionType()
    {
        return $this->_quoteActionType;
    }

    /**
     * @param string $quoteActionType
     * @return string
     */
    public function setQuoteActionType($quoteActionType)
    {
        $this->_quoteActionType = $quoteActionType;

        return $this;
    }

    /**
     * @return null
     */
    public function getLeadId()
    {
        return $this->_leadId;
    }

    /**
     * @param null $leadId
     * @return null
     */
    public function setLeadId($leadId)
    {
        $this->_leadId = $leadId;

        return $this;
    }

    /**
     * @return string
     */
    public function getTotal()
    {
        return $this->_total;
    }

    /**
     * @param string $total
     * @return string
     */
    public function setTotal($total)
    {
        $this->_total = $total;

        return $this;
    }

    /**
     * @return string
     */
    public function getQuoteSent()
    {
        return $this->_quoteSent;
    }

    /**
     * @param string $quoteSent
     * @return string
     */
    public function setQuoteSent($quoteSent)
    {
        $this->_quoteSent = $quoteSent;

        return $this;
    }

    /**
     * @return string
     */
    public function getIsDeleted()
    {
        return $this->_isDeleted;
    }

    /**
     * @param string $isDeleted
     */
    public function setIsDeleted($isDeleted)
    {
        $this->_isDeleted = $isDeleted;
    }

    /**
     * @return string
     */
    public function getDeletedBy()
    {
        return $this->_deletedBy;
    }

    /**
     * @param string $deletedBy
     */
    public function setDeletedBy($deletedBy)
    {
        $this->_deletedBy = $deletedBy;
    }

    /**
     * @return string
     */
    public function getForceDisplay()
    {
        return $this->_forceDisplay;
    }

    /**
     * @param string $forceDisplay
     * @return string
     */
    public function setForceDisplay($forceDisplay)
    {
        $this->_forceDisplay = $forceDisplay;

        return $this;
    }

    /**
     * @return null
     */
    public function getSignedOnlyBy()
    {
        return $this->_signedOnlyBy;
    }

    /**
     * @param null $signedOnlyBy
     */
    public function setSignedOnlyBy($signedOnlyBy)
    {
        $this->_signedOnlyBy = $signedOnlyBy;
    }


}