<?php

/**
 * Class Tools_LeadChangeOwnerTools
 */
class Tools_LeadChangeOwnerTools
{

    public static function changeOwner($ownerIdFrom, $ownerIdTo)
    {
        $leadsMapper = Leads_Mapper_LeadsMapper::getInstance();
        $leadsMapper->changeLeadOwnerByOwnerId($ownerIdFrom, $ownerIdTo);

        $leadsBuilderFormGeneralConfigMapper = Leads_Mapper_LeadsBuilderFormGeneralConfigMapper::getInstance();
        $leadsBuilderFormGeneralConfigMapper->setNotAssignedCreator($ownerIdTo);
        $leadsBuilderFormGeneralConfigMapper->setNotAssignedEditor($ownerIdTo);

        $leadCallLogMapper = Leads_Mapper_LeadsCallLogMapper::getInstance();
        $leadCallLogMapper->changeCreatorId($ownerIdFrom, $ownerIdTo);

        self::changeEventRulesActionsUsers($ownerIdFrom, $ownerIdTo);

        $leadsEventsRulesGeneralConfigMapper = Leads_Mapper_LeadsEventsRulesGeneralConfigMapper::getInstance();
        $leadsEventsRulesGeneralConfigMapper->setNotAssignedCreator($ownerIdTo);
        $leadsEventsRulesGeneralConfigMapper->setNotAssignedEditor($ownerIdTo);

        self::changeFormRulesActionsUsers($ownerIdFrom, $ownerIdTo);

        $leadsFormsRulesGeneralConfigMapper = Leads_Mapper_LeadsFormRulesGeneralConfigMapper::getInstance();
        $leadsFormsRulesGeneralConfigMapper->setNotAssignedCreator($ownerIdTo);
        $leadsFormsRulesGeneralConfigMapper->setNotAssignedEditor($ownerIdTo);

        $leadsMeetingMapper = Leads_Mapper_LeadsMeetingMapper::getInstance();
        $leadsMeetingMapper->changeCreatorId($ownerIdFrom, $ownerIdTo);

        $leadsMeetingLogMapper = Leads_Mapper_LeadsMeetingLogMapper::getInstance();
        $leadsMeetingLogMapper->changeCreatorId($ownerIdFrom, $ownerIdTo);

        $leadsOpportunityMapper = Leads_Mapper_LeadsOpportunityMapper::getInstance();
        $leadsOpportunityMapper->changeCreatorId($ownerIdFrom, $ownerIdTo);

        $leadTaskMapper = Leads_Mapper_LeadsTaskMapper::getInstance();
        $leadTaskMapper->setNotAssignedCreator($ownerIdTo);
        $leadTaskMapper->setNotAssignedUser($ownerIdTo);

        $leadsTasksLogMapper = Leads_Mapper_LeadsTasksLogMapper::getInstance();
        $leadsTasksLogMapper->changeCreatorId($ownerIdFrom, $ownerIdTo);
        $leadsTasksLogMapper->changeUserId($ownerIdFrom, $ownerIdTo);

        $leadsQuoteLogMapper = Leads_Mapper_LeadsQuoteLogMapper::getInstance();
        $leadsQuoteLogMapper->changeCreatorId($ownerIdFrom, $ownerIdTo);
        $leadsQuoteLogMapper->changeCreatorIdOriginalQuote($ownerIdFrom, $ownerIdTo);
        $leadsQuoteLogMapper->changeEditorIdOriginalQuote($ownerIdFrom, $ownerIdTo);
    }

    /**
     * Change event rules configs assign_to, creator_id, user_id
     *
     * @param int $userIdFrom system user id
     * @param int $userIdTo system user id
     */
    public static function changeEventRulesActionsUsers($userIdFrom, $userIdTo)
    {
        $leadEventsRulesActionsMapper = Leads_Mapper_LeadsEventRulesActionsMapper::getInstance();
        $leadEventsEventRulesModels = $leadEventsRulesActionsMapper->fetchAll();
        if (!empty($leadEventsEventRulesModels)) {
            foreach ($leadEventsEventRulesModels as $leadEventsEventRulesModel) {
                $actionConfig = json_decode($leadEventsEventRulesModel->getActionConfig(), true);
                $saveConfig = false;
                if (array_key_exists('assign_to', $actionConfig) && $actionConfig['assign_to'] == $userIdFrom) {
                    $saveConfig = true;
                    $actionConfig['assign_to'] = $userIdTo;
                }

                if (array_key_exists('creator_id', $actionConfig) && $actionConfig['creator_id'] == $userIdFrom) {
                    $saveConfig = true;
                    $actionConfig['creator_id'] = $userIdTo;
                }

                if (array_key_exists('user_id', $actionConfig) && $actionConfig['user_id'] == $userIdFrom) {
                    $saveConfig = true;
                    $actionConfig['user_id'] = $userIdTo;
                }

                if ($saveConfig === true) {
                    $leadEventsEventRulesModel->setActionConfig(json_encode($actionConfig));
                    $leadEventsRulesActionsMapper->save($leadEventsEventRulesModel);
                }
            }
        }
    }


    /**
     * Change form rules configs assign_to, creator_id, user_id
     *
     * @param int $userIdFrom system user id
     * @param int $userIdTo system user id
     */
    public static function changeFormRulesActionsUsers($userIdFrom, $userIdTo)
    {
        $leadFormsRulesActionsMapper = Leads_Mapper_LeadsFormRulesActionsMapper::getInstance();
        $leadFormsFormRulesModels = $leadFormsRulesActionsMapper->fetchAll();
        if (!empty($leadFormsFormRulesModels)) {
            foreach ($leadFormsFormRulesModels as $leadFormsRulesModel) {
                $actionConfig = json_decode($leadFormsRulesModel->getActionConfig(), true);
                $saveConfig = false;
                if (array_key_exists('assign_to', $actionConfig) && $actionConfig['assign_to'] == $userIdFrom) {
                    $saveConfig = true;
                    $actionConfig['assign_to'] = $userIdTo;
                }

                if (array_key_exists('creator_id', $actionConfig) && $actionConfig['creator_id'] == $userIdFrom) {
                    $saveConfig = true;
                    $actionConfig['creator_id'] = $userIdTo;
                }

                if (array_key_exists('user_id', $actionConfig) && $actionConfig['user_id'] == $userIdFrom) {
                    $saveConfig = true;
                    $actionConfig['user_id'] = $userIdTo;
                }

                if ($saveConfig === true) {
                    $leadFormsRulesModel->setActionConfig(json_encode($actionConfig));
                    $leadFormsRulesActionsMapper->save($leadFormsRulesModel);
                }
            }
        }
    }

}