<?php

/**
 * Class Tools_LeadDashboardGraphTools
 */
class Tools_LeadDashboardGraphTools
{


    /**
     * Lead report by owner
     */
    const LEAD_REPORT_BY_REP = 'byRep';

    /**
     *
     * Lead report opportunities count per owner
     *
     */
    const LEAD_REPORT_OPPORTUNITIES_COUNT_PER_REP = 'opportunitiesCountPerRep';

    /**
     *
     * Lead report opportunities amount per owner
     *
     */
    const LEAD_REPORT_OPPORTUNITIES_AMOUNT_PER_REP = 'opportunitiesAmountPerRep';

    /**
     *
     * Lead report opportunities stage per owner
     *
     *
     */
    const LEAD_REPORT_OPPORTUNITIES_STAGE_PER_REP = 'opportunitiesStagePerRep';

    /**
     *
     * Lead report activities stage per owner
     *
     *
     */
    const LEAD_REPORT_ACTIVITIES_PER_REP = 'activitiesPerRep';

    /**
     *
     * Lead report tasks per owner
     *
     */
    const LEAD_REPORT_TASKS_COUNT_PER_REP = 'tasksCountPerRep';

    /**
     * Lead report by group
     */
    const LEAD_REPORT_BY_GROUP = 'byGroup';

    /**
     * Lead report lifecycle by group
     */
    const LEAD_REPORT_LIFECYCLE_BY_GROUP = 'lifecycleByGroup';

    /**
     * Opportunity count per group
     */
    const LEAD_REPORT_OPPORTUNITY_COUNT_PER_GROUP = 'opportunityCountPerGroup';

    /**
     * Opportunity amount by group
     */
    const LEAD_REPORT_OPPORTUNITY_AMOUNT_BY_GROUP = 'opportunityAmountByGroup';

    /**
     * Opportunity stage per group
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_GROUP = 'opportunityStagePerGroup';

    /**
     * Lead report opportunity by source
     */
    const LEAD_REPORT_OPPORTUNITY_BY_SOURCE = 'bySource';

    /**
     * Lead report opportunity per source
     */
    const LEAD_REPORT_OPPORTUNITY_COUNT_PER_SOURCE = 'opportunityCountPerSource';

    /**
     * Lead report opportunity amount by source
     */
    const LEAD_REPORT_OPPORTUNITY_AMOUNT_BY_SOURCE = 'opportunityAmountBySource';

    /**
     * Lead report stage per source
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE = 'opportunityStagePerSource';

    /**
     * Lead report opportunity stage original
     */
    const LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_ORIGINAL = 'opportunityStageFunnelOriginal';

    /**
     * Lead report opportunity stage funnel compare
     */
    const LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_COMPARE = 'opportunityStageFunnelCompare';

    /**
     * Lead report opportunity stage pie original
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PIE_ORIGINAL = 'opportunityStagePieOriginal';

    /**
     * Lead report opportunity stage pie compare
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PIE_COMPARE = 'opportunityStagePieCompare';

    /**
     * Lead report opportunity stage per rep sale sale
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_REP_SALE = 'opportunityStagePerRepSale';

    /**
     * Lead report opportunity stage per source sale sale
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE_SALE = 'opportunityStagePerSourceSale';

    /**
     * Lead report opportunity stage per tag sale
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_TAG_SALE = 'opportunityStagePerTagSale';

    /**
     * Lead report opportunity stage per group sale sale
     */
    const LEAD_REPORT_OPPORTUNITY_STAGE_PER_GROUP_SALE = 'opportunityStagePerGroupSale';

    /**
     * Lead report online sales stage pie
     */
    const LEAD_REPORT_ONLINE_SALES_STAGE_PIE_ORIGINAL = 'onlineSalesStagePieOriginal';

    /**
     * Lead report online sales stage pie compare
     */
    const LEAD_REPORT_ONLINE_SALES_STAGE_PIE_COMPARE = 'onlineSalesStagePieCompare';

    /**
     * Lead report opportunity pie amount
     */
    const LEAD_REPORT_OPPORTUNITY_PIE_AMOUNT = 'opportunityPieAmount';

    /**
     * Lead report opportunity pie count
     */
    const LEAD_REPORT_OPPORTUNITY_PIE_COUNT = 'opportunityPieCount';

    const LEAD_REPORT_OPPORTUNITY_QUOTE_ATTAINMENT = 'quoteAttainmentAmount';

    public static $_opportunityStagesWithoutLostAndWon = array('10', '20', '30', '40', '50', '60', '70', '80', '90');

    /**
     * Lead report by lifecycle
     */
    const LEAD_REPORT_BY_LIFECYCLE = 'byLifecycle';

    public static function getGraphData(
        $graphType,
        $leadReportsFilterStartDateOrigin,
        $leadReportsFilterEndDateOrigin,
        $leadReportsCompareFilterStartDateOrigin = '',
        $leadReportsCompareFilterEndDateOrigin = '',
        $restrictedUserId = 0,
        $additionalParams = array()
    ) {

        $leadReportsMapper = Leads_Mapper_LeadsReportsMapper::getInstance();
        $translator = Zend_Registry::get('Zend_Translate');


        $leadReportsFilterStartDateOriginForLabel = $leadReportsFilterStartDateOrigin;
        if (empty($leadReportsFilterStartDateOriginForLabel)) {
            $leadReportsFilterStartDateOriginForLabel = Tools_System_Tools::convertDateFromTimezone('now');
        }
        $leadReportsFilterEndDateOriginForLabel = $leadReportsFilterEndDateOrigin;
        if (empty($leadReportsFilterEndDateOriginForLabel)) {
            $leadReportsFilterEndDateOriginForLabel = Tools_System_Tools::convertDateFromTimezone('now');
        }

        $leadReportsCompareFilterStartDateOriginForLabel = $leadReportsCompareFilterStartDateOrigin;
        if (empty($leadReportsCompareFilterStartDateOriginForLabel)) {
            $leadReportsCompareFilterStartDateOriginForLabel = Tools_System_Tools::convertDateFromTimezone('now');
        }

        $leadReportsCompareFilterEndDateOriginForLabel = $leadReportsCompareFilterEndDateOrigin;
        if (empty($leadReportsCompareFilterEndDateOriginForLabel)) {
            $leadReportsCompareFilterEndDateOriginForLabel = Tools_System_Tools::convertDateFromTimezone('now');
        }

        $labelTo = $translator->translate(Leads::TRANSLATION_PREFIX.'to');

        $leadReportsFilterDateOriginForLabel = date('d-M-Y',
                strtotime($leadReportsFilterStartDateOriginForLabel)) . ' '.$labelTo .' '. date('d-M-Y',
                strtotime($leadReportsFilterEndDateOriginForLabel));
        $leadReportsFilterDateCompareForLabel = date('d-M-Y',
                strtotime($leadReportsCompareFilterStartDateOriginForLabel)) . ' '.$labelTo .' ' . date('d-M-Y',
                strtotime($leadReportsCompareFilterEndDateOriginForLabel));

        $leadReportsFilterStartDate = Tools_System_Tools::convertDateFromTimezone($leadReportsFilterStartDateOrigin . ' 00:00:00',
            false, 'UTC', 'Y-m-d H:i:s');
        $leadReportsFilterEndDate = Tools_System_Tools::convertDateFromTimezone($leadReportsFilterEndDateOrigin . ' 23:59:59',
            false, 'UTC', 'Y-m-d H:i:s');
        $leadReportsCompareFilterStartDate = Tools_System_Tools::convertDateFromTimezone($leadReportsCompareFilterStartDateOrigin . ' 00:00:00',
            false, 'UTC', 'Y-m-d H:i:s');
        $leadReportsCompareFilterEndDate = Tools_System_Tools::convertDateFromTimezone($leadReportsCompareFilterEndDateOrigin . ' 23:59:59',
            false, 'UTC', 'Y-m-d H:i:s');


        if (self::LEAD_REPORT_OPPORTUNITY_FUNNEL_STAGE_ORIGINAL === $graphType) {
            $dateRangeType = 'expected';
            if (!empty($funnelDateRangeType) && $funnelDateRangeType === 'changed') {
                $dateRangeType = 'changed';
            }
            if (!empty($funnelDateRangeType) && $funnelDateRangeType === 'created') {
                $dateRangeType = 'created';
            }
            $opportunitiesStagesFunnelDataOriginal = $leadReportsMapper->getOpportunitiesStage($leadReportsFilterStartDate,
                $leadReportsFilterEndDate, $dateRangeType, array('1', '100'), $restrictedUserId);
            $opportunitiesStagesFunnelResult = Tools_LeadReportsTools::prepareOpportunityStageFunnel($opportunitiesStagesFunnelDataOriginal);
            $salesExpectation = Tools_LeadReportsTools::prepareSalesExpectation($opportunitiesStagesFunnelDataOriginal);
            if (!empty($opportunitiesStagesFunnelResult)) {
                //$opportunitiesStagesFunnelResult['title'] = $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITY_FUNNEL_STAGE);
                $opportunitiesStagesFunnelResult['filterPeriod'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesFunnelResult['salesExpectation'] = $salesExpectation;
                $opportunitiesStagesFunnelResult['filterStartDate'] = $leadReportsFilterStartDateOrigin;
                $opportunitiesStagesFunnelResult['filterEndDate'] = $leadReportsFilterEndDateOrigin;

                foreach ($opportunitiesStagesFunnelDataOriginal as $key => $opportunitiesStages) {
                    $opportunitiesStagesFunnelResult['axesAdditionalInfo'][] = $key;
                }
            }

            return $opportunitiesStagesFunnelResult;
        }


        if (self::LEAD_REPORT_OPPORTUNITY_STAGE_PER_SOURCE === $graphType) {
            $opportunitiesStagesPerSource = $leadReportsMapper->getOpportunitiesStageBySourceCountAggregated($leadReportsFilterStartDate,
                $leadReportsFilterEndDate, false, false, array('1'), false, $restrictedUserId);
            $opportunitiesStagesPerSourceResult = Tools_LeadReportsTools::prepareLeadStageOwnersDataAggregated($opportunitiesStagesPerSource);


            if (!empty($opportunitiesStagesPerSourceResult)) {
                //$opportunitiesStagesPerSourceResult['title'] = $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_OPPORTUNITIES_BAR_AGGREGATED_BY_SOURCE);
                $opportunitiesStagesPerSourceResult['filterFromDate'] = $leadReportsFilterDateOriginForLabel;
                $opportunitiesStagesPerSourceResult['filterToDate'] = $leadReportsFilterDateCompareForLabel;
                $opportunitiesStagesPerSourceResult['filterStartDate'] = $leadReportsFilterStartDateOrigin;
                $opportunitiesStagesPerSourceResult['filterEndDate'] = $leadReportsFilterEndDateOrigin;
            }

            return $opportunitiesStagesPerSourceResult;
        }

        if (self::LEAD_REPORT_OPPORTUNITY_PIE_AMOUNT === $graphType) {
            if (!empty($additionalParams['oppType'])) {
                $opportunitiesStagesPieData = $leadReportsMapper->getOpportunitiesStageAmount($leadReportsFilterStartDate, $leadReportsFilterEndDate, array(), true, $restrictedUserId, $additionalParams['oppType']);
            } else {
                $opportunitiesStagesPieData = $leadReportsMapper->getOpportunitiesStageAmount($leadReportsFilterStartDate, $leadReportsFilterEndDate, array(), true, $restrictedUserId);
            }

            $opportunitiesStagesPieDataResult = Tools_LeadReportsTools::prepareOpportunityStagePie($opportunitiesStagesPieData, true);
            if (!empty($opportunitiesStagesPieDataResult)) {
                //$opportunitiesStagesPieDataResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_PIE_OPPORTUNITY);
                $opportunitiesStagesPieDataResult['filterPeriod'] = $leadReportsFilterDateOriginForLabel;
            }

            $opportunitiesStagesPieDataResult['filterStartDate'] = $leadReportsFilterStartDateOrigin;
            $opportunitiesStagesPieDataResult['filterEndDate'] = $leadReportsFilterEndDateOrigin;

            return $opportunitiesStagesPieDataResult;
        }

        if (self::LEAD_REPORT_OPPORTUNITY_PIE_COUNT === $graphType) {
            if (!empty($additionalParams['oppType'])) {
                $opportunitiesStagesPieData = $leadReportsMapper->getOpportunitiesStageAmount($leadReportsFilterStartDate, $leadReportsFilterEndDate, array(), true, $restrictedUserId, $additionalParams['oppType']);
            } else {
                $opportunitiesStagesPieData = $leadReportsMapper->getOpportunitiesStageAmount($leadReportsFilterStartDate, $leadReportsFilterEndDate, array(), true, $restrictedUserId);
            }

            $opportunitiesStagesPieDataResult = Tools_LeadReportsTools::prepareOpportunityStagePie($opportunitiesStagesPieData, true);
            if (!empty($opportunitiesStagesPieDataResult)) {
                //$opportunitiesStagesPieDataResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_PIE_OPPORTUNITY);
                $opportunitiesStagesPieDataResult['filterPeriod'] = $leadReportsFilterDateOriginForLabel;
            }

            $opportunitiesStagesPieDataResult['filterStartDate'] = $leadReportsFilterStartDateOrigin;
            $opportunitiesStagesPieDataResult['filterEndDate'] = $leadReportsFilterEndDateOrigin;

            return $opportunitiesStagesPieDataResult;
        }

        if (self::LEAD_REPORT_OPPORTUNITY_QUOTE_ATTAINMENT === $graphType) {
            $opportunitiesStagesPieData = $leadReportsMapper->getOpportunitiesStageAmount($leadReportsFilterStartDate, $leadReportsFilterEndDate, array(), true, $restrictedUserId);
            $opportunitiesStagesPieDataResult = Tools_LeadReportsTools::prepareOpportunityStagePie($opportunitiesStagesPieData, true);

            $opportunityQuoteAttainmentResult = array();
            if (!empty($additionalParams['filterPeriodMonths'])) {
                $filterPeriodMonths = $additionalParams['filterPeriodMonths'];
                if (!empty($opportunitiesStagesPieDataResult) && !empty($opportunitiesStagesPieDataResult['data']['100'])) {
                    $amount = $opportunitiesStagesPieDataResult['data']['100']['amount'];
                    $opportunityQuoteAttainmentResult = Tools_LeadReportsTools::prepareAmountQuoteAttainment($amount, $restrictedUserId, $filterPeriodMonths);
                } else {
                    $opportunityQuoteAttainmentResult = Tools_LeadReportsTools::prepareAmountQuoteAttainment(0, $restrictedUserId, $filterPeriodMonths);
                }
            }

            if (!empty($opportunityQuoteAttainmentResult)) {
               //$opportunityQuoteAttainmentResult['title'] =  $translator->translate(Leads::TRANSLATION_PREFIX.Tools_LeadReportsTools::GRAPH_TITLE_PIE_OPPORTUNITY);
                $opportunityQuoteAttainmentResult['filterPeriod'] = $leadReportsFilterDateOriginForLabel;
            }
            $opportunityQuoteAttainmentResult['filterStartDate'] = $leadReportsFilterStartDateOrigin;
            $opportunityQuoteAttainmentResult['filterEndDate'] = $leadReportsFilterEndDateOrigin;
            return $opportunityQuoteAttainmentResult;
        }

    }

}
