<?php

/**
 * Class Tools_LeadDocumentsTools
 */
class Tools_LeadDocumentsTools
{

    /**
     * General files folder
     */
    const FILES_FOLDER = 'files';

    public static $extensionToMimeTypeMap = array(
        'hqx' => 'application/mac-binhex40',
        'cpt' => 'application/mac-compactpro',
        'csv' => 'text/x-comma-separated-values',
        'oda' => 'application/oda',
        'pdf' => 'application/pdf',
        'eps' => 'application/postscript',
        'epub' => 'application/epub+zip',
        'ps' => 'application/postscript',
        'smi' => 'application/smil',
        'mif' => 'application/vnd.mif',
        'xls' => 'application/vnd.ms-excel',
        'ppt' => 'application/powerpoint',
        'pptx' => 'application/vnd.openxmlformats-officedocument.presentationml.presentation',
        'wbxml' => 'application/wbxml',
        'wmlc' => 'application/wmlc',
        'dcr' => 'application/x-director',
        'dvi' => 'application/x-dvi',
        'gtar' => 'application/x-gtar',
        'gzip' => 'application/x-gzip',
        'php' => 'application/x-httpd-php',
        'phps' => 'application/x-httpd-php-source',
        'js' => 'application/javascript',
        'swf' => 'application/x-shockwave-flash',
        'sit' => 'application/x-stuffit',
        'tar' => 'application/x-tar',
        'z' => 'application/x-compress',
        'xhtml' => 'application/xhtml+xml',
        'xht' => 'application/xhtml+xml',
        'rdf' => 'application/rdf+xml',
        'zip' => 'application/x-zip',
        'rar' => 'application/x-rar',
        'mid' => 'audio/midi',
        'mp3' => 'audio/mpeg',
        'aif' => 'audio/x-aiff',
        'ram' => 'audio/x-pn-realaudio',
        'rpm' => 'audio/x-pn-realaudio-plugin',
        'ra' => 'audio/x-realaudio',
        'rv' => 'video/vnd.rn-realvideo',
        'wav' => 'audio/x-wav',
        'jpg' => 'image/jpeg',
        'png' => 'image/png',
        'gif' => 'image/gif',
        'bmp' => 'image/bmp',
        'tiff' => 'image/tiff',
        'tif' => 'image/tiff',
        'svg' => 'image/svg+xml',
        'css' => 'text/css',
        'html' => 'text/html',
        'txt' => 'text/plain',
        'rtx' => 'text/richtext',
        'rtf' => 'text/rtf',
        'xml' => 'application/xml',
        'xsl' => 'application/xml',
        'mpeg' => 'video/mpeg',
        'qt' => 'video/quicktime',
        'mov' => 'video/quicktime',
        'avi' => 'video/x-msvideo',
        'movie' => 'video/x-sgi-movie',
        'doc' => 'application/msword',
        'docx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
        'docm' => 'application/vnd.ms-word.template.macroEnabled.12',
        'dot' => 'application/msword',
        'dotx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
        'xlsx' => 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
        'word' => 'application/msword',
        'xl' => 'application/excel',
        'eml' => 'message/rfc822',
        'json' => 'application/json',
        'pem' => 'application/x-x509-user-cert',
        'p10' => 'application/x-pkcs10',
        'p12' => 'application/x-pkcs12',
        'p7a' => 'application/x-pkcs7-signature',
        'p7c' => 'application/pkcs7-mime',
        'p7m' => 'application/pkcs7-mime',
        'p7r' => 'application/x-pkcs7-certreqresp',
        'p7s' => 'application/pkcs7-signature',
        'crt' => 'application/x-x509-ca-cert',
        'crl' => 'application/pkix-crl',
        'der' => 'application/x-x509-ca-cert',
        'kdb' => 'application/octet-stream',
        'pgp' => 'application/pgp',
        'gpg' => 'application/gpg-keys',
        'sst' => 'application/octet-stream',
        'csr' => 'application/octet-stream',
        'rsa' => 'application/x-pkcs7',
        'cer' => 'application/pkix-cert',
        '3g2' => 'video/3gpp2',
        '3gp' => 'video/3gp',
        'mp4' => 'video/mp4',
        'm4a' => 'audio/x-m4a',
        'f4v' => 'video/mp4',
        'webm' => 'video/webm',
        'aac' => 'audio/x-acc',
        'm4u' => 'application/vnd.mpegurl',
        'm3u' => 'text/plain',
        'xspf' => 'application/xspf+xml',
        'vlc' => 'application/videolan',
        'wmv' => 'video/x-ms-wmv',
        'au' => 'audio/x-au',
        'ac3' => 'audio/ac3',
        'flac' => 'audio/x-flac',
        'ogg' => 'audio/ogg',
        'kmz' => 'application/vnd.google-earth.kmz',
        'kml' => 'application/vnd.google-earth.kml+xml',
        'ics' => 'text/calendar',
        'zsh' => 'text/x-scriptzsh',
        '7zip' => 'application/x-7z-compressed',
        'cdr' => 'application/cdr',
        'wma' => 'audio/x-ms-wma',
        'jar' => 'application/java-archive',
        'tex' => 'application/x-tex',
        'latex' => 'application/x-latex',
        'odt' => 'application/vnd.oasis.opendocument.text',
        'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
        'odp' => 'application/vnd.oasis.opendocument.presentation',
        'odg' => 'application/vnd.oasis.opendocument.graphics',
        'odc' => 'application/vnd.oasis.opendocument.chart',
        'odf' => 'application/vnd.oasis.opendocument.formula',
        'odi' => 'application/vnd.oasis.opendocument.image',
        'odm' => 'application/vnd.oasis.opendocument.text-master',
        'odb' => 'application/vnd.oasis.opendocument.database',
        'ott' => 'application/vnd.oasis.opendocument.text-template'
    );


    /**
     * Accepted file Mime types for upload
     *
     * @var array
     */
    public static $_acceptedFilesMimeTypes = array(
        'application/pdf',
        'application/xml',
        'application/zip',
        'text/csv',
        'text/plain',
        'image/png',
        'image/jpeg',
        'image/gif',
        'image/bmp',
        'application/msword',
        'application/vnd.ms-excel',
        'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
        'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
        'audio/mpeg3',
        'audio/mpeg',
        'video/avi',
        'video/x-msvideo',
        'video/mp4',
        'video/mpeg',
        'video/mp4',
        'video/quicktime',
        'message/rfc822',
        'application/vnd.openxmlformats-officedocument.presentationml.presentation'

    );

    /**
     * Accepted file types
     *
     * @var array
     */
    public static $_acceptedFileTypes = array(
        'xml,csv,doc,zip,jpg,jpeg,png,bmp,gif,xls,pdf,docx,txt,xlsx,mp3,avi,mpeg,mp4,webm,mov','eml','pptx'
    );

    /**
     * Accepted file types
     *
     * @var array
     */
    public static $_acceptedFileTypesArray = array(
        'xml',
        'csv',
        'doc',
        'zip',
        'jpg',
        'png',
        'bmp',
        'gif',
        'xls',
        'pdf',
        'docx',
        'txt',
        'xlsx',
        'mp3',
        'avi',
        'mpeg',
        'mp4',
        'webm',
        'mov',
        'eml',
        'jpeg',
        'pptx'
    );


    /**
     * Get extension by mime type
     *
     * @param string $mimeType mime type
     * @return string
     */
    public static function getExtensionToMimeTypeMap($mimeType)
    {
        $key = array_search($mimeType, self::$extensionToMimeTypeMap);
        if ($key !== false) {
            return $key;
        }

        return '';
    }

    /**
     * Get path to file
     *
     * @param string $fileStoredName file stored name
     * @return string
     */
    public static function getFilePath($fileStoredName)
    {
        $websiteHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('website');

        return $websiteHelper->getPath() . 'plugins' . DIRECTORY_SEPARATOR . 'leads' .
            DIRECTORY_SEPARATOR . 'web' . DIRECTORY_SEPARATOR . self::FILES_FOLDER
            . DIRECTORY_SEPARATOR . $fileStoredName;

    }

    /**
     * Attach base 64 format file to the lead
     *
     * @param int $leadId lead id
     * @param string $base64File base64 string
     * @param string $fileName file name
     */
    public static function attachFileToLeadBase64($leadId, $base64File, $fileName = '')
    {
        $leadsMapper = Leads_Mapper_LeadsMapper::getInstance();
        $leadModel = $leadsMapper->find($leadId);
        if ($leadModel instanceof Leads_Model_LeadsModel) {
            $fileContent = base64_decode($base64File);
            $fInfo = finfo_open();
            $mimeType = finfo_buffer($fInfo, $fileContent, FILEINFO_MIME_TYPE);
            $fileExtension = self::getExtensionToMimeTypeMap($mimeType);
            if (in_array($mimeType, self::$_acceptedFilesMimeTypes, true) && in_array($fileExtension,
                    self::$_acceptedFileTypesArray, true)) {
                $fileHash = self::generateUniqueHash($fileName);
                $fileStoredName = self::generateUniqueFileStoredName($fileName, $fileExtension);
                $savePath = self::getFilePath($fileStoredName);
                $isSaved = file_put_contents($savePath, $fileContent);
                if ($isSaved) {
                    self::processDocumentRecord($leadId, $fileStoredName, $fileHash, $fileName, $fileExtension);
                }
            }
        }
    }

    /**
     * @param $leadId
     * @param $fileStoredName
     * @param $fileHash
     * @param $fileName
     * @param $fileExtension
     * @param $externalUrl
     * @param $uploadedAt
     * @return Leads_Model_LeadsDocumentsModel
     */
    public static function processDocumentRecord($leadId, $fileStoredName, $fileHash, $fileName, $fileExtension, $externalUrl = '', $uploadedAt = '')
    {
        $leadsDocumentsMapper = Leads_Mapper_LeadsDocumentsMapper::getInstance();
        $leadsDocumentsModel = new Leads_Model_LeadsDocumentsModel();
        $leadsDocumentsModel->setLeadId($leadId);
        $leadsDocumentsModel->setFileStoredName($fileStoredName);
        $leadsDocumentsModel->setFileHash($fileHash);
        $leadsDocumentsModel->setOriginalFileName($fileName . '.' . $fileExtension);
        $leadsDocumentsModel->setDisplayFileName($fileName);
        $leadsDocumentsModel->setExternalUrl($externalUrl);
        if (!empty($uploadedAt)) {
            $leadsDocumentsModel->setUploadedAt($uploadedAt);
        } else {
            $leadsDocumentsModel->setUploadedAt(Tools_System_Tools::convertDateFromTimezone('now'));
        }

        return $leadsDocumentsMapper->save($leadsDocumentsModel);
    }

    /**
     * Generate stored and hash
     *
     * @param array $file file info
     * @return array
     * @throws Zend_Exception
     */
    public static function generateStoredName($file)
    {
        $translator = Zend_Registry::get('Zend_Translate');
        $storedData = array();

        preg_match('~[^\x00-\x1F"<>\|:\*\?/]+\.[\w\d]{2,8}$~iU', $file['name'], $match);
        if (!$match) {
            $storedData['error'] = array('result' => $translator->translate(Leads::TRANSLATION_PREFIX.'Corrupted filename'), 'error' => 1);
        }

        $fileExtension = pathinfo($file['name'], PATHINFO_EXTENSION);
        $fileName = pathinfo($file['name'], PATHINFO_FILENAME);

        $storedData['fileExtension'] = $fileExtension;
        $storedData['fileName'] = $fileName;
        $storedData['fileStoredName'] = self::generateUniqueFileStoredName($fileName, $fileExtension);
        $storedData['fileHash'] = self::generateUniqueHash($fileName);

        return $storedData;
    }


    /**
     * Generate unique file hash name
     *
     * @param string $fileName file name
     * @return string
     */
    public static function generateUniqueHash($fileName)
    {
        return sha1($fileName . uniqid(microtime()));
    }

    /**
     * Generate unique file stored hash name
     *
     * @param string $fileName file name
     * @param string $fileExtension file extension
     * @return string
     */
    public static function generateUniqueFileStoredName($fileName, $fileExtension)
    {
        return self::generateUniqueHash($fileName) . '.' . $fileExtension;
    }

    /**
     * Clean document name
     *
     * @param string $documentName document name
     * @return string|string[]
     */
    public static function cleanDocumentName($documentName)
    {
        $documentName = str_replace(array(',', ';', '/'),'',$documentName);
        return $documentName;
    }


}
