<?php

class Tools_LeadEmailSequenceTools
{

    /**
     * Add to queue no_cart status emails
     */
    public static function addToQueueNoCartEmails($partially)
    {
        $cartStatusQueueMapper = Emailsequence_Models_Mapper_EmailsequenceQueueMapper::getInstance();
        $leadHasEmailSequence = Leads_Mapper_LeadsHasEmailSequenceMapper::getInstance();
        $sequenceConfigs = $leadHasEmailSequence->getEmailSequenceConfigNoCart(false, Leads::$_noCartStatuses);
        $leadsEmailSequenceStatusMapper = Leads_Mapper_LeadsEmailSequenceStatusMapper::getInstance();
        $shoppingConfigMapper =  Models_Mapper_ShoppingConfig::getInstance();
        $storeTimezone = $shoppingConfigMapper->getConfigParam('timezone');
        if (!empty($sequenceConfigs)) {
            $sequenceKeys = array_keys($sequenceConfigs);
            $processedTriggersKeys = $leadHasEmailSequence->getProcessedTriggers($sequenceKeys);
            $sequenceTriggersToProcess = array_diff_key($sequenceConfigs, $processedTriggersKeys);
            if (!empty($partially)) {
                $sequenceTriggersToProcess = array_slice($sequenceTriggersToProcess, 0, 30);
            }
            if (!empty($sequenceTriggersToProcess)) {
                foreach ($sequenceTriggersToProcess as $sequenceConfig) {
                    $period = $sequenceConfig['period'];
                    $newCartStatus = $sequenceConfig['cartStatus'];
                    $emailTemplate = $sequenceConfig['emailTemplate'];
                    $emailFrom = $sequenceConfig['emailFrom'];
                    $emailMessage = $sequenceConfig['emailMessage'];
                    $leadLastName = $sequenceConfig['lead_last_name'];
                    $leadFirstName = $sequenceConfig['lead_first_name'];
                    $cartStatusId = $sequenceConfig['trigger_id'];
                    $lagType = $sequenceConfig['lagType'];
                    $leadEmail = $sequenceConfig['lead_email'];
                    $sequenceId = $sequenceConfig['sequenceId'];
                    $leadId = $sequenceConfig['lead_id'];
                    $schedulePeriod = $sequenceConfig['schedulePeriod'];
                    $schedulePeriodType = $sequenceConfig['schedulePeriodType'];
                    $sequenceDate = $sequenceConfig['sequence_date'];
                    $subject = $sequenceConfig['subject'];
                    $leadMobileCode = $sequenceConfig['lead_mobile_country_code_value'];
                    $leadMobile = $sequenceConfig['lead_mobile'];
                    $leadPhoneCode = $sequenceConfig['lead_phone_country_code_value'];
                    $leadPhone = $sequenceConfig['lead_phone'];
                    $type = $sequenceConfig['type'];
                    $preheader = $sequenceConfig['preheader'];

                    $leadFullName = $leadFirstName;
                    if (!empty($leadLastName)) {
                        $leadFullName .= ' ' . $leadLastName;
                    }

                    $queueExists = $leadHasEmailSequence->checkCartStatusQueue($leadId,
                        Leads::CART_STATUS_PLUGIN_EXTERNAL_TYPE, $sequenceId, $cartStatusId);
                    if (empty($queueExists)) {

                        $serverTimezone = date_default_timezone_get();
                        if (empty($serverTimezone)) {
                            $serverTimezone = 'UTC';
                        }
                        $toSendAt = Tools_System_Tools::convertDateFromTimezone(date(Tools_System_Tools::DATE_MYSQL, strtotime($sequenceDate.' +'.$period.' '.$lagType)), $serverTimezone, 'UTC');
                        $toSendAt = date(Tools_System_Tools::DATE_MYSQL, strtotime($toSendAt .'+'.Tools_EmailSequenceTools::getTimezoneShift('UTC', $storeTimezone).'hours'));
                        //analyze to send date
                        $sendEmailNow = true;
                        if (!empty($schedulePeriod)) {
                            $schedulePeriodDataSet = explode(',', $schedulePeriod);
                            $currentDayOfTheWeek = strtolower(date('l', strtotime($toSendAt)));
                            $currentHourOfTheWeek = intval(strtolower(date('H', strtotime($toSendAt))));
                            $sendEmailNow = false;
                            $delayTodayOfTheWeek = false;
                            $deliveryDates = array();
                            $excludeDayOfTheWeek = '';
                            $operationalHoursStoreConfig = Models_Mapper_ShoppingConfig::getInstance()->getConfigParam('operationalHours');
                            if (!empty($operationalHoursStoreConfig) && $schedulePeriodType === Emailsequence_Models_Models_EmailTriggerSettingsModel::SCHEDULE_PERIOD_TYPE_OPERATION_HOURS) {
                                $operationalHoursStoreConfig = unserialize($operationalHoursStoreConfig);
                            } else {
                                $operationalHoursStoreConfig = array();
                            }
                            foreach ($schedulePeriodDataSet as $key => $dayOfTheWeek) {
                                $nextDeliveryDate = strtotime("next ".$dayOfTheWeek, strtotime($toSendAt));
                                if(($nextDeliveryDate > strtotime($toSendAt)) && empty($delayTodayOfTheWeek) && $currentDayOfTheWeek !== $dayOfTheWeek) {
                                    if ($excludeDayOfTheWeek !== $dayOfTheWeek) {
                                        $deliveryDates[$dayOfTheWeek] = $nextDeliveryDate;
                                    }
                                } elseif($currentDayOfTheWeek === $dayOfTheWeek){
                                    $deliveryDates[$dayOfTheWeek] = strtotime($toSendAt);
                                }
                                if ($currentDayOfTheWeek === $dayOfTheWeek && empty($operationalHoursStoreConfig)) {
                                    $sendEmailNow = true;
                                } elseif($currentDayOfTheWeek === $dayOfTheWeek && !empty($operationalHoursStoreConfig) && !empty($operationalHoursStoreConfig[$currentDayOfTheWeek])) {
                                    if (empty($operationalHoursStoreConfig[$currentDayOfTheWeek]['from']) && empty($operationalHoursStoreConfig[$currentDayOfTheWeek]['to'])) {
                                        $sendEmailNow = true;
                                    } else {
                                        if (!empty($operationalHoursStoreConfig[$currentDayOfTheWeek]['from'])) {
                                            $sendFromHours = $operationalHoursStoreConfig[$currentDayOfTheWeek]['from'] - 1;
                                        } else {
                                            $sendFromHours = 0;
                                        }
                                        if (!empty($operationalHoursStoreConfig[$currentDayOfTheWeek]['to'])) {
                                            $sendToHours = $operationalHoursStoreConfig[$currentDayOfTheWeek]['to'] - 1;
                                        } else {
                                            $sendToHours = 24;
                                        }

                                        if ($currentHourOfTheWeek >= $sendFromHours && $sendToHours >= $currentHourOfTheWeek) {
                                            $sendEmailNow = true;
                                            break;
                                        } elseif ($currentHourOfTheWeek < $sendFromHours) {
                                            $deliveryDates[$dayOfTheWeek] = strtotime(date('Y-m-d H:i:s', strtotime(date('Y-m-d', strtotime($toSendAt)). ' '.$sendFromHours.':00:00')));
                                        }
                                        else
                                        {
                                            $currentScheduleDateOfTheWeekId = array_search($dayOfTheWeek, $schedulePeriodDataSet);
                                            if (!empty($schedulePeriodDataSet[$currentScheduleDateOfTheWeekId + 1])) {
                                                $dayOfTheWeek = $schedulePeriodDataSet[$currentScheduleDateOfTheWeekId + 1];
                                            }
                                            $excludeDayOfTheWeek = $dayOfTheWeek;
                                            $deliveryDates[$dayOfTheWeek] = strtotime("next ".$dayOfTheWeek. "+".$sendFromHours." hour", strtotime($toSendAt));
                                        }
                                    }
                                } elseif($currentDayOfTheWeek !== $dayOfTheWeek&& !empty($operationalHoursStoreConfig) && !empty($operationalHoursStoreConfig[$dayOfTheWeek])) {
                                    if (!empty($operationalHoursStoreConfig[$dayOfTheWeek]['from']) || !empty($operationalHoursStoreConfig[$dayOfTheWeek]['to'])) {
                                        if (!empty($operationalHoursStoreConfig[$dayOfTheWeek]['from'])) {
                                            $sendFromHours = $operationalHoursStoreConfig[$dayOfTheWeek]['from'] - 1;
                                        } else {
                                            $sendFromHours = 0;
                                        }
                                        if (!empty($operationalHoursStoreConfig[$dayOfTheWeek]['to'])) {
                                            $sendToHours = $operationalHoursStoreConfig[$dayOfTheWeek]['to'] - 1;
                                        } else {
                                            $sendToHours = 24;
                                        }

                                        if ($currentHourOfTheWeek > $sendFromHours && $sendToHours > $currentHourOfTheWeek) {
                                            $sendEmailNow = true;
                                        } elseif ($currentHourOfTheWeek < $sendFromHours) {
                                            $deliveryDates[$dayOfTheWeek] =  strtotime("next ".$dayOfTheWeek. "+".$sendFromHours." hour", strtotime($toSendAt));
                                        }
                                        else
                                        {
                                            $excludeDayOfTheWeek = $dayOfTheWeek;
                                            $deliveryDates[$dayOfTheWeek] = strtotime("next ".$dayOfTheWeek. "+".$sendFromHours." hour", strtotime($toSendAt));
                                        }
                                    }
                                }
                            }
                            if (!empty($deliveryDates)) {
                                $delayTodayOfTheWeek = date(Tools_System_Tools::DATE_MYSQL, min($deliveryDates));
                            }
                        }

                        if ($sendEmailNow === false) {
                            $toSendAt = $delayTodayOfTheWeek;
                        }

                        $hoursShift = Tools_EmailSequenceTools::getTimezoneShift('UTC', $storeTimezone);
                        if ($hoursShift > 0) {
                            $hoursShift = ' -'. $hoursShift;
                        } else {
                            $hoursShift = ' +'.abs($hoursShift);
                        }

                        $toSendAt = date(Tools_System_Tools::DATE_MYSQL, strtotime($toSendAt.$hoursShift.'hours'));

                        $mobilePhoneLead = Tools_EmailSequenceTools::glueUserPhone($leadMobileCode, $leadMobile, $leadPhoneCode, $leadPhone);

                        $emailQueueExist = $cartStatusQueueMapper->selectUniqueSequence($cartStatusId,
                            $leadId, $sequenceId, 'lead');

                        if (empty($emailQueueExist)) {
                            $cartStatusQueueModel = new Emailsequence_Models_Models_EmailsequenceQueueModel();
                            $cartStatusQueueModel->setStatus(0);
                            $cartStatusQueueModel->setCartStatusId($cartStatusId);
                            $cartStatusQueueModel->setType($type);
                            $cartStatusQueueModel->setUserEmail($leadEmail);
                            $cartStatusQueueModel->setUserFullName($leadFullName);
                            $cartStatusQueueModel->setUserPhoneNumber($mobilePhoneLead);
                            $cartStatusQueueModel->setCartStatus($newCartStatus);
                            $cartStatusQueueModel->setEmailMessage($emailMessage);
                            $cartStatusQueueModel->setEmailFrom($emailFrom);
                            $cartStatusQueueModel->setEmailTemplate($emailTemplate);
                            $cartStatusQueueModel->setExternalId($leadId);
                            $cartStatusQueueModel->setDelayDelivery('1');
                            $cartStatusQueueModel->setExternalType(Leads::CART_STATUS_PLUGIN_EXTERNAL_TYPE);
                            $cartStatusQueueModel->setSequenceId($sequenceId);
                            $cartStatusQueueModel->setDelayedTo($toSendAt);
                            $cartStatusQueueModel->setSubject($subject);
                            $cartStatusQueueModel->setPreheader($preheader);

                            if ($type == 'email') {
                                if (!empty($leadEmail)) {
                                    $cartStatusSubscribeMapper = Emailsequence_Models_Mapper_SubscribeMapper::getInstance();
                                    $cartStatusSubscribeModel = $cartStatusSubscribeMapper->findModelByExternalLeadEmail($leadEmail);

                                    if (!$cartStatusSubscribeModel instanceof Emailsequence_Models_Models_SubscribeModel) {
                                        $cartStatusSubscribeModel = new Emailsequence_Models_Models_SubscribeModel();
                                        $cartStatusSubscribeModel->setUserId(0);
                                        $cartStatusSubscribeModel->setCode(sha1(uniqid(strtotime('now'))));
                                        $cartStatusSubscribeModel->setStatus(Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED);
                                        $cartStatusSubscribeModel->setExternal(1);
                                        $cartStatusSubscribeModel->setExternalEmail($leadEmail);
                                        $cartStatusSubscribeMapper->save($cartStatusSubscribeModel);
                                    }
                                    if ($cartStatusSubscribeModel->getStatus() === Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED) {
                                        $cartStatusQueueMapper->save($cartStatusQueueModel);
                                    }
                                }
                            } else {
                                if ($type == 'sms' && !empty($mobilePhoneLead)) {
                                    $cartStatusSubscribeSmsMapper = Emailsequence_Models_Mapper_SubscribeSmsMapper::getInstance();
                                    $subscribeSmsModel = $cartStatusSubscribeSmsMapper->findByMobile($mobilePhoneLead);
                                    if (!$subscribeSmsModel instanceof Emailsequence_Models_Models_SubscribeSmsModel) {
                                        $subscribeSmsModel = new Emailsequence_Models_Models_SubscribeSmsModel();
                                        $subscribeSmsModel->setUserId(0);
                                        $subscribeSmsModel->setCode(sha1(uniqid(strtotime('now'))));
                                        $subscribeSmsModel->setStatus(Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED);
                                        $subscribeSmsModel->setExternal(1);
                                        $subscribeSmsModel->setExternalEmail($leadEmail);
                                        $subscribeSmsModel->setMobileNumber($mobilePhoneLead);
                                        $cartStatusSubscribeSmsMapper->save($subscribeSmsModel);
                                    }
                                    if ($subscribeSmsModel->getStatus() === Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED) {
                                        $cartStatusQueueMapper->save($cartStatusQueueModel);
                                    }
                                }
                            }

                            $leadEmailSequenceStatusModel = $leadsEmailSequenceStatusMapper->getLeadSequence($leadId, $sequenceId, $cartStatusId);
                            if (!$leadEmailSequenceStatusModel instanceof Leads_Model_LeadsEmailSequenceStatusModel) {
                                $leadEmailSequenceStatusModel = new Leads_Model_LeadsEmailSequenceStatusModel();
                                $leadEmailSequenceStatusModel->setLeadId($leadId);
                                $leadEmailSequenceStatusModel->setSequenceId($sequenceId);
                                $leadEmailSequenceStatusModel->setCartStatusSettingsId($cartStatusId);
                                $leadEmailSequenceStatusModel->setSequenceAppliedDate(date(Tools_System_Tools::DATE_MYSQL,
                                    strtotime('now')));
                                try {
                                    $leadsEmailSequenceStatusMapper->save($leadEmailSequenceStatusModel);
                                } catch (Exception $e) {
                                    
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    /**
     * Add to queue cart status emails
     */
    public static function addToQueueCartEmails()
    {
        $cartStatusQueueMapper = Emailsequence_Models_Mapper_EmailsequenceQueueMapper::getInstance();
        $sequenceConfig = Leads_Mapper_LeadsHasEmailSequenceMapper::getInstance()->getEmailSequenceConfig();
        $leadMapper = Leads_Mapper_LeadsMapper::getInstance();
        $cartStatusDbtable = new Emailsequence_Models_Dbtables_EmailSequenceSettingsDbtable();
        if (!empty($sequenceConfig)) {
            foreach ($sequenceConfig as $statusCart) {
                $cartStatus = $statusCart['cartStatus'];
                $newCartStatus = $statusCart['cartStatus'];
                $period = $statusCart['period'];
                $productsIds = $statusCart['productsIds'];
                $emailTemplate = $statusCart['emailTemplate'];
                $emailFrom = $statusCart['emailFrom'];
                $emailMessage = $statusCart['emailMessage'];
                $productRule = $statusCart['productsRule'];
                $productsIds = explode(',', $productsIds);
                $cartStatusId = $statusCart['trigger_id'];
                $lagType = $statusCart['lagType'];
                $sequenceOnly = $statusCart['sequenceOnly'];
                $leadEmails = explode(',', $statusCart['lead_emails']);
                $sequenceId = $statusCart['sequenceId'];
                $subject = $statusCart['subject'];
                $preheader = $statusCart['preheader'];

                $where = '';
                if (isset($cartStatus) && ($cartStatus == Models_Model_CartSession::CART_STATUS_PENDING || $cartStatus == Models_Model_CartSession::CART_STATUS_PROCESSING || $cartStatus == Models_Model_CartSession::CART_STATUS_CANCELED)) {
                    $where = $cartStatusDbtable->getAdapter()->quoteInto('gateway <> ?',
                        Emailsequence::GATEWAY_QUOTE);
                }
                if (isset($cartStatus) && ($cartStatus == Tools_Misc::CS_ALIAS_PENDING)) {
                    $cartStatus = Models_Model_CartSession::CART_STATUS_PENDING;
                    $where = $cartStatusDbtable->getAdapter()->quoteInto('gateway = ?',
                        Emailsequence::GATEWAY_QUOTE);
                }
                if (isset($cartStatus) && $cartStatus == Tools_Misc::CS_ALIAS_PROCESSING) {
                    $cartStatus = Models_Model_CartSession::CART_STATUS_PROCESSING;
                    $where = $cartStatusDbtable->getAdapter()->quoteInto('gateway = ?',
                        Emailsequence::GATEWAY_QUOTE);
                }
                if (isset($cartStatus) && $cartStatus == Tools_Misc::CS_ALIAS_LOST_OPPORTUNITY) {
                    $cartStatus = Models_Model_CartSession::CART_STATUS_CANCELED;
                    $where = $cartStatusDbtable->getAdapter()->quoteInto('gateway = ?',
                        Emailsequence::GATEWAY_QUOTE);
                }
                if (!empty($where)) {
                    $where .= ' AND ' . $cartStatusDbtable->getAdapter()->quoteInto('shcs.status = ?',
                            $cartStatus);
                } else {
                    $where = $cartStatusDbtable->getAdapter()->quoteInto('shcs.status = ?', $cartStatus);
                }

                if (!empty($where)) {
                    $where .= ' AND ' . $cartStatusDbtable->getAdapter()->quoteInto('u.email IN (?)',
                            $leadEmails);
                } else {
                    $where = $cartStatusDbtable->getAdapter()->quoteInto('u.email IN (?)', $leadEmails);
                }

                $lagType = strtoupper($lagType);
                $limitPeriod = $period + 24;
                if ($lagType === 'DAY') {
                    $limitPeriod = $period + 1;
                }

                $where .= " AND DATE_SUB(NOW(), INTERVAL $period $lagType) > `updated_at`";
                if ($lagType !== 'MONTH') {
                    $where .= " AND DATE_SUB(NOW(), INTERVAL $limitPeriod $lagType) < `updated_at`";
                } else {
                    $where .= " AND DATE_SUB(DATE_SUB(NOW(), INTERVAL $period $lagType), INTERVAL 24 HOUR) < `updated_at`";
                }

                if ($productRule == Emailsequence::PRODUCT_RULE_ALL || $productRule == Emailsequence::PRODUCT_RULE_ANY) {
                    $idsQuantity = count($productsIds);
                    if ($idsQuantity > 1) {
                        foreach ($productsIds as $key => $ids) {
                            if ($key == 0) {
                                $where .= ' AND (' . $cartStatusDbtable->getAdapter()->quoteInto('product_id = ?',
                                        $ids);
                            } else {
                                $where .= ' OR ' . $cartStatusDbtable->getAdapter()->quoteInto('product_id = ?',
                                        $ids);
                            }
                        }
                        $where .= ')';
                    } else {
                        $where .= ' AND ' . $cartStatusDbtable->getAdapter()->quoteInto('product_id = ?',
                                $productsIds[0]);
                    }
                }

                $where .= ' AND (' . $cartStatusDbtable->getAdapter()->quoteInto('pcs.status = ?',
                        Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED);
                $where .= ' OR ' . new Zend_Db_Expr('pcs.status IS NULL') . ')';

                if (!empty($sequenceOnly)) {
                    if ($productRule == Emailsequence::PRODUCT_RULE_ALL) {
                        $select = $cartStatusDbtable->select()
                            ->setIntegrityCheck(false)
                            ->from(array('shcs' => 'shopping_cart_session'),
                                array('shcs.id', 'cartCount' => 'count(shcs.id)', 'shcs.user_id'))
                            ->joinleft(array('shcsc' => 'shopping_cart_session_content'),
                                'shcs.id = shcsc.cart_id', array('cartId' => 'shcs.id'))
                            ->joinleft(array('u' => 'user'), 'shcs.user_id = u.id',
                                array('userEmail' => 'u.email', 'userFullName' => 'u.full_name'))
                            ->joinLeft(array('pcs' => 'plugin_cartstatusemail_subscribe'),
                                'pcs.user_id=u.id',
                                array())
                            ->where($where)->group('shcs.id')->having('cartCount > ' . ($idsQuantity - 1));
                    } else {
                        $select = $cartStatusDbtable->select()
                            ->setIntegrityCheck(false)
                            ->from(array('shcs' => 'shopping_cart_session'),
                                array('shcs.id', 'cartCount' => 'count(shcs.id)', 'shcs.user_id'))
                            ->joinleft(array('shcsc' => 'shopping_cart_session_content'),
                                'shcs.id = shcsc.cart_id', array('cartId' => 'shcs.id'))
                            ->joinleft(array('u' => 'user'), 'shcs.user_id = u.id',
                                array('userEmail' => 'u.email', 'userFullName' => 'u.full_name'))
                            ->joinLeft(array('pcs' => 'plugin_cartstatusemail_subscribe'),
                                'pcs.user_id=u.id',
                                array())
                            ->where($where)->group('shcs.id');
                    }
                    $resultCarts = $cartStatusDbtable->getAdapter()->fetchAssoc($select);
                    if (!empty($resultCarts)) {
                        foreach ($resultCarts as $cart) {
                            $cartStatusQueueModel = new Emailsequence_Models_Models_EmailsequenceQueueModel();
                            $cartId = $cart['cartId'];
                            $userEmail = $cart['userEmail'];
                            $userId = $cart['user_id'];
                            if ($userEmail != null) {
                                $emailQueueExist = $cartStatusQueueMapper->selectFromQueue($cartStatusId,
                                    $cartId, $userEmail);
                                if (empty($emailQueueExist)) {
                                    $cartStatusSubscribeMapper = Emailsequence_Models_Mapper_SubscribeMapper::getInstance();
                                    $subscribeExists = $cartStatusSubscribeMapper->findByUserId($userId);
                                    $cartStatusSubscribeSmsMapper = Emailsequence_Models_Mapper_SubscribeSmsMapper::getInstance();
                                    $subscribeSmsExists = $cartStatusSubscribeSmsMapper->findByUserId($userId);
                                    $addToQueue = false;
                                    $addToQueueSms = false;
                                    if (empty($subscribeExists)) {
                                        $cartStatusSubscribeModel = new Emailsequence_Models_Models_SubscribeModel();
                                        $cartStatusSubscribeModel->setUserId($userId);
                                        $cartStatusSubscribeModel->setCode(sha1(uniqid(strtotime('now'))));
                                        $cartStatusSubscribeModel->setStatus(Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED);
                                        $cartStatusSubscribeMapper->save($cartStatusSubscribeModel);
                                        $addToQueue = true;
                                    } elseif ($subscribeExists['status'] === Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED) {
                                        $addToQueue = true;
                                    }

                                    if (empty($subscribeSmsExists)) {
                                        $mobilePhoneUser = Tools_EmailSequenceTools::glueUserPhone($cart['userMobileCode'], $cart['userMobile'], $cart['userPhoneCode'], $cart['userPhone']);
                                        $cartStatusSubscribeSmsModel = new Emailsequence_Models_Models_SubscribeSmsModel();
                                        $cartStatusSubscribeSmsModel->setUserId($userId);
                                        $cartStatusSubscribeSmsModel->setCode(sha1(uniqid(strtotime('now'))));
                                        $cartStatusSubscribeSmsModel->setStatus(Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED);
                                        $cartStatusSubscribeSmsModel->setExternal(0);
                                        $cartStatusSubscribeSmsModel->setExternalEmail('');
                                        $cartStatusSubscribeSmsModel->setMobileNumber($mobilePhoneUser);
                                        $cartStatusSubscribeSmsMapper->save($cartStatusSubscribeSmsModel);
                                        $addToQueueSms = true;
                                    } elseif ($subscribeSmsExists['status'] === Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED) {
                                        $addToQueueSms = true;
                                    }

                                    $leadModel = $leadMapper->findByEmail($userEmail);
                                    $leadId = 0;
                                    if ($leadModel instanceof Leads_Model_LeadsModel) {
                                        $leadId = $leadModel->getId();
                                    }

                                    if ($addToQueue || $addToQueueSms) {
                                        $cartStatusQueueModel->setCartId($cartId);
                                        $cartStatusQueueModel->setStatus(0);
                                        $cartStatusQueueModel->setCartStatusId($cartStatusId);
                                        $cartStatusQueueModel->setUserEmail($userEmail);
                                        $cartStatusQueueModel->setUserFullName($cart['userFullName']);
                                        $cartStatusQueueModel->setCartStatus($newCartStatus);
                                        $cartStatusQueueModel->setEmailMessage($emailMessage);
                                        $cartStatusQueueModel->setEmailFrom($emailFrom);
                                        $cartStatusQueueModel->setEmailTemplate($emailTemplate);
                                        $cartStatusQueueModel->setExternalId($leadId);
                                        $cartStatusQueueModel->setExternalType(Leads::CART_STATUS_PLUGIN_EXTERNAL_TYPE);
                                        $cartStatusQueueModel->setSequenceId($sequenceId);
                                        $cartStatusQueueModel->setSubject($subject);
                                        $cartStatusQueueModel->setPreheader($preheader);
                                        $cartStatusQueueMapper->save($cartStatusQueueModel);
                                    }
                                }

                            }
                        }

                    }
                }
            }
        }
    }

    /**
     *
     * Send email on logged user email for sent and upcoming lead sequence email
     *
     * @param Emailsequence_Models_Models_EmailsequenceQueueModel $emailModel
     * @return array
     */
    public static function sendCartStatusEmail(Emailsequence_Models_Models_EmailsequenceQueueModel $emailModel)
    {
        $cartstatusemailSubscribeMapper = Emailsequence_Models_Mapper_SubscribeMapper::getInstance();
        $subscriptionExists = $cartstatusemailSubscribeMapper->findByEmail($emailModel->getUserEmail());

        if(empty($subscriptionExists)) {
            $subscriptionExists = $cartstatusemailSubscribeMapper->findByExternalLeadEmail($emailModel->getUserEmail());
        }
        $unsubscribeCode = '';
        if (!empty($subscriptionExists) && $subscriptionExists['status'] === Emailsequence::SUBSCRIBED_STATUS_SUBSCRIBED) {
            $unsubscribeCode = $subscriptionExists['code'];
        }
        $orderId = $emailModel->getCartId();
        $cartStatus = $emailModel->getCartStatus();
        $cartStatusQueueMapper = Emailsequence_Models_Mapper_EmailsequenceQueueMapper::getInstance();
        $selectActiveActionEmailTriggers = $cartStatusQueueMapper->getDbtable()->select()->setIntegrityCheck(false)->from('email_triggers_actions',
            array('trigger', 'id'));
        $activeActionEmailTriggers = $cartStatusQueueMapper->getDbTable()->getAdapter()->fetchAssoc($selectActiveActionEmailTriggers);
        if (in_array($cartStatus, Emailsequence::$cartStatuses)) {
            if (!Zend_Registry::isRegistered('postPurchaseCart')) {
                $cart = Models_Mapper_CartSessionMapper::getInstance()->find(
                    $orderId
                );
                if ($cart instanceof Models_Model_CartSession) {
                    $productMapper = Models_Mapper_ProductMapper::getInstance();
                    $cartContent = $cart->getCartContent();
                    foreach ($cartContent as $key => $product) {
                        $productObject = $productMapper->find($product['product_id']);
                        if ($productObject instanceof Models_Model_Product) {
                            $cartContent[$key]['mpn'] = $productObject->getMpn();
                            $cartContent[$key]['photo'] = $productObject->getPhoto();
                            $cartContent[$key]['productUrl'] = $productObject->getPage()->getUrl();
                            $cartContent[$key]['taxRate'] = Tools_Tax_Tax::calculateProductTax($productObject,
                                null, true);
                        }
                    }
                    $cart->setCartContent($cartContent);
                    $billingAddressId = $cart->getBillingAddressId();
                    if (null !== $billingAddressId) {
                        $cart->setBillingAddressId(Tools_ShoppingCart::getAddressById($billingAddressId));
                    }
                    $shippingAddressId = $cart->getShippingAddressId();
                    if (null !== $shippingAddressId) {
                        $cart->setShippingAddressId(Tools_ShoppingCart::getAddressById($shippingAddressId));
                    }

                }
                Zend_Registry::set('postPurchaseCart', $cart);
                if ($cart instanceof Models_Model_CartSession && !Zend_Registry::isRegistered('postPurchasePickup') && $cart->getShippingService() === 'pickup') {
                    $pickupLocationConfigMapper = Store_Mapper_PickupLocationConfigMapper::getInstance();
                    $pickupLocationData = $pickupLocationConfigMapper->getCartPickupLocationByCartId($cart->getId());
                    if (empty($pickupLocationData)) {
                        $shoppingConfig = Models_Mapper_ShoppingConfig::getInstance()->getConfigParams();
                        $pickupLocationData = array(
                            'name' => $shoppingConfig['company'],
                            'address1' => $shoppingConfig['address1'],
                            'address2' => $shoppingConfig['address2'],
                            'country' => $shoppingConfig['country'],
                            'city' => $shoppingConfig['city'],
                            'state' => $shoppingConfig['state'],
                            'zip' => $shoppingConfig['zip'],
                            'phone' => $shoppingConfig['phone']
                        );
                    }
                    $pickupLocationData['map_link'] = 'https://maps.google.com/?q=' . $pickupLocationData['address1'] . '+' . $pickupLocationData['city'] . '+' . $pickupLocationData['state'];
                    $pickupLocationData['map_src'] = Tools_Geo::generateStaticGmaps($pickupLocationData,
                        640,
                        300);
                    Zend_Registry::set('postPurchasePickup', $pickupLocationData);
                }
            }

            $orderModel = Models_Mapper_CartSessionMapper::getInstance()->find($orderId);
            $userId = 0;
            if ($orderModel instanceof Models_Model_CartSession) {
                $userId = $orderModel->getUserId();
            }
        }

        $emailTriggerName = self::prepareEmailTriggerName($emailModel->getCartStatus());
        if (!array_key_exists($emailTriggerName, $activeActionEmailTriggers)) {
            return array('error' => '1', 'message' => 'missing action email trigger');
        }

        $sessionHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('session');

        $userSession = $sessionHelper->getCurrentUser();
        $currentLoggedUserEmail = $userSession->getEmail();
        $currentLoggedUserFullName = $userSession->getFullName();
        $emailModel->setUserEmail($currentLoggedUserEmail);
        $emailModel->setUserFullName($currentLoggedUserFullName);

        if (in_array($cartStatus, Emailsequence::$cartStatuses)) {
            $emailModel->registerObserver(new Tools_Mail_Watchdog(array(
                'trigger' => $emailTriggerName,
                'unsubscribeCode' => $unsubscribeCode,
                'userId' => $userId,
                'cartStatus' => $cartStatus,
                'silentMode' => true,
                'recipient' => Tools_EmailsequenceMailWatchdog::ROLE_CUSTOMER
            )));
        } else {
            $emailModel->registerObserver(new Tools_Mail_Watchdog(array(
                'trigger' => $emailTriggerName,
                'unsubscribeCode' => $unsubscribeCode,
                'silentMode' => true,
                'recipient' => Tools_EmailsequenceMailWatchdog::ROLE_CUSTOMER
            )));
        }
        $emailModel->notifyObservers();
    }

    /**
     *
     * @param string $cartStatus cart status
     * @return string
     */
    public static function prepareEmailTriggerName($cartStatus){
        switch ($cartStatus) {
            case Models_Model_CartSession::CART_STATUS_NEW:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_ABANDONED;
                break;
            case Models_Model_CartSession::CART_STATUS_PENDING:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_ACTION_REQUIRE;
                break;
            case Models_Model_CartSession::CART_STATUS_PROCESSING:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_TECHNICAL_PROCESSING;
                break;
            case Models_Model_CartSession::CART_STATUS_COMPLETED:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_PAYMENT_RECEIVED;
                break;
            case Models_Model_CartSession::CART_STATUS_SHIPPED:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_ITEMS_SHIPPED;
                break;
            case Models_Model_CartSession::CART_STATUS_DELIVERED:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_ITEMS_DELIVERED;
                break;
            case Models_Model_CartSession::CART_STATUS_REFUNDED:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_REFUNDED_PURCHASE;
                break;
            case Tools_Misc::CS_ALIAS_PENDING:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_NEWQUOTE;
                break;
            case Tools_Misc::CS_ALIAS_PROCESSING:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_QUOTESENT;
                break;
            case Tools_Misc::CS_ALIAS_LOST_OPPORTUNITY:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_LOST_OPPORTUNITY;
                break;
            default:
                $emailTriggerName = Tools_EmailsequenceMailWatchdog::TRIGGER_CART_STATUS_DEFAULT;
                break;
        }
        return $emailTriggerName;
    }

}
