<?php

/**
 * Class Tools_LeadExternalNotificationsTools
 */
class Tools_LeadExternalNotificationsTools
{


    public static function addToExternalNotificationsLog($leadModel, $oldLeadModel)
    {
        if ($oldLeadModel instanceof Leads_Model_LeadsModel && $leadModel instanceof Leads_Model_LeadsModel) {
            $leadsExternalNotificationsMapper = Leads_Mapper_LeadsExternalNotificationsMapper::getInstance();
            $leadsExternalNotificationsModel = new Leads_Model_LeadsExternalNotificationsModel();
            $currentLeadHash = md5(implode(',', $leadModel->toArray()));
            $oldLeadHash = md5(implode(',', $oldLeadModel->toArray()));
            if ($currentLeadHash !== $oldLeadHash) {
                $leadsExternalNotificationsModel->setLeadId($oldLeadModel->getId());
                $leadsExternalNotificationsModel->setCreatedAt(Tools_System_Tools::convertDateFromTimezone('now'));
                $leadsExternalNotificationsModel->setStatus(Leads_Model_LeadsExternalNotificationsModel::STATUS_SCHEDULEDED);
                $leadsExternalNotificationsMapper->save($leadsExternalNotificationsModel);
            }
        }
    }

    /**
     * process external notifications
     */
    public static function processExternalNotifications()
    {
        $leadsExternalNotificationsMapper = Leads_Mapper_LeadsExternalNotificationsMapper::getInstance();
        $notSendNotifications = $leadsExternalNotificationsMapper->getNotSendNotifications();

        if (!empty($notSendNotifications)) {
            self::notifyExternalEndpoints($notSendNotifications);
        }
    }

    /**
     * Notify external endpoints
     *
     * @param array $notSendNotifications not send notifications
     * @throws Zend_Reflection_Exception
     */
    public static function notifyExternalEndpoints(array $notSendNotifications)
    {
        $leadsExternalNotificationsMapper = Leads_Mapper_LeadsExternalNotificationsMapper::getInstance();
        $notificationEndpoints = $leadsExternalNotificationsMapper->getNotificationEndpoints();
        $leadMapper = Leads_Mapper_LeadsMapper::getInstance();
        if (!empty($notificationEndpoints)) {
            $notificationIds = array();
            $leadIdsData = array();
            foreach ($notSendNotifications as $notificationId => $notificationData) {
                $notificationIds[$notificationId] = $notificationId;
                $leadIdsData[$notificationData['lead_id']] = $notificationData;
            }

            $leadIds = array_keys($leadIdsData);
            $where = $leadMapper->getDbTable()->getAdapter()->quoteInto('pld.id IN (?)', $leadIds);
            $leadsData = $leadMapper->fetchAll($where, null, null, null, true);
            if (!empty($leadsData)) {
                foreach ($notificationEndpoints as $notificationEndpoint) {
                    $methodName = 'notify' . ucfirst($notificationEndpoint['method_name']);
                    $class = new Zend_Reflection_Class(self::class);
                    $actionExists = $class->hasMethod($methodName);
                    if ($actionExists === true) {
                        $verifyAction = $class->getMethod($methodName);
                        if (!$verifyAction->isStatic()) {
                            continue;
                        }

                        self::$methodName(array('leadData' =>$leadsData));
                    }

                }
            }

            $leadsExternalNotificationsMapper->changeStatuses($notificationIds, Leads_Model_LeadsExternalNotificationsModel::STATUS_SENT);

        }

    }


    public static function notifyCrmLeadInfo($leadsData)
    {
        $response = Apps::apiCall('POST', 'apps', array('crmLeadInfo'), $leadsData);
    }

}
