<?php

/**
 * Class Lead_LeadFormBuilderTools
 */
class Tools_LeadFormBuilderTools
{

    const FORM_FIELD_TYPE_INPUT_TEXT = 'input-text';

    const FORM_FIELD_TYPE_TEXTAREA = 'textarea';

    const FORM_FIELD_TYPE_CHECKBOX = 'checkbox';

    const FORM_FIELD_TYPE_RADIO = 'radio';

    const FORM_FIELD_TYPE_DROPDOWN = 'dropdown';

    const FORM_FIELD_TYPE_DATE = 'date';

    const FORM_FIELD_TYPE_PREDEFINED_NAME = 'name';

    const FORM_FIELD_TYPE_PREDEFINED_EMAIL  = 'email';

    const FORM_FIELD_TYPE_GROUP  = 'group';

    const FORM_FIELD_SYSTEM_TYPE_CRM = 'crm';

    const FORM_TYPE_EXTERNAL = 'external';

    const FORM_TYPE_INTERNAL = 'internal';

    const FORM_FIELD_SUBTYPE_FIRST_NAME = 'name';

    const FORM_FIELD_SUBTYPE_LAST_NAME = 'lastname';

    const FORM_FIELD_SUBTYPE_PREFIX = 'prefix';

    const FORM_FIELD_SUBTYPE_EMAIL = 'email';

    const FORM_FIELD_SUBTYPE_POSITION = 'position';

    const FORM_FIELD_SUBTYPE_PHONE = 'phone';

    const FORM_FIELD_SUBTYPE_MOBILE = 'mobile';

    const FORM_FIELD_SUBTYPE_TAG_NAME = 'tag-name';

    const FORM_FIELD_SUBTYPE_ADDRESS = 'address';

    const FORM_FIELD_SUBTYPE_ADDRESS1 = 'address1';

    const FORM_FIELD_SUBTYPE_CITY = 'city';

    const FORM_FIELD_SUBTYPE_ZIP = 'zip';

    const FORM_FIELD_SUBTYPE_STATE = 'state';

    const FORM_FIELD_SUBTYPE_COUNTRY = 'country';

    const FORM_FIELD_SUBTYPE_GROUP_NAME = 'group-name';

    /**
     * Crm fields
     *
     * @var array
     */
    public static $_crmFormFields = array(
        self::FORM_FIELD_SUBTYPE_FIRST_NAME,
        self::FORM_FIELD_SUBTYPE_LAST_NAME,
        self::FORM_FIELD_SUBTYPE_PREFIX,
        self::FORM_FIELD_SUBTYPE_EMAIL,
        self::FORM_FIELD_SUBTYPE_POSITION,
        self::FORM_FIELD_SUBTYPE_PHONE,
        self::FORM_FIELD_SUBTYPE_MOBILE,
        self::FORM_FIELD_SUBTYPE_TAG_NAME,
        self::FORM_FIELD_SUBTYPE_ADDRESS,
        self::FORM_FIELD_SUBTYPE_ADDRESS1,
        self::FORM_FIELD_SUBTYPE_CITY,
        self::FORM_FIELD_SUBTYPE_ZIP,
        self::FORM_FIELD_SUBTYPE_STATE,
        self::FORM_FIELD_SUBTYPE_COUNTRY,
        self::FORM_FIELD_SUBTYPE_GROUP_NAME
    );

    /**
     * crm form fields with predefined content
     *
     * @var array
     */
    public static $_crmFormFieldsWithPredefinedData = array(
        self::FORM_FIELD_SUBTYPE_PHONE,
        self::FORM_FIELD_SUBTYPE_MOBILE,
        self::FORM_FIELD_SUBTYPE_TAG_NAME,
        self::FORM_FIELD_SUBTYPE_COUNTRY,
        self::FORM_FIELD_SUBTYPE_GROUP_NAME
    );

    public static $_crmFormFieldsWithPredefinedDataDropdown = array(
        self::FORM_FIELD_SUBTYPE_TAG_NAME,
        self::FORM_FIELD_SUBTYPE_COUNTRY,
        self::FORM_FIELD_SUBTYPE_GROUP_NAME,
        self::FORM_FIELD_SUBTYPE_STATE
    );


    /**
     * Generate form preview code
     *
     * @param array $formFieldsData form fields data
     * @param string $formType form type
     * @param string $formSignature form signature
     * @param array $data form data
     * @return string
     * @throws Exceptions_SeotoasterPluginException
     */
    public static function generatePreviewCode($formFieldsData, $formType = 'internal', $formSignature = '', $data = array())
    {
        $websiteHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('website');
        $websiteUrl = $websiteHelper->getUrl();
        $leadsPlugin = Tools_Factory_PluginFactory::createPlugin('leads', array(),
            array('websiteUrl' => $websiteUrl));

        return $leadsPlugin->generatePreviewCode($formFieldsData, $formType, $formSignature, $data);
    }

}