<?php

/**
 * Class Lead_LeadGoalsTools
 */
class Tools_LeadGoalsTools
{


    public static function calculateGoalOppStats($goalId)
    {

        $statsData = array(
            'goalTotalOppAmount' => '0',
            'goalTotalOppCount' => '0'
        );

        $leadsOwnerGoalsOpportunitiesMapper = Leads_Mapper_LeadsOwnerGoalsOpportunitiesMapper::getInstance();
        $goalOpportunitiesData = $leadsOwnerGoalsOpportunitiesMapper->findByGoalId($goalId);
        foreach ($goalOpportunitiesData as $oppData) {
            $statsData['goalTotalOppAmount'] += $oppData['opportunity_amount'];
            $statsData['goalTotalOppCount'] += $oppData['opportunity_count'];
        }

        $currency = Zend_Registry::get('Zend_Currency');
        $statsData['goalTotalOppAmount'] = $currency->toCurrency($statsData['goalTotalOppAmount']);

        return $statsData;

    }

    public static function calculateGlobalStats()
    {

        $globalStats = array(
            'globalOppAmount' => 0,
            'globalOppCount' => 0,
            'globalOppAmountYear' => 0,
            'globalOppCountYear' => 0,
            'globalQuotas' => 0,
            'globalSalesObjectives' => 0,
            'globalSalesObjectiveYear' => 0,
            'globalQuotasYear' => 0,
            'globalMeetingsHeld' => 0,
            'globalMeetingsHeldYear' => 0,
            'globalCallsPlaced' => 0,
            'globalCallsPlacedYear' => 0,
            'globalEmailsSent' => 0,
            'globalEmailsSentYear' => 0
        );

        $leadsOwnerGoalsOpportunitiesMapper = Leads_Mapper_LeadsOwnerGoalsOpportunitiesMapper::getInstance();
        $goalOpportunitiesData = $leadsOwnerGoalsOpportunitiesMapper->getAllOpportunities();
        foreach ($goalOpportunitiesData as $opportunitiesData) {
            $globalStats['globalOppAmount'] += $opportunitiesData['opportunity_amount'];
            $globalStats['globalOppCount'] += $opportunitiesData['opportunity_count'];
        }

        $globalStats['globalOppAmountYear'] = $globalStats['globalOppAmount']*12;
        $globalStats['globalOppCountYear'] = $globalStats['globalOppCount']*12;


        $currency = Zend_Registry::get('Zend_Currency');
        $leadsOwnerGoalsMapper = Leads_Mapper_LeadsOwnerGoalsMapper::getInstance();
        $goalsData = $leadsOwnerGoalsMapper->fetchAllData(null, null,null, null, true);
        if (!empty($goalsData)) {
            foreach ($goalsData as $goalData) {
                $globalStats['globalQuotas'] += $goalData['quotes_amount'];
                $globalStats['globalMeetingsHeld'] += $goalData['meetings_held'];
                $globalStats['globalCallsPlaced'] += $goalData['calls_placed'];
                $globalStats['globalEmailsSent'] += $goalData['emails_sent'];
                $globalStats['globalSalesObjectives'] += $goalData['quote_objective'];
            }
        }

        $globalStats['globalQuotasYear'] = $globalStats['globalQuotas']*12;
        $globalStats['globalMeetingsHeldYear'] = $globalStats['globalMeetingsHeld']*12;
        $globalStats['globalCallsPlacedYear'] = $globalStats['globalCallsPlaced']*12;
        $globalStats['globalEmailsSentYear'] = $globalStats['globalEmailsSent']*12;
        $globalStats['globalSalesObjectiveYear'] = $globalStats['globalSalesObjectives']*12;


        $globalStats['globalOppAmount'] = $currency->toCurrency($globalStats['globalOppAmount']);
        $globalStats['globalOppAmountYear'] = $currency->toCurrency($globalStats['globalOppAmountYear']);
        $globalStats['globalQuotas'] = $currency->toCurrency($globalStats['globalQuotas']);
        $globalStats['globalQuotasYear'] = $currency->toCurrency($globalStats['globalQuotasYear']);
        $globalStats['globalSalesObjectives'] = $currency->toCurrency($globalStats['globalSalesObjectives']);
        $globalStats['globalSalesObjectiveYear'] = $currency->toCurrency($globalStats['globalSalesObjectiveYear']);

        return $globalStats;
    }

}