<?php

/**
 * Class Tools_LeadInternalNotificationsTools
 */
class Tools_LeadInternalNotificationsTools
{

    /**
     * Add to internal notifications
     *
     * @param $leadModel
     * @param $oldLeadModel
     */
    public static function addToInternalNotificationsLog($leadModel, $oldLeadModel)
    {
        $leadsInternalNotificationsMapper = Leads_Mapper_LeadsInternalNotificationsMapper::getInstance();
        $leadsInternalNotificationsModel = new Leads_Model_LeadsInternalNotificationsModel();
        if ($oldLeadModel instanceof Leads_Model_LeadsModel && $leadModel instanceof Leads_Model_LeadsModel) {
            $currentLeadHash = md5(implode(',', $leadModel->toArray()));
            $oldLeadHash = md5(implode(',', $oldLeadModel->toArray()));
            if ($currentLeadHash !== $oldLeadHash) {
                $leadsInternalNotificationsModel->setLeadId($oldLeadModel->getId());
                $leadsInternalNotificationsModel->setCreatedAt(Tools_System_Tools::convertDateFromTimezone('now'));
                $leadsInternalNotificationsModel->setStatus(Leads_Model_LeadsInternalNotificationsModel::STATUS_SCHEDULEDED);
                $leadsInternalNotificationsMapper->save($leadsInternalNotificationsModel);
            }
        } elseif ($leadModel instanceof Leads_Model_LeadsModel) {
            $leadsInternalNotificationsModel->setLeadId($leadModel->getId());
            $leadsInternalNotificationsModel->setCreatedAt(Tools_System_Tools::convertDateFromTimezone('now'));
            $leadsInternalNotificationsModel->setStatus(Leads_Model_LeadsExternalNotificationsModel::STATUS_SCHEDULEDED);
            $leadsInternalNotificationsMapper->save($leadsInternalNotificationsModel);
        }
    }

    /**
     * process internal notifications
     */
    public static function processInternalNotifications()
    {
        $leadsInternalNotificationsMapper = Leads_Mapper_LeadsInternalNotificationsMapper::getInstance();
        $notSendNotifications = $leadsInternalNotificationsMapper->getNotSendNotifications();

        if (!empty($notSendNotifications)) {
            self::notifyInternalEndpoints($notSendNotifications);
        }
    }


    /**
     * Notify internal endpoints
     *
     * @param array $notSendNotifications not send notifications
     * @throws Zend_Reflection_Exception
     */
    public static function notifyInternalEndpoints(array $notSendNotifications)
    {
        $leadsInternalNotificationsMapper = Leads_Mapper_LeadsInternalNotificationsMapper::getInstance();

        $notificationIds = array();
        $leadIdsData = array();
        foreach ($notSendNotifications as $notificationId => $notificationData) {
            $notificationIds[$notificationId] = $notificationId;
            $leadIdsData[$notificationData['lead_id']] = $notificationData;
        }

        $pluginsToNotify = Tools_Plugins_Tools::getPluginsByTags(array('syncleads'));

        $leadIds = array_keys($leadIdsData);
        if (!empty($leadIds) && !empty($pluginsToNotify)) {
            foreach ($pluginsToNotify as $plugin) {
                $methodName = 'localLeadNotification';
                Tools_System_Tools::firePluginMethodByPluginName($plugin->getName(), $methodName, $leadIds);
            }
        }

        $leadsInternalNotificationsMapper->changeStatuses($notificationIds,
            Leads_Model_LeadsInternalNotificationsModel::STATUS_SENT);

    }


}
