<?php

/**
 * Class Lead_LeadMeetingTools
 */
class Tools_LeadMeetingTools
{

    public static function processMeetingRemindersEmails()
    {
        $leadsMeetingMapper = Leads_Mapper_LeadsMeetingMapper::getInstance();
        $leadMapper = Leads_Mapper_LeadsMapper::getInstance();
        $firstMeetingsForNotifications = $leadsMeetingMapper->getFirstMeetingsForNotifications();
        if (!empty($firstMeetingsForNotifications)) {
            foreach ($firstMeetingsForNotifications as $firstMeetingsForNotification) {
                $leadModel = $leadMapper->find($firstMeetingsForNotification['lead_id']);
                if ($leadModel instanceof Leads_Model_LeadsModel) {
                    $meetingId = $firstMeetingsForNotification['id'];
                    $leadMeetingModel = $leadsMeetingMapper->find($meetingId);
                    $sendSms = false;
                    $phoneNumber = '';
                    if (!empty($leadMeetingModel->getSendNotificationSms())) {
                        $leadMobile = $leadModel->getLeadMobile();
                        if (empty($leadMobile)) {
                            $leadPhone = $leadModel->getLeadPhone();
                            if (!empty($phoneNumber)) {
                                $phoneNumber = $leadModel->getLeadPhoneCountryCodeValue() . $leadPhone;
                            }
                        } else {
                            $phoneNumber = $leadModel->getLeadMobileCountryCodeValue() . $leadMobile;
                        }

                        $phoneNumber = Apps_Tools_Twilio::normalizePhoneNumberToE164($phoneNumber);
                        if (!empty($phoneNumber)) {
                            $sendSms = true;
                        }
                    }

                    $creatorId = $leadMeetingModel->getCreatorId();
                    $userModel = Application_Model_Mappers_UserMapper::getInstance()->find($creatorId);
                    $adminSmsPhoneNumber = '';
                    if ($userModel instanceof Application_Model_Models_User) {
                        $adminMobile = $userModel->getMobilePhone();
                        if (empty($adminMobile)) {
                            $adminPhone = $userModel->getDesktopPhone();
                            if (!empty($adminPhone)) {
                                $adminSmsPhoneNumber = $userModel->getDesktopCountryCodeValue() . $adminPhone;
                            }
                        } else {
                            $adminSmsPhoneNumber = $userModel->getMobileCountryCodeValue() . $adminMobile;
                        }

                        $adminSmsPhoneNumber = Apps_Tools_Twilio::normalizePhoneNumberToE164($adminSmsPhoneNumber);
                    }

                    $leadMeetingModel->registerObserver(new Tools_Mail_Watchdog(array(
                        'trigger' => Tools_LeadsMailWatchdog::LEADS_MEETING_REMINDER,
                        'leadModel' => $leadModel,
                        'params' => $firstMeetingsForNotification,
                        'sendSms' => $sendSms,
                        'smsPhoneNumber' => $phoneNumber,
                        'adminSmsPhoneNumber' => $adminSmsPhoneNumber
                    )));

                    $leadMeetingModel->notifyObservers();
                    $leadsMeetingMapper->updateFirstNotificationSent($meetingId);
                }
            }

        }

        $secondMeetingsForNotifications = $leadsMeetingMapper->getSecondMeetingsForNotifications();
        if (!empty($secondMeetingsForNotifications)) {
            foreach ($secondMeetingsForNotifications as $secondMeetingsForNotification) {
                $leadModel = $leadMapper->find($secondMeetingsForNotification['lead_id']);
                if ($leadModel instanceof Leads_Model_LeadsModel) {
                    $meetingId = $secondMeetingsForNotification['id'];
                    $leadMeetingModel = $leadsMeetingMapper->find($meetingId);
                    $sendSms = false;
                    $phoneNumber = '';
                    if (!empty($leadMeetingModel->getSendNotificationSms())) {
                        $leadMobile = $leadModel->getLeadMobile();
                        if (empty($leadMobile)) {
                            $leadPhone = $leadModel->getLeadPhone();
                            if (!empty($phoneNumber)) {
                                $phoneNumber = $leadModel->getLeadPhoneCountryCodeValue() . $leadPhone;
                            }
                        } else {
                            $phoneNumber = $leadModel->getLeadMobileCountryCodeValue() . $leadMobile;
                        }

                        $phoneNumber = Apps_Tools_Twilio::normalizePhoneNumberToE164($phoneNumber);
                        if (!empty($phoneNumber)) {
                            $sendSms = true;
                        }
                    }

                    $creatorId = $leadMeetingModel->getCreatorId();
                    $userModel = Application_Model_Mappers_UserMapper::getInstance()->find($creatorId);
                    $adminSmsPhoneNumber = '';
                    if ($userModel instanceof Application_Model_Models_User) {
                        $adminMobile = $userModel->getMobilePhone();
                        if (empty($adminMobile)) {
                            $adminPhone = $userModel->getDesktopPhone();
                            if (!empty($adminPhone)) {
                                $adminSmsPhoneNumber = $userModel->getDesktopCountryCodeValue() . $adminPhone;
                            }
                        } else {
                            $adminSmsPhoneNumber = $userModel->getMobileCountryCodeValue() . $adminMobile;
                        }

                        $adminSmsPhoneNumber = Apps_Tools_Twilio::normalizePhoneNumberToE164($adminSmsPhoneNumber);
                    }

                    $leadMeetingModel->registerObserver(new Tools_Mail_Watchdog(array(
                        'trigger' => Tools_LeadsMailWatchdog::LEADS_MEETING_REMINDER,
                        'leadModel' => $leadModel,
                        'params' => $secondMeetingsForNotification,
                        'sendSms' => $sendSms,
                        'smsPhoneNumber' => $phoneNumber,
                        'adminSmsPhoneNumber' => $adminSmsPhoneNumber
                    )));

                    $leadMeetingModel->notifyObservers();
                    $leadsMeetingMapper->updateSecondNotificationSent($meetingId);
                }
            }

        }

    }

}