<?php

/**
 * Class Tools_LeadPiwikTools
 */
class Tools_LeadPiwikTools
{

    /**
     * Process piwik log data
     *
     * @param int $websiteId website id
     * @param array $piwikLogData piwik log data
     */
    public static function processPiwikDataLog($websiteId, $piwikLogData)
    {
        foreach ($piwikLogData as $piwikData) {
            if (!empty($piwikData['visitIp'])) {
                $leadIpsData = Leads_Mapper_LeadsIpsMapper::getInstance()->getByIp($piwikData['visitIp']);
                $leadsIpUserProfileLogMapper = Leads_Mapper_LeadsIpUserProfileLogMapper::getInstance();
                $leadsIpUserLogActionDetailsMapper = Leads_Mapper_LeadsIpUserProfileLogActionDetailsMapper::getInstance();
                if (!empty($leadIpsData)) {
                    $type = Leads_Model_LeadsActionLogModel::ACTION_TYPE_INBOUND;
                    $leadType = Leads_Model_LeadsTypeModel::LEAD_INBOUND_WEBSITE_VISIT;
                    $leadTypeModel = Leads_Mapper_LeadsTypeMapper::getInstance()->findByTypeName($leadType);
                    $leadMapper = Leads_Mapper_LeadsMapper::getInstance();
                    foreach ($leadIpsData as $leadIpData) {
                        $leadId = $leadIpData->getLeadId();
                        $actionLeadLogModel = $leadsIpUserProfileLogMapper->getByIdVisit($piwikData['idVisit'], $leadIpData->getLeadId());
                        if (!$actionLeadLogModel instanceof Leads_Model_LeadsIpUserProfileLogModel) {
                            $firstActionDateFormatted = self::getDateFromTimestamp($piwikData['firstActionTimestamp']);
                            $actionLeadLogModel = Tools_LeadTools::logLeadAction(Leads_Model_LeadsActionLogModel::ACTION_VISIT,
                                $leadIpData->getLeadId(), $type, $firstActionDateFormatted, $leadType);

                            $leadModel = $leadMapper->find($leadId);
                            if ($leadTypeModel instanceof Leads_Model_LeadsTypeModel) {
                                $leadModel->setLastActivityTypeId($leadTypeModel->getId());
                                $leadModel->setLastActivitySubtype('');
                                $previousActivity = $leadModel->getLastActivity();
                                $updateLead = false;
                                if (!empty($previousActivity) &&  strtotime($previousActivity) < strtotime($firstActionDateFormatted)) {
                                    $leadModel->setLastActivity($firstActionDateFormatted);
                                    $updateLead = true;
                                } elseif(empty($previousActivity)) {
                                    $leadModel->setLastActivity($firstActionDateFormatted);
                                    $updateLead = true;
                                }
                                if ($updateLead === true) {
                                    $leadMapper->save($leadModel);
                                }
                            }


                            $leadIpUserProfileModel = new Leads_Model_LeadsIpUserProfileLogModel();
                            $leadIpUserProfileModel->setVisitIpAddress($piwikData['visitIp']);
                            $leadIpUserProfileModel->setVisitorId($piwikData['visitorId']);
                            $leadIpUserProfileModel->setIdVisit($piwikData['idVisit']);
                            $leadIpUserProfileModel->setPiwikIdWebsite($piwikData['idSite']);
                            $leadIpUserProfileModel->setGoalConversions($piwikData['goalConversions']);
                            $leadIpUserProfileModel->setSiteCurrency($piwikData['siteCurrency']);
                            $leadIpUserProfileModel->setServerDate($piwikData['serverDate']);
                            $leadIpUserProfileModel->setLastActionDateTime($piwikData['lastActionDateTime']);
                            if (!empty($piwikData['userId'])) {
                                $leadIpUserProfileModel->setPiwikUserId($piwikData['userId']);
                            }

                            $leadIpUserProfileModel->setVisitorType($piwikData['visitorType']);
                            $leadIpUserProfileModel->setVisitConverted($piwikData['visitConverted']);
                            $leadIpUserProfileModel->setVisitCount($piwikData['visitCount']);
                            $leadIpUserProfileModel->setFirstActionTimestamp($firstActionDateFormatted);
                            $leadIpUserProfileModel->setVisitEcommerceStatus($piwikData['visitEcommerceStatus']);
                            $leadIpUserProfileModel->setDaysSinceFirstVisit($piwikData['daysSinceFirstVisit']);
                            $leadIpUserProfileModel->setDaysSinceLastEcommerceOrder($piwikData['daysSinceLastEcommerceOrder']);
                            $leadIpUserProfileModel->setVisitDuration($piwikData['visitDuration']);
                            $leadIpUserProfileModel->setSearches($piwikData['searches']);
                            $leadIpUserProfileModel->setActions($piwikData['actions']);
                            $leadIpUserProfileModel->setReferrerType($piwikData['referrerType']);
                            $leadIpUserProfileModel->setReferrerTypeName($piwikData['referrerTypeName']);
                            $leadIpUserProfileModel->setReferrerName($piwikData['referrerName']);
                            $leadIpUserProfileModel->setReferrerKeyword($piwikData['referrerKeyword']);
                            if (!empty($piwikData['referrerKeywordPosition'])) {
                                $leadIpUserProfileModel->setReferrerKeywordPosition($piwikData['referrerKeywordPosition']);
                            }

                            if (!empty($piwikData['referrerUrl'])) {
                                $leadIpUserProfileModel->setReferrerUrl($piwikData['referrerUrl']);
                            }

                            if (!empty($piwikData['referrerSearchEngineUrl'])) {
                                $leadIpUserProfileModel->setReferrerSearchEngineUrl($piwikData['referrerSearchEngineUrl']);
                            }

                            $leadIpUserProfileModel->setLanguageCode($piwikData['languageCode']);
                            $leadIpUserProfileModel->setDeviceType($piwikData['deviceType']);
                            $leadIpUserProfileModel->setDeviceBrand($piwikData['deviceBrand']);
                            $leadIpUserProfileModel->setDeviceModel($piwikData['deviceModel']);
                            $leadIpUserProfileModel->setOperatingSystem($piwikData['operatingSystem']);
                            $leadIpUserProfileModel->setOperatingSystemName($piwikData['operatingSystemName']);
                            $leadIpUserProfileModel->setOperatingSystemCode($piwikData['operatingSystemCode']);
                            $leadIpUserProfileModel->setOperatingSystemVersion($piwikData['operatingSystemVersion']);
                            $leadIpUserProfileModel->setBrowserFamily($piwikData['browserFamily']);
                            $leadIpUserProfileModel->setBrowserFamilyDescription($piwikData['browserFamilyDescription']);
                            $leadIpUserProfileModel->setBrowser($piwikData['browser']);
                            $leadIpUserProfileModel->setBrowserName($piwikData['browserName']);
                            $leadIpUserProfileModel->setBrowserCode($piwikData['browserCode']);
                            $leadIpUserProfileModel->setBrowserVersion($piwikData['browserVersion']);
                            $leadIpUserProfileModel->setEvents($piwikData['events']);
                            $leadIpUserProfileModel->setContinentCode($piwikData['continentCode']);
                            $leadIpUserProfileModel->setCountryCode($piwikData['countryCode']);
                            $leadIpUserProfileModel->setRegion($piwikData['region']);
                            $leadIpUserProfileModel->setCity($piwikData['city']);
                            $leadIpUserProfileModel->setLocation($piwikData['location']);
                            $leadIpUserProfileModel->setLatitude($piwikData['latitude']);
                            $leadIpUserProfileModel->setLongitude($piwikData['longitude']);
                            $leadIpUserProfileModel->setDaysSinceLastVisit($piwikData['daysSinceLastVisit']);
                            $leadIpUserProfileModel->setLeadId($leadId);
                            $leadIpUserProfileModel->setResolution($piwikData['resolution']);

                            $serverDateFormatted = self::getDateFromTimestamp($piwikData['serverTimestamp']);

                            $leadIpUserProfileModel->setServerTimestamp($serverDateFormatted);
                            $leadIpUserProfileModel->setActionLogId($actionLeadLogModel->getId());
                            $leadIpUserProfileModel->setWebsiteId($websiteId);

                            $leadIpUserProfileModel = $leadsIpUserProfileLogMapper->save($leadIpUserProfileModel);
                            if (!empty($piwikData['actionDetails'])) {
                                foreach ($piwikData['actionDetails'] as $actionDetails) {
                                    $leadIpUserProfileModelActionDetails = new Leads_Model_LeadsIpUserProfileLogActionDetailsModel();

                                    $actionDateTime = self::getDateFromTimestamp($actionDetails['timestamp']);
                                    $urlHost = parse_url($actionDetails['url'], PHP_URL_HOST);
                                    $generationTime = str_replace(',', '.', preg_replace('~[^0-9,].*~ui','', $actionDetails['generationTime']));
                                    $leadIpUserProfileModelActionDetails->setDomainName($urlHost);
                                    $leadIpUserProfileModelActionDetails->setPageGenerationTime($generationTime);
                                    $leadIpUserProfileModelActionDetails->setPageIdAction($actionDetails['pageIdAction']);
                                    $leadIpUserProfileModelActionDetails->setPageTitle($actionDetails['pageTitle']);
                                    if (!empty($actionDetails['timeSpent'])) {
                                        $leadIpUserProfileModelActionDetails->setTimeSpent($actionDetails['timeSpent']);
                                    }
                                    $leadIpUserProfileModelActionDetails->setPageUrl($actionDetails['url']);
                                    $leadIpUserProfileModelActionDetails->setActionDatetime($actionDateTime);
                                    $leadIpUserProfileModelActionDetails->setType($actionDetails['type']);
                                    $leadIpUserProfileModelActionDetails->setUserProfileLogId($leadIpUserProfileModel->getId());
                                    $leadsIpUserLogActionDetailsMapper->save($leadIpUserProfileModelActionDetails);
                                }
                            }
                        }

                    }
                }
            }
        }
    }

    /**
     * Get date from timestamp
     *
     * @param int $timestamp timestamp
     * @return string
     */
    public static function getDateFromTimestamp($timestamp)
    {
        $date = new DateTime();
        $date->setTimestamp($timestamp);
        $date->setTimezone(new DateTimeZone('UTC'));

        return $date->format(Tools_System_Tools::DATE_MYSQL);
    }
}