<?php

class Tools_LeadQuoteWatchdog implements Interfaces_Observer
{

    public function notify($quoteModel)
    {
        $request = Zend_Controller_Front::getInstance()->getRequest();

        if ($quoteModel instanceof Quote_Models_Model_Quote) {

            $formParams = $request->getParams();
            $leadsMapper = Leads_Mapper_LeadsMapper::getInstance();
            $userMapper = Application_Model_Mappers_UserMapper::getInstance();
            if ($request->isPost() || $request->isPut()) {
                $quoteId = $quoteModel->getId();
                $currentLoggedUserId = $quoteModel->getUserId();
                $cartModel = Models_Mapper_CartSessionMapper::getInstance()->find($quoteModel->getCartId());
                $quoteHasBeenSent = false;
                $forceDisplay = false;
                $forceProcessLead = false;
                if ($request->isPut()) {
                    $quoteData = Zend_Json::decode($request->getRawBody());
                    parse_str($quoteData['billing'], $quoteData['billing']);
                    parse_str($quoteData['shipping'], $quoteData['shipping']);
                    if (!empty($quoteData['billing']) && !empty($quoteData['billing']['overwriteQuoteUserBilling'])) {
                        $forceProcessLead = true;
                        $forceProcessLeadType = 'billing';
                    }
                    if (!empty($quoteData['shipping']) && !empty($quoteData['shipping']['overwriteQuoteUserShipping'])) {
                        $forceProcessLead = true;
                        $forceProcessLeadType = 'shipping';
                    }
                }
                if ($cartModel instanceof Models_Model_CartSession && !empty($currentLoggedUserId)) {
                    $quoteStatus = $quoteModel->getStatus();
                    $leadsQuoteLogMapper = Leads_Mapper_LeadsQuoteLogMapper::getInstance();
                    $leadQuoteLogExists = $leadsQuoteLogMapper->findByLastQuoteId($quoteId);
                    $cartTotal = $cartModel->getTotal();
                    if (!empty($leadQuoteLogExists)) {
                        $oldStatus = $leadQuoteLogExists['status'];
                        if ($oldStatus === Quote_Models_Model_Quote::STATUS_NEW && $quoteStatus === Quote_Models_Model_Quote::STATUS_SENT) {
                            $quoteHasBeenSent = true;
                        }
                        if ($oldStatus === $quoteStatus && $leadQuoteLogExists['total'] == $cartTotal && $forceProcessLead === false) {
                            return '';
                        }
                    }

                    if (!Tools_Security_Acl::isAllowed(Shopping::RESOURCE_STORE_MANAGEMENT) && $quoteStatus === Quote_Models_Model_Quote::STATUS_NEW) {
                        $forceDisplay = true;
                    }

                    if (!empty($leadQuoteLogExists) && !empty($leadQuoteLogExists['force_display'])) {
                        $forceDisplay = true;
                    }


                    $currentLoggedUserModel = $userMapper->find($currentLoggedUserId);
                    $currentLoggedUserEmail = $currentLoggedUserModel->getEmail();

                    $leadEmail = '';
                    $firstName = '';
                    $lastName = '';
                    $mobile = '';
                    $phone = '';
                    $zip = '';
                    $address ='';
                    $address1 = '';
                    $position = '';

                    if (!empty($formParams['phone'])) {
                        $formParams['phone'] = preg_replace('~[^\d]~ui', '', $formParams['phone']);
                        if (!empty($formParams['phonecountrycode'])) {
                            $mobileCountryPhoneCode = Zend_Locale::getTranslation($formParams['phonecountrycode'],
                                'phoneToTerritory');
                            $formParams['phone_country_code_value'] = '+' . $mobileCountryPhoneCode;
                        } else {
                            $formParams['phone_country_code_value'] = null;
                        }
                    }

                    if (!empty($formParams['mobile'])) {
                        $formParams['mobile'] = preg_replace('~[^\d]~ui', '', $formParams['mobile']);
                        if (!empty($formParams['mobilecountrycode'])) {
                            $mobileCountryPhoneCode = Zend_Locale::getTranslation($formParams['mobilecountrycode'],
                                'phoneToTerritory');
                            $formParams['mobile_country_code_value'] = '+' . $mobileCountryPhoneCode;
                        } else {
                            $formParams['mobile_country_code_value'] = null;
                        }
                    }

                    if ($request->isPost() && !empty($formParams['email'])) {
                        $leadEmail = $formParams['email'];
                        $formParams = filter_var_array($formParams, FILTER_SANITIZE_STRING);
                        $firstName = Tools_LeadTools::getValue($formParams, 'firstname');
                        $lastName = Tools_LeadTools::getValue($formParams, 'lastname');
                        $mobile = Tools_LeadTools::getValue($formParams, 'mobile');
                        $phone = Tools_LeadTools::getValue($formParams, 'phone');
                        $zip = Tools_LeadTools::getValue($formParams, 'zip');
                        $address = Tools_LeadTools::getValue($formParams, 'address1');
                        $address1 = Tools_LeadTools::getValue($formParams, 'address2');
                        $position = Tools_LeadTools::getValue($formParams, 'position');
                        $prefix = Tools_LeadTools::getValue($formParams, 'prefix');
                        $city = Tools_LeadTools::getValue($formParams, 'city');
                        $countryCode = Tools_LeadTools::getValue($formParams,'country');
                        $stateCode = Tools_LeadTools::getValue($formParams,'state');
                        $mobileCountryCode =  Tools_LeadTools::getValue($formParams,'mobilecountrycode');
                        $phoneCountryCode =  Tools_LeadTools::getValue($formParams,'phonecountrycode');
                    } elseif($request->isPut() && $forceProcessLead === true) {
                        $leadEmail = $quoteData[$forceProcessLeadType]['email'];
                        $firstName = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'firstname');
                        $lastName = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'lastname');
                        $mobile = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'mobile');
                        $phone = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'phone');
                        $zip = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'zip');
                        $address = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'address1');
                        $address1 = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'address2');
                        $position = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'position');
                        $prefix = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'prefix');
                        $city = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType], 'city');
                        $countryCode = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType],'country');
                        $stateCode = '';
                        if (!empty($quoteData[$forceProcessLeadType]['state'])) {
                            $stateCode = Tools_LeadTools::getValue($quoteData[$forceProcessLeadType],'state');
                            if (is_numeric($stateCode)) {
                                $stateInfo = Tools_Geo::getStateById($stateCode);
                                if (!empty($stateInfo)) {
                                    $stateCode = $stateInfo['state'];
                                }
                            }
                        }

                        $mobileCountryCode =  Tools_LeadTools::getValue($quoteData[$forceProcessLeadType],'mobilecountrycode');
                        $phoneCountryCode =  Tools_LeadTools::getValue($quoteData[$forceProcessLeadType],'phonecountrycode');
                    }

                    $mobileCountryCodeValue = '';
                    $phoneCountryCodeValue = '';
                    if (empty($mobileCountryCode)) {
                        $mobileCountryCode = '';
                    }

                    if (empty($phoneCountryCode)) {
                        $phoneCountryCode = '';
                    }


                    $countryCodes = Tools_Geo::getCountries(true);
                    if (!empty($countryCode)) {
                        if (!array_key_exists($countryCode, $countryCodes)) {
                            $countryCode = '';
                        }
                    }

                    if (!empty($mobileCountryCode)) {
                        if (!array_key_exists($mobileCountryCode, $countryCodes)) {
                            $mobileCountryCode = '';
                        }
                    }

                    if (!empty($phoneCountryCode)) {
                        if (!array_key_exists($phoneCountryCode, $countryCodes)) {
                            $phoneCountryCode = '';
                        }
                    }

                    $shoppingConfig = Models_Mapper_ShoppingConfig::getInstance()->getConfigParams();
                    if (!empty($shoppingConfig['country'])) {
                        if (empty($countryCode)) {
                            $countryCode = $shoppingConfig['country'];
                        }
                    }

                    $configHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('config');
                    $userDefaultMobileCountryCode = $configHelper->getConfig('userDefaultPhoneMobileCode');
                    if (empty($mobileCountryCode) && !empty($userDefaultMobileCountryCode)) {
                        $mobileCountryCode = $userDefaultMobileCountryCode;
                    }

                    if (empty($phoneCountryCode) && !empty($userDefaultMobileCountryCode)) {
                        $phoneCountryCode = $userDefaultMobileCountryCode;
                    }

                    if (!empty($mobile)) {
                        $mobile = Tools_LeadTools::cleanPhoneAddress($mobile);
                    }

                    if (!empty($phone)) {
                        $phone = Tools_LeadTools::cleanPhoneAddress($phone);
                    }

                    if (!empty($mobileCountryCode) && !empty($mobile)) {
                        $mobileNumberExists = Tools_LeadTools::checkLeadMobileOrPhoneNumber($mobile, $mobileCountryCode);
                        $mobileCountryCodeValue = Tools_LeadTools::getCountryCodeValue($mobileCountryCode);
                        if (!empty($mobileNumberExists)) {
                            $mobile = '';
                        }
                    }
                    if (!empty($phoneCountryCode) && !empty($phone)) {
                        $phoneNumberExists = Tools_LeadTools::checkLeadMobileOrPhoneNumber($phone, $phoneCountryCode);
                        $phoneCountryCodeValue = Tools_LeadTools::getCountryCodeValue($phoneCountryCode);
                        if (!empty($phoneNumberExists)) {
                            $phone = '';
                        }
                    }

                    $mobileNumberExists = Tools_LeadTools::checkLeadMobileOrPhoneNumber($mobile);
                    if (!empty($mobileNumberExists)) {
                        $mobile = '';
                    }
                    $phoneNumberExists = Tools_LeadTools::checkLeadMobileOrPhoneNumber($phone);
                    if (!empty($phoneNumberExists)) {
                        $phone = '';
                    }


                    $leadModel = Tools_LeadTools::getLeadModelByIdAndEmail($currentLoggedUserId, $currentLoggedUserEmail, $leadEmail);

                    if (!Tools_Security_Acl::isAllowed(Shopping::RESOURCE_STORE_MANAGEMENT)) {
                        $ip = Tools_LeadTools::getIpAddress();
                    }

                    $ownerId = Tools_LeadTools::getDefaultLeadOwner();

                    $createdAt = Tools_System_Tools::convertDateFromTimezone('now');
                    $leadType = Leads_Model_LeadsTypeModel::LEAD_TYPE_INBOUND_QUOTE;
                    if (Tools_Security_Acl::isAllowed(Shopping::RESOURCE_STORE_MANAGEMENT)) {
                        $leadType = Leads_Model_LeadsTypeModel::LEAD_TYPE_OUTBOUND_QUOTE;
                    }

                    if (!$leadModel instanceof Leads_Model_LeadsModel) {
                        $leadAdditionAvailable = Tools_LeadLicenseTools::checkLimit();
                        if ($leadAdditionAvailable['error'] === true) {
                            $leadModel = new Leads_Model_LeadsModel();
                            $leadModel->registerObserver(new Tools_Mail_Watchdog(array(
                                'trigger' => Tools_LeadsMailWatchdog::LEADS_LICENSE_LIMIT
                            )));

                            $leadModel->notifyObservers();
                            return '';
                        }
                        $leadTypeId = Tools_LeadTools::getLeadTypeIdByLeadTypeName($leadType);
                        $leadModel = new Leads_Model_LeadsModel();
                        $leadModel->setCreatedAt($createdAt);
                        if (!empty($currentLoggedUserEmail)) {
                            $leadModel->setLeadEmail($currentLoggedUserEmail);
                        } else {
                            $leadModel->setLeadEmail($leadEmail);
                        }
                        $leadModel->setLeadFirstName($firstName);
                        $leadModel->setLeadMobileCountryCode($mobileCountryCode);
                        if (!empty($mobile)) {
                            $leadModel->setLeadMobile($mobile);
                            $leadModel->setLeadMobileCountryCodeValue($mobileCountryCodeValue);
                        }
                        $leadModel->setLeadPhoneCountryCode($phoneCountryCode);
                        if (!empty($phone)) {
                            $leadModel->setLeadPhone($phone);
                            $leadModel->setLeadPhoneCountryCodeValue($phoneCountryCodeValue);
                        }
                        $leadModel->setLeadPhone($phone);
                        $leadModel->setLeadLastName($lastName);
                        $leadModel->setLeadZip($zip);
                        $leadModel->setLeadAddress($address);
                        $leadModel->setLeadAddress1($address1);
                        $leadModel->setOwnerId($ownerId);
                        $leadModel->setLeadTypeId($leadTypeId);
                        if (!empty($prefix)) {
                            $leadModel->setPrefix($prefix);
                        }
                        if (!empty($city)) {
                            $leadModel->setLeadCity($city);
                        }
                        if (!empty($countryCode)) {
                            $leadModel->setLeadCountryCode($countryCode);
                        }
                        if (!empty($stateCode)) {
                            $leadModel->setLeadStateCode($stateCode);
                        }
                        if (!empty($position)) {
                            $leadModel->setLeadPosition($position);
                        }

                        $leadModel->setLeadSource(Tools_LeadTools::getRefererUrl().' '.Tools_LeadTools::getUtmTagsString());
                    } else {
                        $currentFirstName = $leadModel->getLeadFirstName();
                        $currentLeadLastName = $leadModel->getLeadLastName();
                        $currentMobile = $leadModel->getLeadMobile();
                        $currentPhone = $leadModel->getLeadPhone();
                        $currentZip = $leadModel->getLeadZip();
                        $currentAddress = $leadModel->getLeadAddress();
                        $currentAddress1 = $leadModel->getLeadAddress1();
                        $currentPosition = $leadModel->getLeadPosition();
                        $currentPrefix = $leadModel->getPrefix();
                        $currentCity = $leadModel->getLeadCity();
                        $currentCountry = $leadModel->getLeadCountryCode();
                        $currentState = $leadModel->getLeadStateCode();

                        if (empty($currentFirstName)) {
                            $leadModel->setLeadFirstName($firstName);
                        }
                        if (empty($currentLeadLastName)) {
                            $leadModel->setLeadLastName($lastName);
                        }
                        if (empty($currentMobile) && !empty($mobile)) {
                            $leadModel->setLeadMobile($mobile);
                            $leadModel->setLeadMobileCountryCodeValue($mobileCountryCodeValue);
                            $leadModel->setLeadMobileCountryCode($mobileCountryCode);
                        }
                        if (empty($currentPhone) && !empty($phone)) {
                            $leadModel->setLeadPhone($phone);
                            $leadModel->setLeadPhoneCountryCode($phoneCountryCode);
                            $leadModel->setLeadPhoneCountryCodeValue($phoneCountryCodeValue);
                        }

                        if (empty($currentZip)) {
                            $leadModel->setLeadZip($zip);
                        }

                        if (empty($currentAddress)) {
                            $leadModel->setLeadAddress($address);
                        }

                        if (empty($currentAddress1)) {
                            $leadModel->setLeadAddress1($address1);
                        }

                        if (empty($currentPrefix) && !empty($prefix)) {
                            $leadModel->setPrefix($prefix);
                        }

                        if (empty($currentCity) && !empty($city)) {
                            $leadModel->setLeadCity($city);
                        }

                        if (empty($currentCountry) && !empty($countryCode)) {
                            $leadModel->setLeadCountryCode($countryCode);
                        }

                        if (empty($currentState) && !empty($stateCode)) {
                            $leadModel->setLeadStateCode($stateCode);
                        }

                        if (empty($currentPosition) && !empty($position)) {
                            $leadModel->setLeadPosition($position);
                        }

                    }

                    $oldUserId = $leadModel->getUserId();
                    if (empty($oldUserId)) {
                        $leadModel->setUserId($currentLoggedUserId);
                    }

                    $quoteType = Leads_Model_LeadsActionLogModel::ACTION_TYPE_INBOUND;
                    if (Tools_Security_Acl::isAllowed(Shopping::RESOURCE_STORE_MANAGEMENT)) {
                        $quoteType = Leads_Model_LeadsActionLogModel::ACTION_TYPE_OUTBOUND;
                    }

                    if ($quoteType === Leads_Model_LeadsActionLogModel::ACTION_TYPE_INBOUND) {
                        $leadTypeModel = Leads_Mapper_LeadsTypeMapper::getInstance()->findByTypeName($leadType);
                        if ($leadTypeModel instanceof Leads_Model_LeadsTypeModel) {
                            $leadModel->setLastActivityTypeId($leadTypeModel->getId());
                            $leadModel->setLastActivitySubtype('');
                        }
                        $leadModel->setLastActivity($createdAt);
                    }

                    if ($quoteType === Leads_Model_LeadsActionLogModel::ACTION_TYPE_OUTBOUND) {
                        $leadTypeModel = Leads_Mapper_LeadsTypeMapper::getInstance()->findByTypeName($leadType);
                        if ($leadTypeModel instanceof Leads_Model_LeadsTypeModel) {
                            $leadModel->setLastActivityTypeId($leadTypeModel->getId());
                            $leadModel->setLastActivitySubtype('');
                        }
                        $leadModel->setLastActivityOutbound($createdAt);
                    }
                    try {
                        $leadModel = $leadsMapper->save($leadModel);
                    } catch (Exception $e) {
                        return false;
                    }
                    $leadId = $leadModel->getId();

                    if (!empty($ip)) {
                        $leadsIpsModel = Tools_LeadTools::addIpAddressToLead($leadId, $ip);
                        if ($leadsIpsModel instanceof Leads_Model_LeadsIpsModel) {
                            Tools_LeadTools::addIpToMojo($leadsIpsModel);
                        }
                    }

                    $leadsActionLog = Tools_LeadTools::logLeadAction(Leads_Model_LeadsActionLogModel::ACTION_QUOTE,
                        $leadId,
                        $quoteType, $createdAt, $leadType);

                    $session = Zend_Controller_Action_HelperBroker::getStaticHelper('session');
                    $currentLoggedUserId = $session->getCurrentUser()->getId();
                    $creatorId = null;
                    $signedOnlyById = 0;
                    if (Tools_Security_Acl::isAllowed(Shopping::RESOURCE_STORE_MANAGEMENT)) {
                        $creatorId = $currentLoggedUserId;
                        if ($quoteStatus === Quote_Models_Model_Quote::STATUS_SIGNATURE_ONLY_SIGNED) {
                            $signedOnlyById  = $creatorId;
                        }
                    }

                    $leadQuoteLogModel = new Leads_Model_LeadsQuoteLogModel();
                    $leadQuoteLogModel->setStatus($quoteStatus);
                    $leadQuoteLogModel->setQuoteId($quoteId);
                    $leadQuoteLogModel->setTitle($quoteModel->getTitle());
                    $leadQuoteLogModel->setCreatedAt($createdAt);
                    $leadQuoteLogModel->setActionLogId($leadsActionLog->getId());
                    $leadQuoteLogModel->setCreatorId($creatorId);
                    $leadQuoteLogModel->setQuoteLink($quoteId . '.html');
                    $leadQuoteLogModel->setLeadId($leadId);
                    $leadQuoteLogModel->setSignedOnlyBy($signedOnlyById);
                    $leadQuoteLogModel->setTotal($cartTotal);
                    if ($quoteHasBeenSent === true) {
                        $leadQuoteLogModel->setQuoteSent('1');
                    }

                    if ($forceDisplay === true) {
                        $leadQuoteLogModel->setForceDisplay('1');
                    }
                    $leadsQuoteLogMapper->save($leadQuoteLogModel);
                }

            }elseif ($request->isDelete()){
                $sessionHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('session');
                $quoteId = $quoteModel->getId();

                if(!empty($quoteId)){
                    $currentUser = $sessionHelper->getCurrentUser();
                    $leadsQuoteLogMapper = Leads_Mapper_LeadsQuoteLogMapper::getInstance();

                    $allQuotes = $leadsQuoteLogMapper->findByQuoteId($quoteId);

                    if(!empty($allQuotes)){
                        foreach ($allQuotes as $quote) {
                            $quote->setIsDeleted(1);
                            $quote->setDeletedBy($currentUser->getId());
                            $leadsQuoteLogMapper->save($quote);
                        }

                        $quote = $leadsQuoteLogMapper->findByLastQuoteId($quoteId);

                        if(!empty($quote)){
                            $leadId = $quote['lead_id'];
                            $createdAt = Tools_System_Tools::convertDateFromTimezone('now');
                            $leadActionLog = Tools_LeadTools::logLeadAction(Leads_Model_LeadsActionLogModel::ACTION_QUOTE_DELETED,
                                $leadId,
                                Leads_Model_LeadsActionLogModel::ACTION_TYPE_OUTBOUND, $createdAt,
                                 Leads_Model_LeadsTypeModel::LEAD_TYPE_OUTBOUND_QUOTE,
                                Leads_Model_LeadsActionLogModel::EVENT_LOG_EXPIRED);


                            if ($leadActionLog instanceof Leads_Model_LeadsActionLogModel) {
                                $leadQuoteLogModel = new Leads_Model_LeadsQuoteLogModel();
                                $leadQuoteLogModel->setQuoteId($quote['quote_id']);
                                $leadQuoteLogModel->setTitle($quote['title']);
                                $leadQuoteLogModel->setStatus(Leads_Model_LeadsQuoteLogModel::QUOTE_ACTION_TYPE_DELETED);
                                $leadQuoteLogModel->setCreatedAt($quote['created_at']);
                                $leadQuoteLogModel->setActionLogId($leadActionLog->getId());
                                $leadQuoteLogModel->setCreatorId($quote['creator_id']);
                                $leadQuoteLogModel->setQuoteLink($quote['quote_link']);
                                $leadQuoteLogModel->setQuoteActionType(Leads_Model_LeadsQuoteLogModel::QUOTE_ACTION_TYPE_DELETED);
                                $leadQuoteLogModel->setLeadId($leadId);
                                $leadQuoteLogModel->setTotal($quote['total']);
                                $leadQuoteLogModel->setQuoteSent($quote['quote_sent']);
                                $leadQuoteLogModel->setIsDeleted(1);
                                $leadQuoteLogModel->setDeletedBy($currentUser->getId());

                                $leadsQuoteLogMapper->save($leadQuoteLogModel);
                            }
                        }
                    }
                }
            }
        }
    }
}

