<?php

/**
 * Class Tools_LeadRemarketingAudiencesTools
 */
class Tools_LeadRemarketingAudiencesTools
{
    /**
     * Limit per day
     */
    const GOOGLE_ADS_LIMIT = '10000';//10000

    /**
     * Limit per hour
     */
    const FACEBOOK_ADS_LIMIT = '5000';//5000

    const LEAD_REMARKETING_AUDIENCES_PROCESS_PATH = 'plugins/leads/system/cronscript/processRemarketingAudiences.php';


    public static $_audiences = array(
            'facebook',
            'adwords'
        );

    public static function prepareAndSaveData($type, $audienceId = array(), $remove, $listContent = array()) {
        if(!empty($audienceId) && !empty($listContent)) {
            $action = 'add';

            if($remove) {
                $action = 'remove';
            }

            foreach ($audienceId as $audience) {
                $leadsData = json_encode($listContent);

                $leadsRemarketingAudiencesMapper = Leads_Mapper_LeadsRemarketingAudiencesMapper::getInstance();
                $leadsRemarketingAudiencesModel = new Leads_Model_LeadsRemarketingAudiencesModel();

                $leadsRemarketingAudiencesModel->setType($type);
                $leadsRemarketingAudiencesModel->setAction($action);
                $leadsRemarketingAudiencesModel->setAudienceId($audience);
                $leadsRemarketingAudiencesModel->setListContent($leadsData);
                $leadsRemarketingAudiencesModel->setAdditionalInfo(null);
                $leadsRemarketingAudiencesModel->setCreatedAt(date(Tools_System_Tools::DATE_MYSQL));

                $leadsRemarketingAudiencesMapper->save($leadsRemarketingAudiencesModel);
            }

        }

    }

    public static function processAudiences() {
        $leadsRemarketingAudiencesMapper = Leads_Mapper_LeadsRemarketingAudiencesMapper::getInstance();
        $leadsConfigMapper = Leads_Mapper_LeadsConfigMapper::getInstance();
        $leadsMapper = Leads_Mapper_LeadsMapper::getInstance();
        $leadTagsMapper = Leads_Mapper_LeadsTagsMapper::getInstance();

        $remarketingAudiencesFacebookProcessedCount = $leadsConfigMapper->getConfigParam('remarketingAudiencesFacebookProcessedCount');
        $remarketingAudiencesFacebookProcessedDate = $leadsConfigMapper->getConfigParam('remarketingAudiencesFacebookProcessedDate');

        $remarketingAudiencesAdwordsProcessedCount = $leadsConfigMapper->getConfigParam('remarketingAudiencesAdwordsProcessedCount');
        $remarketingAudiencesAdwordsProcessedDate = $leadsConfigMapper->getConfigParam('remarketingAudiencesAdwordsProcessedDate');

        $currentDate = date(Tools_System_Tools::DATE_MYSQL, strtotime('now'));

        foreach (self::$_audiences as $audience) {
            $services = Apps::apiCall('GET', 'sambastatsRemarketingList', array(), array('type' => $audience));

            if(!$services['error']) {
                if($audience == 'facebook') {
                    $limit = self::FACEBOOK_ADS_LIMIT;
                    if(!empty($remarketingAudiencesFacebookProcessedDate)) {
                        $dateFrom = date(Tools_System_Tools::DATE_MYSQL, strtotime($remarketingAudiencesFacebookProcessedDate));
                        $dateTo = date(Tools_System_Tools::DATE_MYSQL, strtotime($currentDate));
                        $dateFrom = new DateTime($dateFrom);
                        $dateTo = new DateTime($dateTo);
                        $preparePeriod = $dateFrom->diff($dateTo);
                        $periodDifference = $preparePeriod->h;
                        $periodDifferenceDays = $preparePeriod->days;

                        if(($periodDifference < 1 && $periodDifferenceDays < 1) && $remarketingAudiencesFacebookProcessedCount >= $limit) {
                            continue;
                        } else {
                            $limit = $limit - $remarketingAudiencesFacebookProcessedCount;

                            if($limit < 1) {
                                $limit = self::FACEBOOK_ADS_LIMIT;
                                $remarketingAudiencesFacebookProcessedCount = '0';
                            }
                        }

                    }

                } elseif ($audience == 'adwords') {
                    $limit = self::GOOGLE_ADS_LIMIT;
                    if(!empty($remarketingAudiencesAdwordsProcessedDate)) {
                        $dateFrom = date(Tools_System_Tools::DATE_MYSQL, strtotime($remarketingAudiencesAdwordsProcessedDate));
                        $dateTo = date(Tools_System_Tools::DATE_MYSQL, strtotime($currentDate));
                        $dateFrom = new DateTime($dateFrom);
                        $dateTo = new DateTime($dateTo);
                        $preparePeriod = $dateFrom->diff($dateTo);
                        $periodDifference = $preparePeriod->days;

                        if($periodDifference < 1 && $remarketingAudiencesAdwordsProcessedCount >= $limit) {
                            continue;
                        } else {
                            $limit = $limit - $remarketingAudiencesAdwordsProcessedCount;

                            if($limit < 1) {
                                $limit = self::FACEBOOK_ADS_LIMIT;
                                $remarketingAudiencesAdwordsProcessedCount = '0';
                            }
                        }

                    }
                }

                $where = $leadsRemarketingAudiencesMapper->getDbTable()->getAdapter()->quoteInto("type = ?", $audience);
                $audiencesData = $leadsRemarketingAudiencesMapper->fetchAll($where, null, $limit, null, '');

                if(!empty($audiencesData)) {
                    $requestData = array();
                    $remarketingAudiencesIdsToRemove = array();

                    foreach ($audiencesData as $key => $aData) {
                        $remarketingAudiencesIdsToRemove[] = $aData['id'];

                        $action = 'add';
                        if($aData['action'] == 'remove') {
                            $action = 'remove';
                        }

                        $requestData[$action][$aData['audienceId']]['type'] = $audience;

                        if(!in_array($aData['audienceId'], $requestData[$action][$aData['audienceId']]['audienceId'])) {
                            $requestData[$action][$aData['audienceId']]['audienceId'][] = $aData['audienceId'];
                        }

                        $requestData[$action][$aData['audienceId']]['remove'] = false;
                        if($action == 'remove') {
                            $requestData[$action][$aData['audienceId']]['remove'] = true;
                        }

                        $listContent = json_decode($aData['listContent'], true);
                        $listContent = array_shift($listContent);

                        $requestData[$action][$aData['audienceId']]['listContent'][$listContent['id']] = $listContent;

                    }

                    if(!empty($requestData)) {
                        foreach ($requestData as $rData) {
                            if(!empty($rData)) {
                                foreach ($rData as $audiences) {
                                    $response = Apps::apiCall('POST', 'sambastatsAddDataToRemarketingList', array(), $audiences);

                                    /*$response = array('errorList' => array(
                                        '23851117786260651' => 'Audience doesn\'t belong to connected account',
                                        '23851111137170651' => 'OTHER EEERRROR'
                                    ));*/


                                    //Tags deletion sector
                                    if(!empty($response['errorList'])) {
                                        foreach ($response['errorList'] as $key => $error) {
                                            foreach ($services['data'] as $data) {
                                               if($key == $data['id']) {
                                                   $adsPrefix = 'Added to Google Audience';
                                                   if($audience == 'facebook') {
                                                       $adsPrefix = 'Added to FB Audience';
                                                   }

                                                   $tagNameOld = $data['name'] .' - '. $data['id'];//SMB CRM Leads - 243575394539
                                                   $tagName = $adsPrefix . ' ' . $data['name'] .' - '. $data['id'];//Added to Google Audience SMB CRM Leads - 243575394539
                                                   foreach ($audiences['listContent'] as $lId => $lData) {
                                                       $tag = $leadTagsMapper->getTag($tagName);
                                                       if ($tag instanceof Leads_Model_LeadsTagModel) {
                                                           $tagId = $tag->getId();

                                                           $leadsMapper->deleteTag($lId, $tagId);
                                                       }

                                                       //old rule
                                                       $tag = $leadTagsMapper->getTag($tagNameOld);
                                                       if ($tag instanceof Leads_Model_LeadsTagModel) {
                                                           $tagId = $tag->getId();

                                                           $leadsMapper->deleteTag($lId, $tagId);
                                                       }
                                                   }
                                               }
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        if($audience == 'facebook') {
                            if($periodDifference < 1 && !empty($remarketingAudiencesFacebookProcessedDate)) {
                                $currentDate = $remarketingAudiencesFacebookProcessedDate;
                            }

                            $leadsConfigMapper->save(array(
                                'remarketingAudiencesFacebookProcessedDate' => $currentDate,
                                'remarketingAudiencesFacebookProcessedCount' => $remarketingAudiencesFacebookProcessedCount + count($audiencesData)
                            ));

                        } elseif ($audience == 'adwords') {
                            if($periodDifference < 1 && !empty($remarketingAudiencesAdwordsProcessedDate)) {
                                $currentDate = $remarketingAudiencesAdwordsProcessedDate;
                            }

                            $leadsConfigMapper->save(array(
                                'remarketingAudiencesAdwordsProcessedDate' => $currentDate,
                                'remarketingAudiencesAdwordsProcessedCount' => $remarketingAudiencesAdwordsProcessedCount + count($audiencesData)
                            ));
                        }

                        $leadsRemarketingAudiencesMapper->delete($remarketingAudiencesIdsToRemove);

                    }
                }
            }
        }

        return true;
    }


}
