<?php

/**
 * Class Tools_LeadReportsTools
 */
class Tools_LeadReportsTools
{


    /**
     * Result graph label for leads by reputation bar
     */
    const GRAPH_RESULT_LABEL_LEADS_BY_REP = 'Leads';

    /**
     * Graph title for leads by reputation bar
     */
    const GRAPH_TITLE_LEADS_BY_REP = 'Leads by rep';

    /**
     * Result graph label for opportunities count bar
     */
    const GRAPH_RESULT_LABEL_OPPORTUNITIES_COUNT_BAR = 'Opportunities count';

    /**
     * Result graph label for tasks count bar
     */
    const GRAPH_RESULT_LABEL_TASKS_COUNT_BAR = 'Tasks by rep';

    /**
     * Graph title for leads by reputation bar
     */
    const GRAPH_TITLE_OPPORTUNITIES_COUNT_BAR = 'Opportunities count per rep';

    /**
     * Result graph label for opportunities amount bar
     */
    const GRAPH_RESULT_LABEL_OPPORTUNITIES_AMOUNT_BAR = 'Opportunities amount';

    /**
     * Title for opportunities amount bar
     */
    const GRAPH_TITLE_OPPORTUNITIES_AMOUNT_BAR = 'Opportunities amount by rep';

    /**
     * Title for opportunities bar aggregated
     */
    const GRAPH_TITLE_OPPORTUNITIES_BAR_AGGREGATED = 'Opportunities stage by rep';

    /**
     * Title for activities bar aggregated
     */
    const GRAPH_TITLE_ACTIVITIES_BAR_AGGREGATED = 'Activities by rep';

    /**
     * Title for opportunities bar aggregated
     */
    const GRAPH_TITLE_OPPORTUNITIES_SALES_BAR_AGGREGATED = 'Sales by rep';

    /**
     * Result graph label by group
     */
    const GRAPH_RESULT_LABEL_LEADS_BY_GROUP = 'Leads';

    /**
     * Result graph label lifecycle by group
     */
    const GRAPH_RESULT_LABEL_LEADS_LIFECYCLE_BY_GROUP = 'Leads lifecycle';

    /**
     * Title for leads lifecycle group
     */
    const GRAPH_TITLE_LEADS_LIFECYCLE_BY_GROUP = 'Leads lifecycle by group';

    /**
     * Title for leads group
     */
    const GRAPH_TITLE_LEADS_BY_GROUP = 'Leads by group';

    /**
     * Result graph label opportunities count per group
     */
    const GRAPH_RESULT_LABEL_OPPORTUNITIES_COUNT_PER_GROUP = 'Opportunities count';

    /**
     * Title for opportunities count per group
     */
    const GRAPH_TITLE_OPPORTUNITIES_COUNT_PER_GROUP = 'Opportunities count per group';

    /**
     * Result graph label opportunities amount per group
     */
    const GRAPH_RESULT_LABEL_OPPORTUNITIES_AMOUNT_BY_GROUP = 'Opportunities amount';

    /**
     * Title for opportunities amount per group
     */
    const GRAPH_TITLE_OPPORTUNITIES_AMOUNT_BY_GROUP = 'Opportunities amount by group';

    /**
     * Title for opportunities bar aggregated by group
     */
    const GRAPH_TITLE_OPPORTUNITIES_BAR_AGGREGATED_BY_GROUP = 'Opportunities stage per group';

    /**
     * Title for opportunities bar aggregated by group
     */
    const GRAPH_TITLE_OPPORTUNITIES_SALES_BAR_AGGREGATED_BY_GROUP = 'Sales per group';

    /**
     * Result graph label by source
     */
    const GRAPH_RESULT_LABEL_LEADS_BY_SOURCE = 'Leads';

    /**
     * Title for leads by source
     */
    const GRAPH_TITLE_LEADS_BY_SOURCE = 'Leads by source';

    /**
     * Result graph label opportunities count per source
     */
    const GRAPH_RESULT_LABEL_OPPORTUNITIES_COUNT_PER_SOURCE = 'Opportunities count';

    /**
     * Title for opportunities count per source
     */
    const GRAPH_TITLE_OPPORTUNITIES_COUNT_PER_SOURCE = 'Opportunities count per source';

    /**
     * Result graph label opportunities amount per source
     */
    const GRAPH_RESULT_LABEL_OPPORTUNITIES_AMOUNT_BY_SOURCE = 'Opportunities amount';

    /**
     * Title for opportunities amount by source
     */
    const GRAPH_TITLE_OPPORTUNITIES_AMOUNT_BY_SOURCE = 'Opportunities amount by source';

    /**
     * Title for opportunities bar aggregated by source
     */
    const GRAPH_TITLE_OPPORTUNITIES_BAR_AGGREGATED_BY_SOURCE = 'Opportunities stage per source';

    /**
     * Title for opportunities bar aggregated by source
     */
    const GRAPH_TITLE_OPPORTUNITIES_SALES_BAR_AGGREGATED_BY_SOURCE = 'Sales per source';

    /**
     * Title for opportunities bar aggregated by tag
     */
    const GRAPH_TITLE_OPPORTUNITIES_SALES_BAR_AGGREGATED_BY_TAG = 'Sales by lead tag';

    /**
     * Title for opportunity stage funnel graph
     */
    const GRAPH_TITLE_OPPORTUNITY_FUNNEL_STAGE = 'Sales funnel';

    /**
     * Title for opportunity stage pie graph
     */
    const GRAPH_TITLE_PIE_OPPORTUNITY = 'Sales';

    /**
     * Title for online sales stage pie graph
     */
    const GRAPH_TITLE_PIE_ONLINE_SALES = 'Online sales';

    /**
     * Result graph label by lifecycle
     */
    const GRAPH_RESULT_LABEL_LEADS_LIFECYCLE_BY_SOURCE = 'Leads lifecycle';

    /**
     * Title for leads by lifecycle
     */
    const GRAPH_TITLE_LEADS_BY_LIFECYCLE = 'Leads lifecycle by source';

    /**
     * Label for marketing open emails graph
     */
    const GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_EMAILS_COUNT_BAR_OPEN = 'Opened emails';

    /**
     * Label for marketing send emails graph
     */
    const GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_EMAILS_COUNT_BAR_SEND = 'Emails sent';

    /**
     * Label for marketing send sms graph
     */
    const GRAPH_RESULT_LABEL_MARKETING_SEQUENCES_SMS_COUNT_BAR_SEND = 'SMS/Text sent';

    /**
     * Opportunity graph color relation
     *
     * @var array
     */
    public static $_opportunityColors = array('1' => '#e48f8f', '10' => '#9b86d1', '20' => '#9da3df', '30' => '#93badb', '40' => '#8ad1cd',
        '50' => '#bed977', '60' => '#e8d76a', '70' => '#e8c27a', '80' => '#e8a37e', '90' => '#e87e7e', '100' => '#6fce70');

    /**
     * Opportunity graph color relation for comparison
     *
     * @var array
     */
    public static $_opportunityColorsForCompare =  array('1' => '#df8585', '10' => '#9880d6', '20' => '#9299e3', '30' => '#86b1d6', '40' => '#77cac5',
        '50' => '#b5d16a', '60' => '#e3d160', '70' => '#e3bb6f', '80' => '#e49c75', '90' => '#e47878', '100' => '#65c866');

    /**
     * Tasks bar colors from
     *
     * @var array
     */
    public static $_tasksBarColorsFrom = array('10' => '#AED6F1', '20' => '#2ECC71', '30' => '#1F99C4');

    /**
     * Tasks bar colors to
     *
     * @var array
     */
    public static $_tasksBarColorsTo = array('10' => '#85C1E9', '20' => '#28B463', '30' => '#1D8EB6');

    /**
     * Default color for all bar graphs
     *
     * @var array
     */
    public static $_standardColorBar = array('#71bce2');

    /**
     * Default color for all bar graphs for compare
     *
     * @var array
     */
    public static $_standardColorsToCompareBar = array('#71bce2', '#94a2a9');


    public static $_opportunityPieColors = array('1' => '#e48f8f', '99' => '#e8d76a', '100' => '#6fce70', '1000' =>'#e2e2e2');

    /**
     * It is alternative method
     *
     * Prepare owners data for bar chart (per owner chart)
     *
     * @param array $ownersData owners data
     * @param bool $compareToData owners data to compare
     * @return array
     */
    public static function prepareLeadOwnersData($ownersData, $compareToData = false)
    {
        $ownersDataResult = array();
        if (!empty($ownersData)) {
            $ownersDataResult['axes'] = array();
            $ownersDataResult['axesAdditionalInfo'] = array();
            $ownersDataResult['data'] = array();
            if ($compareToData !== false) {
                $ownersDataResult['dataToCompare'] = array();
            }
            $usedOwnerNames = array();
            array_push($ownersDataResult['axes'], 'x');
            array_push($ownersDataResult['axesAdditionalInfo'], 'x');
            array_push($ownersDataResult['data'], 'data');
            if ($compareToData !== false) {
                array_push($ownersDataResult['dataToCompare'], 'dataToCompare');
            }
            foreach ($ownersData as $key => $ownerData) {
                $currentOwnerName = $ownerData['full_name'];
                if (!array_key_exists($ownerData['full_name'], $usedOwnerNames)) {
                    $usedOwnerNames[$currentOwnerName] = 0;
                } else {
                    $usedOwnerNames[$currentOwnerName] = $usedOwnerNames[$currentOwnerName] + 1;
                    $currentOwnerName = $currentOwnerName . '_' . $usedOwnerNames[$currentOwnerName];
                }
                array_push($ownersDataResult['axes'], $currentOwnerName);
                array_push($ownersDataResult['axesAdditionalInfo'], $currentOwnerName);
                array_push($ownersDataResult['data'], $ownerData['count']);
                if ($compareToData !== false) {
                    if (!empty($compareToData[$key])) {
                        array_push($ownersDataResult['dataToCompare'], $compareToData[$key]['count']);
                        unset($compareToData[$key]);
                    } else {
                        array_push($ownersDataResult['dataToCompare'], 0);
                    }
                }
            }

            if (!empty($compareToData)) {
                foreach ($compareToData as $key => $ownerData) {
                    $currentOwnerName = $ownerData['full_name'];
                    if (!array_key_exists($ownerData['full_name'], $usedOwnerNames)) {
                        $usedOwnerNames[$currentOwnerName] = 0;
                    } else {
                        $usedOwnerNames[$currentOwnerName] = $usedOwnerNames[$currentOwnerName] + 1;
                        $currentOwnerName = $currentOwnerName . '_' . $usedOwnerNames[$currentOwnerName];
                    }
                    array_push($ownersDataResult['axes'], $currentOwnerName);
                    array_push($ownersDataResult['axesAdditionalInfo'], $ownerData['id']);
                    array_push($ownersDataResult['data'], 0);
                    array_push($ownersDataResult['dataToCompare'], $ownerData['count']);
                }
            }

        }

        return $ownersDataResult;
    }

    /**
     * Prepare owners data for bar chart (per owner chart)
     *
     * @param array $ownersData owners data
     * @param bool $compareToData flag to process compared data
     * @param string $resultLabel result label
     * @return array
     */
    public static function prepareLeadOwnersDataAggregated($ownersData, $compareToData = false, $resultLabel = 'data', $preventDuplicate = false, array $additionalFilterParams = array())
    {
        $ownersDataResult = array();
        if (!empty($ownersData)) {
            $ownersDataResult['axes'] = array();
            $ownersDataResult['data'] = array();
            $ownersDataResult['axesAdditionalInfo'] = array();
            if ($compareToData !== false) {
                $ownersDataResult['dataToCompare'] = array();
            }
            $usedOwnerNames = array();
            $comparisonData = array();
            $allNames = array();
            array_push($ownersDataResult['axes'], 'x');
            array_push($ownersDataResult['axesAdditionalInfo'], 'x');
            array_push($ownersDataResult['data'], $resultLabel);

            $ownersDataResult['additionalFilterPreset'][] = 'x';
            if ($compareToData !== false) {
                array_push($ownersDataResult['dataToCompare'], '*'.$resultLabel);
            }

            $excludeIds = array();

            foreach ($ownersData as $key => $ownerData) {
                $additionalFilterPreset = '';
                if(!empty($additionalFilterParams)) {
                    foreach ($additionalFilterParams as $additionalParam) {
                        if(!empty($ownerData[$additionalParam])) {
                            $additionalFilterPreset .= '&'.$additionalParam . '=' . $ownerData[$additionalParam];
                        }
                    }
                }

                $currentOwnerName = $ownerData['full_name'];
                if (!array_key_exists($ownerData['full_name'], $usedOwnerNames)) {
                    $usedOwnerNames[$currentOwnerName] = 0;
                } elseif(!in_array($ownerData['id'], $excludeIds)) {
                    $usedOwnerNames[$currentOwnerName] = $usedOwnerNames[$currentOwnerName] + 1;
                    $currentOwnerName = $currentOwnerName . '_' . $usedOwnerNames[$currentOwnerName];
                }

                if (!in_array($ownerData['id'], $excludeIds)) {
                    $allNames[$ownerData['id']] = $currentOwnerName;
                    array_push($ownersDataResult['axes'], $currentOwnerName);
                    array_push($ownersDataResult['axesAdditionalInfo'], $ownerData['id']);

                    $ownersDataResult['additionalFilterPreset'][] = $additionalFilterPreset;
                }

                if ($compareToData === false) {
                    array_push($ownersDataResult['data'], $ownerData['count']);
                } else {
                    if ($ownerData['type'] === 'current' && !in_array($ownerData['id'], $excludeIds)) {
                        array_push($ownersDataResult['data'], $ownerData['count']);
                        $previousKey = $ownerData['id'] . '_previous';
                        if (array_key_exists($previousKey, $ownersData)) {
                            array_push($ownersDataResult['dataToCompare'], $ownersData[$previousKey]['count']);
                        } else {
                            array_push($ownersDataResult['dataToCompare'], 0);
                        }

                        array_push($excludeIds, $ownerData['id']);

                    } elseif (!in_array($ownerData['id'], $excludeIds)) {
                        array_push($ownersDataResult['dataToCompare'], $ownerData['count']);
                        $currentKey = $ownerData['id'] . '_current';
                        if (array_key_exists($currentKey, $ownersData)) {
                            array_push($ownersDataResult['data'], $ownersData[$currentKey]['count']);
                        } else {
                            array_push($ownersDataResult['data'], 0);
                        }

                        array_push($excludeIds, $ownerData['id']);
                    }

                }

            }


            if ($compareToData !== false) {
                $comparisonData = self::prepareComparisonDataForBarGraphs($ownersData, $allNames);
            }

            $ownersDataResult['colorPattern'] = self::$_standardColorBar;
            $ownersDataResult['comparisonData'] = $comparisonData;
            if ($compareToData !== false) {
                $ownersDataResult['colorPattern'] = self::$_standardColorsToCompareBar;
            }
        }

        return $ownersDataResult;

    }

    /**
     * Opened Emails and Send SMS Sequences multiple method
     *
     * @param $sequencesData
     * @param $compareToData
     * @param $resultLabel
     * @param array $additionalFilterParams
     * @return array
     */
    public static function prepareSequenceOpenEmailsAndSendSmsByOwnerDataAggregated($sequencesData, $compareToData = false, $resultLabel = 'data', array $additionalFilterParams = array())
    {
        $sequencesDataResult = array();
        if (!empty($sequencesData)) {
            $sequencesDataResult['axes'] = array();
            $sequencesDataResult['data'] = array();
            $sequencesDataResult['axesAdditionalInfo'] = array();
            if ($compareToData !== false) {
                $sequencesDataResult['dataToCompare'] = array();
            }
            $usedSequenceNames = array();
            $comparisonData = array();
            $allNames = array();
            array_push($sequencesDataResult['axes'], 'x');
            array_push($sequencesDataResult['axesAdditionalInfo'], 'x');
            array_push($sequencesDataResult['data'], $resultLabel);

            $sequencesDataResult['additionalFilterPreset'][] = 'x';
            if ($compareToData !== false) {
                array_push($sequencesDataResult['dataToCompare'], '*'.$resultLabel);
            }

            $excludeIds = array();

            foreach ($sequencesData as $key => $sequenceData) {
                $additionalFilterPreset = '';
                if(!empty($additionalFilterParams)) {
                    foreach ($additionalFilterParams as $additionalParam) {
                        if(!empty($sequenceData[$additionalParam])) {
                            $additionalFilterPreset .= '&'.$additionalParam . '=' . $sequenceData[$additionalParam];
                        }
                    }
                }

                $currentSequenceName = $sequenceData['sequence_name'];
                if (!array_key_exists($sequenceData['sequence_name'], $usedSequenceNames)) {
                    $usedSequenceNames[$currentSequenceName] = 0;
                } elseif(!in_array($sequenceData['id'], $excludeIds)) {
                    $usedSequenceNames[$currentSequenceName] = $usedSequenceNames[$currentSequenceName] + 1;
                    $currentSequenceName = $currentSequenceName . '_' . $usedSequenceNames[$currentSequenceName];
                }

                if (!in_array($sequenceData['id'], $excludeIds)) {
                    $allNames[$sequenceData['id']] = $currentSequenceName;
                    array_push($sequencesDataResult['axes'], $currentSequenceName);
                    array_push($sequencesDataResult['axesAdditionalInfo'], $sequenceData['id']);

                    $sequencesDataResult['additionalFilterPreset'][] = $additionalFilterPreset;
                }

                if ($compareToData === false) {
                    array_push($sequencesDataResult['data'], $sequenceData['count']);
                } else {
                    if ($sequenceData['type'] === 'current' && !in_array($sequenceData['id'], $excludeIds)) {
                        array_push($sequencesDataResult['data'], $sequenceData['count']);
                        $previousKey = $sequenceData['id'] . '_previous';
                        if (array_key_exists($previousKey, $sequencesData)) {
                            array_push($sequencesDataResult['dataToCompare'], $sequencesData[$previousKey]['count']);
                        } else {
                            array_push($sequencesDataResult['dataToCompare'], 0);
                        }

                        array_push($excludeIds, $sequenceData['id']);

                    } elseif (!in_array($sequenceData['id'], $excludeIds)) {
                        array_push($sequencesDataResult['dataToCompare'], $sequenceData['count']);
                        $currentKey = $sequenceData['id'] . '_current';
                        if (array_key_exists($currentKey, $sequencesData)) {
                            array_push($sequencesDataResult['data'], $sequencesData[$currentKey]['count']);
                        } else {
                            array_push($sequencesDataResult['data'], 0);
                        }

                        array_push($excludeIds, $sequenceData['id']);
                    }

                }

            }

            if ($compareToData !== false) {
                $comparisonData = self::prepareComparisonDataForBarGraphs($sequencesData, $allNames);
            }

            $sequencesDataResult['colorPattern'] = self::$_standardColorBar;
            $sequencesDataResult['comparisonData'] = $comparisonData;
            if ($compareToData !== false) {
                $sequencesDataResult['colorPattern'] = self::$_standardColorsToCompareBar;
            }
        }

        return $sequencesDataResult;

    }

    /**
     *
     * @param array $ownersData owners data
     * @param array $colorSchemeFrom color scheme per id  Ex: array('1' => '#e48f8f', '10' => '#b190d6', '20' => '#9da3df')
     * @param array $colorSchemeTo color scheme per id  Ex: array('1' => '#e48f8f', '10' => '#b190d6', '20' => '#9da3df')
     * @param bool $compareToData flag to process compared data
     * @param bool $useAmountAsValue flag use amount as value
     * @param string $limitCalculationByBarId limit by bar id
     *
     * @return array
     */
    public static function prepareLeadsDataAggregatedBar($ownersData, $colorSchemeFrom, $compareToData = false, $colorSchemeTo = array(), $useAmountAsValue = false, $limitCalculationByBarId = '0', array $additionalFilterParams = array())
    {
        $ownersDataResult = array();
        if (!empty($ownersData)) {
            $ownersDataResult['axes'] = array();
            $ownersDataResult['axesAdditionalInfo'] = array();
            $ownersDataResult['data'] = array();
            if ($compareToData !== false) {
                $ownersDataResult['dataToCompare'] = array();
            }
            $usedOwnerNames = array();
            $ownersNamesArray = array();
            $graphData = array();
            $graphDataResultFrom = array();
            $graphDataResultTo = array();
            $colorPatternResult = array();
            $fullColorPattern = array();
            $allNames = array();
            array_push($ownersDataResult['axes'], 'x');
            array_push($ownersDataResult['axesAdditionalInfo'], 'x');
            if ($compareToData !== false) {
                array_push($ownersDataResult['dataToCompare'], 'dataToCompare');
            }

            $excludeOwnerIds = array();

            foreach ($ownersData as $key => $ownerData) {
                $currentOwnerName = $ownerData['full_name'];
                $addName = false;
                $graphData[$ownerData['barId']]['barName'] = $ownerData['description'];
                if (!array_key_exists($ownerData['full_name'], $usedOwnerNames)) {
                    $usedOwnerNames[$currentOwnerName]['id'] = $ownerData['id'];
                    $usedOwnerNames[$currentOwnerName]['count'] = 0;
                    $addName = true;
                } elseif($usedOwnerNames[$currentOwnerName]['id'] != $ownerData['id'] && !in_array($ownerData['id'], $excludeOwnerIds)) {
                    $usedOwnerNames[$currentOwnerName]['count'] = $usedOwnerNames[$currentOwnerName]['count'] + 1;
                    $currentOwnerName = $currentOwnerName . '_' . $usedOwnerNames[$currentOwnerName]['count'];
                    $addName = true;
                }

                if (!array_key_exists($ownerData['id'], $allNames)) {
                    $allNames[$ownerData['id']] = $currentOwnerName;
                }

                if ($addName === true) {
                    array_push($ownersDataResult['axes'], $currentOwnerName);
                    array_push($ownersDataResult['axesAdditionalInfo'], $ownerData['id']);
                    $ownersNamesArray[$ownerData['id']]['id'] = $ownerData['id'];
                    $ownersNamesArray[$ownerData['id']]['position'] = count($ownersDataResult['axes']) - 1;
                }

                array_push($excludeOwnerIds, $ownerData['id']);
            }

            $comparisonData = array();
            if ($compareToData !== false) {
                $comparisonData = self::prepareComparisonDataForLeadsDataAggregatedBar($ownersData, $allNames, $useAmountAsValue, $limitCalculationByBarId);
            }

            foreach ($graphData as $opportunityId => $barName) {
                array_push($graphDataResultFrom, $barName['barName']);
                if ($compareToData !== false) {
                    array_push($graphDataResultTo, '*'.$barName['barName']);
                }
                $graphData[$opportunityId]['position'] = count($graphDataResultFrom);

            }

            $dataGrouped = array();

            foreach ($ownersData as $key => $ownerData) {
                $barName = $ownerData['description'];

                if ($compareToData !== false && $ownerData['type'] === 'previous') {
                    $barName = '*'.$ownerData['description'];
                }

                //Add colors
                if ($ownerData['type'] === 'current' && !in_array($colorSchemeFrom[$ownerData['barId']], $colorPatternResult)) {
                    $colorPatternResult[] = $colorSchemeFrom[$ownerData['barId']];
                    $fullColorPattern[$barName] = $colorSchemeFrom[$ownerData['barId']];
                }

                if ($ownerData['type'] === 'previous'  && !in_array($colorSchemeTo[$ownerData['barId']], $colorPatternResult)) {
                    $colorPatternResult[] = $colorSchemeTo[$ownerData['barId']];
                    $fullColorPattern[$barName] = $colorSchemeFrom[$ownerData['barId']];
                }


                $dataGrouped[$ownerData['barId'].'_'.$ownerData['type']][0] = $barName;
                $position = $ownersNamesArray[$ownerData['id']]['position'];
                if ($useAmountAsValue === true) {
                    $dataGrouped[$ownerData['barId'] . '_' . $ownerData['type']][$position] = $ownerData['amount'];
                } else {
                    $dataGrouped[$ownerData['barId'] . '_' . $ownerData['type']][$position] = $ownerData['count'];
                }
            }

            foreach ($dataGrouped as $key => $dataGroupedSingleItem) {
                $quantity = count($ownersNamesArray) + 1;
                for($i = 0; $i < $quantity; $i++)
                {
                    if(!isset($dataGrouped[$key][$i]))
                    {
                        $dataGrouped[$key][$i] = null;
                    }
                }
            }

            foreach ($dataGrouped as $key => $dataGroupedSingleItem) {
                ksort($dataGroupedSingleItem);
                $dataGrouped[$key] = $dataGroupedSingleItem;
            }

            $ownersDataResult['data'] = $dataGrouped;
            $ownersDataResult['dataGroupFrom'] = $graphDataResultFrom;
            $ownersDataResult['dataGroupTo'] = $graphDataResultTo;
            $ownersDataResult['colorPattern'] = array_values($colorPatternResult);
            $ownersDataResult['fullColorPattern'] = $fullColorPattern;
            $ownersDataResult['comparisonData'] = $comparisonData;
            if ($compareToData !== false) {
                $ownersDataResult['dataToCompare'] = true;
            }

            if(!empty($additionalFilterParams)) {
                $leadActivityIds = array();

                $ownersDataResult['additionalFilterPreset'][] = 'x';

                foreach ($additionalFilterParams as $additionalParam) {
                    if(!empty($ownerData[$additionalParam])) {
                        if($additionalParam == 'activity_id') {

                            foreach ($allNames as $uId => $name) {
                                foreach ($ownersData as $ownerData) {
                                    if($uId == $ownerData['id']) {
                                        $leadActivityIds[$uId][] = $ownerData['activity_id'];
                                    }
                                }
                            }
                        }
                    }
                }

                if(!empty($leadActivityIds)) {
                    foreach ($leadActivityIds as $typeIds) {
                        $additionalFilterPreset = '&activity_id=' . implode(',', $typeIds);
                        $ownersDataResult['additionalFilterPreset'][] = $additionalFilterPreset;
                    }
                }
            }


        }

        return $ownersDataResult;

    }


    /**
     * Prepare comparison data for bar graph aggregated
     *
     * @param array $graphsData graph data aggregated
     * @param array $names names/descriptionData data
     * @param bool $useAmountAsValue flag use amount as value
     * @param string $limitCalculationByBarId limit by bar id
     * @return array
     */
    public static function prepareComparisonDataForLeadsDataAggregatedBar(
        $graphsData,
        $names,
        $useAmountAsValue = false,
        $limitCalculationByBarId = '0'
    ) {
        $result = array();
        if (!empty($graphsData)) {
            $aggregatedData = array();
            foreach ($graphsData as $graphData) {
                $id = $graphData['id'];
                $type = $graphData['type'];
                $uniqueKey = $id . '_' . $type;
                $count = 'count';
                if ($useAmountAsValue === true) {
                    $count = 'amount';
                }
                if (!empty($limitCalculationByBarId)) {
                    if ($graphData['barId'] === $limitCalculationByBarId) {
                        if (empty($aggregatedData[$uniqueKey][$count])) {
                            $aggregatedData[$uniqueKey][$count] = $graphData[$count];
                            $aggregatedData[$uniqueKey]['uniqueId'] = $graphData['uniqueId'];
                            $aggregatedData[$uniqueKey]['type'] = $type;
                            $aggregatedData[$uniqueKey]['full_name'] = $graphData['full_name'];
                            $aggregatedData[$uniqueKey]['description'] = $graphData['description'];
                            $aggregatedData[$uniqueKey]['barId'] = $graphData['barId'];
                            $aggregatedData[$uniqueKey]['id'] = $graphData['id'];
                        } else {
                            $aggregatedData[$uniqueKey][$count] = $aggregatedData[$uniqueKey][$count] + $graphData[$count];
                        }
                    } else {
                        if (empty($aggregatedData[$uniqueKey][$count])) {
                            $aggregatedData[$uniqueKey][$count] = 0;
                            $aggregatedData[$uniqueKey]['uniqueId'] = $graphData['uniqueId'];
                            $aggregatedData[$uniqueKey]['type'] = $type;
                            $aggregatedData[$uniqueKey]['full_name'] = $graphData['full_name'];
                            $aggregatedData[$uniqueKey]['description'] = $graphData['description'];
                            $aggregatedData[$uniqueKey]['barId'] = $graphData['barId'];
                            $aggregatedData[$uniqueKey]['id'] = $graphData['id'];
                        } else {
                            $aggregatedData[$uniqueKey][$count] = $aggregatedData[$uniqueKey][$count] + 0;
                        }
                    }
                } else {
                    if (empty($aggregatedData[$uniqueKey][$count])) {
                        $aggregatedData[$uniqueKey][$count] = $graphData[$count];
                        $aggregatedData[$uniqueKey]['uniqueId'] = $graphData['uniqueId'];
                        $aggregatedData[$uniqueKey]['type'] = $type;
                        $aggregatedData[$uniqueKey]['full_name'] = $graphData['full_name'];
                        $aggregatedData[$uniqueKey]['description'] = $graphData['description'];
                        $aggregatedData[$uniqueKey]['barId'] = $graphData['barId'];
                        $aggregatedData[$uniqueKey]['id'] = $graphData['id'];
                    } else {
                        $aggregatedData[$uniqueKey][$count] = $aggregatedData[$uniqueKey][$count] + $graphData[$count];
                    }
                }

            }
            $result = self::calculateComparisonDataForBarGraphs($aggregatedData, $names, $useAmountAsValue);
        }

        return $result;
    }

    /**
     * Prepare comparison data for bar graph
     *
     * @param array $graphsData graph data
     * @param array $names names/descriptionData data
     * @param bool $useAmountAsValue flag use amount as value
     * @return array
     */
    public static function calculateComparisonDataForBarGraphs($graphsData, $names, $useAmountAsValue = false)
    {
        $result = array();
        if (!empty($graphsData)) {
            $excludeIds = array();
            foreach ($graphsData as $graphData) {
                $increment = 0;
                $incrementSymbol = 'none';
                $incrementSymbolLabel = '';
                $id = $graphData['id'];
                $type = $graphData['type'];
                $count = 'count';
                if ($useAmountAsValue === true) {
                    $count = 'amount';
                }

                $quantity = $graphData[$count];
                if (!in_array($id, $excludeIds)) {
                    if ($type === 'current') {
                        $uniqueKey = $id . '_previous';
                    } else {
                        $uniqueKey = $id . '_current';
                    }

                    if (array_key_exists($uniqueKey, $graphsData)) {
                        $quantityToCompare = $graphsData[$uniqueKey][$count];
                    } else {
                        $quantityToCompare = 0;
                    }

                    if ($type === 'current' && !empty($quantityToCompare)) {
                        $increment = abs(round(($quantity / $quantityToCompare) * 100) - 100);
                        if ($quantity > $quantityToCompare) {
                            $incrementSymbol = 'plus';
                            $incrementSymbolLabel = '+';
                        } elseif ($quantity < $quantityToCompare) {
                            $incrementSymbol = 'minus';
                            $incrementSymbolLabel = '-';
                        }
                    } elseif ($type === 'current') {
                        $increment = intval($quantity * 100);
                        $incrementSymbol = 'plus';
                        $incrementSymbolLabel = '+';
                    }

                    if ($type === 'previous' && !empty($quantityToCompare)) {
                        $increment = abs(round(($quantity/ $quantityToCompare) * 100) - 100);
                        if ($quantityToCompare > $quantity) {
                            $incrementSymbol = 'plus';
                            $incrementSymbolLabel = '+';
                        } elseif ($quantityToCompare < $quantity) {
                            $incrementSymbol = 'minus';
                            $incrementSymbolLabel = '-';
                        }
                    } elseif ($type === 'previous') {
                        $increment = intval($quantity * 100);
                        $incrementSymbol = 'minus';
                        $incrementSymbolLabel = '-';
                    }

                    array_push($excludeIds, $id);
                    $result[$id]['increment'] = $increment;
                    $result[$id]['incrementSymbol'] = $incrementSymbol;
                    $result[$id]['incrementSymbolLabel'] = $incrementSymbolLabel;
                    $result[$id]['description'] = $names[$id];
                }
            }
        }


        return $result;
    }



    /**
     * Prepare data for the opportunity stages bar chart (per owner chart)
     *
     * @param array $ownersData owners data
     * @param bool $compareToData flag to process compared data
     * @param bool $useAmountAsValue flag use amount as value
     * @return array
     */
    public static function prepareLeadStageOwnersDataAggregated($ownersData, $compareToData = false, $useAmountAsValue = false)
    {
        $ownersDataResult = array();
        if (!empty($ownersData)) {
            $ownersDataResult['axes'] = array();
            $ownersDataResult['axesAdditionalInfo'] = array();
            $ownersDataResult['data'] = array();
            if ($compareToData !== false) {
                $ownersDataResult['dataToCompare'] = array();
            }
            $usedOwnerNames = array();
            $ownersNamesArray = array();
            $opportunitiesData = array();
            $opportunitiesDataResultFrom = array();
            $opportunitiesDataResultTo = array();
            $colorPatternResult = array();
            $fullColorPattern = array();
            $allNames = array();
            array_push($ownersDataResult['axes'], 'x');
            array_push($ownersDataResult['axesAdditionalInfo'], 'x');
            if ($compareToData !== false) {
                array_push($ownersDataResult['dataToCompare'], 'dataToCompare');
            }

            $excludeOwnerIds = array();

            foreach ($ownersData as $key => $ownerData) {
                $currentOwnerName = $ownerData['full_name'];
                $addName = false;
                $opportunitiesData[$ownerData['opportunityId']]['opportunityName'] = $ownerData['description'];
                if (!array_key_exists($ownerData['full_name'], $usedOwnerNames)) {
                    $usedOwnerNames[$currentOwnerName]['id'] = $ownerData['id'];
                    $usedOwnerNames[$currentOwnerName]['count'] = 0;
                    $addName = true;
                } elseif($usedOwnerNames[$currentOwnerName]['id'] != $ownerData['id'] && !in_array($ownerData['id'], $excludeOwnerIds)) {
                    $usedOwnerNames[$currentOwnerName]['count'] = $usedOwnerNames[$currentOwnerName]['count'] + 1;
                    $currentOwnerName = $currentOwnerName . '_' . $usedOwnerNames[$currentOwnerName]['count'];
                    $addName = true;
                }

                if (!array_key_exists($ownerData['id'], $allNames)) {
                    $allNames[$ownerData['id']] = $currentOwnerName;
                }

                if ($addName === true) {
                    array_push($ownersDataResult['axes'], $currentOwnerName);
                    array_push($ownersDataResult['axesAdditionalInfo'],  $ownerData['id']);
                    $ownersNamesArray[$ownerData['id']]['id'] = $ownerData['id'];
                    $ownersNamesArray[$ownerData['id']]['position'] = count($ownersDataResult['axes']) - 1;
                }

                array_push($excludeOwnerIds, $ownerData['id']);
            }

            $comparisonData = array();
            if ($compareToData !== false) {
                $comparisonData = self::prepareComparisonDataForBarGraphsAggregated($ownersData, $allNames, $useAmountAsValue);
            }

            foreach ($opportunitiesData as $opportunityId => $opportunityName) {
                $percentPrefix = '';
                if ($opportunityId != '1' && $opportunityId != '100') {
                    $percentPrefix = ' ('.$opportunityId.'%)';
                }
                array_push($opportunitiesDataResultFrom, $opportunityName['opportunityName'].$percentPrefix);
                //$colorPatternResult[] = self::$_opportunityColors[$opportunityId];
                if ($compareToData !== false) {
                    array_push($opportunitiesDataResultTo, '*'.$opportunityName['opportunityName'].$percentPrefix);
                }
                $opportunitiesData[$opportunityId]['position'] = count($opportunitiesDataResultFrom);

            }

            $opportunitiesDataGrouped = array();

            foreach ($ownersData as $key => $ownerData) {
                $percentPrefix = '';
                if ($ownerData['opportunityId'] != '1' && $ownerData['opportunityId'] != '100') {
                    $percentPrefix = ' ('.$ownerData['opportunityId'].'%)';
                }

                $opportunityName = $ownerData['description'].$percentPrefix;

                if ($compareToData !== false && $ownerData['type'] === 'previous') {
                    $opportunityName = '*'.$ownerData['description'].$percentPrefix;
                }

                //Add colors
                if ($ownerData['type'] === 'current' && !in_array(self::$_opportunityColors[$ownerData['opportunityId']], $colorPatternResult)) {
                    $colorPatternResult[] = self::$_opportunityColors[$ownerData['opportunityId']];
                    $fullColorPattern[$opportunityName] =  self::$_opportunityColors[$ownerData['opportunityId']];
                }

                if ($ownerData['type'] === 'previous'  && !in_array(self::$_opportunityColorsForCompare[$ownerData['opportunityId']], $colorPatternResult)) {
                    $colorPatternResult[] = self::$_opportunityColorsForCompare[$ownerData['opportunityId']];
                    $fullColorPattern[$opportunityName] =  self::$_opportunityColors[$ownerData['opportunityId']];
                }


                $opportunitiesDataGrouped[$ownerData['opportunityId'].'_'.$ownerData['type']][0] = $opportunityName;
                $position = $ownersNamesArray[$ownerData['id']]['position'];
                if ($useAmountAsValue === true) {
                    $opportunitiesDataGrouped[$ownerData['opportunityId'] . '_' . $ownerData['type']][$position] = $ownerData['amount'];
                } else {
                    $opportunitiesDataGrouped[$ownerData['opportunityId'] . '_' . $ownerData['type']][$position] = $ownerData['count'];
                }
            }

            foreach ($opportunitiesDataGrouped as $key => $opportunitiesDataGroupedSingleItem) {
                //end($opportunitiesDataGroupedSingleItem);
                //$quantity = key($opportunitiesDataGroupedSingleItem);
                $quantity = count($ownersNamesArray) + 1;
                for($i = 0; $i < $quantity; $i++)
                {
                    if(!isset($opportunitiesDataGrouped[$key][$i]))
                    {
                        $opportunitiesDataGrouped[$key][$i] = null;
                    }
                }

            }

            foreach ($opportunitiesDataGrouped as $key => $opportunitiesDataGroupedSingleItem) {
                ksort($opportunitiesDataGroupedSingleItem);
                $opportunitiesDataGrouped[$key] = $opportunitiesDataGroupedSingleItem;
            }

            $ownersDataResult['data'] = $opportunitiesDataGrouped;
            $ownersDataResult['opportunitiesGroupFrom'] = $opportunitiesDataResultFrom;
            $ownersDataResult['opportunitiesGroupTo'] = $opportunitiesDataResultTo;
            $ownersDataResult['colorPattern'] = array_values($colorPatternResult);
            $ownersDataResult['fullColorPattern'] = $fullColorPattern;
            $ownersDataResult['comparisonData'] = $comparisonData;
            if ($compareToData !== false) {
                $ownersDataResult['dataToCompare'] = true;
            }


        }

        return $ownersDataResult;

    }

    /**
     * prepare opportunity stages for funnel
     *
     * @param $opportunitiesStagesFunnelData
     * @return array
     */
    public static function prepareOpportunityStageFunnel($opportunitiesStagesFunnelData)
    {
        $opportunitiesStagesResult = array();
        $opportunitiesResult = array();
        if (!empty($opportunitiesStagesFunnelData)) {
            foreach ($opportunitiesStagesFunnelData as $opportunitiesStage) {
                $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId'].'%']['count'] = $opportunitiesStage['count'];
                $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId'].'%']['color'] = self::$_opportunityColorsForCompare[$opportunitiesStage['opportunityStageId']];
                $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId'].'%']['stageName'] = $opportunitiesStage['opportunityStageDescription'];
                $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId'].'%']['amount'] = $opportunitiesStage['opportunityValue'];
                $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId'].'%']['leadsCount'] = $opportunitiesStage['leadsCount'];
            }
            $opportunitiesResult['data'] = $opportunitiesStagesResult;
        }

        return $opportunitiesResult;
    }


    /**
     * prepare sales expectation
     *
     * @param $opportunitiesStagesFunnelData
     * @return array
     */
    public static function prepareSalesExpectation($opportunitiesStagesFunnelData)
    {
        $salesExpectationResult = 0;
        if (!empty($opportunitiesStagesFunnelData)) {
            foreach ($opportunitiesStagesFunnelData as $opportunitiesStage) {
                $salesExpectationResult += (($opportunitiesStage['opportunityValue'])/100)*$opportunitiesStage['opportunityStageId'];
            }
        }

        return $salesExpectationResult;
    }

    /**
     * prepare pipeline size
     *
     * @param $opportunitiesStagesData
     * @return int|mixed
     */
    public static function preparePipelineSize($opportunitiesStagesData)
    {
        $salesPipelineSizeResult = 0;
        if (!empty($opportunitiesStagesData)) {
            foreach ($opportunitiesStagesData as $opportunitiesStage) {
                $salesPipelineSizeResult += $opportunitiesStage['opportunityValue'];
            }
        }

        return $salesPipelineSizeResult;
    }

    /**
     * prepare opportunity stages for pie chart
     *
     * @param array $opportunitiesStagesData opportunityStagesData
     * @param bool $groupAllActiveStatuses
     * @return array
     */
    public static function prepareOpportunityStagePie($opportunitiesStagesData, $groupAllActiveStatuses = false)
    {
        $opportunitiesStagesResult = array();
        $opportunitiesResult = array();
        $opportunitiesColors = array();
        $axesAdditionalInfo = array();
        $translator = Zend_Registry::get('Zend_Translate');
        if (!empty($opportunitiesStagesData)) {
            foreach ($opportunitiesStagesData as $opportunitiesStage) {
                if ($groupAllActiveStatuses === false) {
                    $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['amount'] = $opportunitiesStage['amount'];
                    $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['percentage'] = 0;
                    $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['stageName'] = $opportunitiesStage['opportunityStageDescription'];
                    $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['count'] = $opportunitiesStage['count'];
                    $opportunitiesColors[] = self::$_opportunityPieColors[$opportunitiesStage['id']];
                    $axesAdditionalInfo[] = $opportunitiesStage['id'];
                } else {
                    if ($opportunitiesStage['opportunityStageId'] !== '100' && $opportunitiesStage['opportunityStageId'] !== '1') {
                        if ($opportunitiesStagesResult['99']['amount']) {
                            $opportunitiesStagesResult['99']['amount'] += $opportunitiesStage['amount'];
                        } else {
                            $opportunitiesStagesResult['99']['amount'] = $opportunitiesStage['amount'];
                        }
                        $opportunitiesStagesResult['99']['percentage'] = 0;
                        $opportunitiesStagesResult['99']['stageName'] = $translator->translate(Leads::TRANSLATION_PREFIX.'Open');
                        if (isset($opportunitiesStagesResult['99']['count'])) {
                            $opportunitiesStagesResult['99']['count'] += $opportunitiesStage['count'];
                        } else {
                            $opportunitiesStagesResult['99']['count'] = $opportunitiesStage['count'];
                        }

                        $additionalAxesPosition = array_search('99', $axesAdditionalInfo);
                        if ($additionalAxesPosition === false) {
                            $axesAdditionalInfo[] = '99';
                            $opportunitiesColors[] = self::$_opportunityPieColors['99'];
                        }
                    } else {
                        $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['amount'] = $opportunitiesStage['amount'];
                        $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['stageName'] = $opportunitiesStage['opportunityStageDescription'];
                        $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['count'] = $opportunitiesStage['count'];
                        $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['percentage'] = 0;
                        $opportunitiesColors[] = self::$_opportunityPieColors[$opportunitiesStage['id']];
                        $axesAdditionalInfo[] = $opportunitiesStage['id'];
                    }
                }
            }

            $fullAmount = 0;

            if (!empty($opportunitiesStagesResult)) {
                foreach ($opportunitiesStagesResult as $opportunitiesStagesRes) {
                    $fullAmount += $opportunitiesStagesRes['amount'];
                }
            }

            if (!empty($fullAmount) && !empty($opportunitiesStagesResult)) {
                foreach ($opportunitiesStagesResult as $key => $opportunitiesStagesRes) {
                    if (empty($opportunitiesStagesRes['amount']) || empty($fullAmount)) {
                        $opportunitiesStagesResult[$key]['percentage'] = 0;
                    } else {
                        $opportunitiesStagesResult[$key]['percentage'] = round($opportunitiesStagesRes['amount'] / $fullAmount * 100);
                    }
                }
            }

            $opportunitiesResult['data'] = $opportunitiesStagesResult;
            $opportunitiesResult['colorPattern'] = array_values($opportunitiesColors);
            $opportunitiesResult['axesAdditionalInfo'] = $axesAdditionalInfo;
        }

        return $opportunitiesResult;
    }

    public static function prepareAmountQuoteAttainment($amount, $userId = 0, $period = 1)
    {
        $opportunitiesStagesResult = array();
        $opportunitiesResult = array();
        $opportunitiesColors = array();
        $axesAdditionalInfo = array();
        $translator = Zend_Registry::get('Zend_Translate');

        $leadsOwnerGoalsMapper = Leads_Mapper_LeadsOwnerGoalsMapper::getInstance();
        $leadOwnersGoal = $leadsOwnerGoalsMapper->getMainConfigData($userId);

        if (!empty($leadOwnersGoal)) {
            $quoteAttainmentAmount = 0;
            $numberOfGoals = count($leadOwnersGoal);
            foreach ($leadOwnersGoal as $leadOwnerGoal) {
                $quoteAttainmentAmount += $leadOwnerGoal['quotes_amount'];
            }

            if (empty($period)) {
                $period = 1;
            }

            $quoteAttainmentAmount = ($quoteAttainmentAmount*$period);

            $opportunitiesStagesResult['100']['amount'] = $amount;
            $opportunitiesStagesResult['100']['stageName'] = $translator->translate(Leads::TRANSLATION_PREFIX.'Won');
            if (empty($amount) || empty($quoteAttainmentAmount)) {
                $opportunitiesStagesResult['100']['percentage'] = 0;
            } else {
                $opportunitiesStagesResult['100']['percentage'] = round($amount / $quoteAttainmentAmount * 100);
            }
            $opportunitiesColors[] = self::$_opportunityPieColors['100'];
            if ($quoteAttainmentAmount > $amount) {
                $opportunitiesStagesResult['1000']['amount'] = $quoteAttainmentAmount - $amount;
                $opportunitiesStagesResult['1000']['stageName'] = $translator->translate(Leads::TRANSLATION_PREFIX.'Goal');
                if (empty($amount) || empty($quoteAttainmentAmount)) {
                    $opportunitiesStagesResult['1000']['percentage'] = 100;
                } else {
                    $opportunitiesStagesResult['1000']['percentage'] = 100 - round($amount / $quoteAttainmentAmount * 100);
                }
            }

            $opportunitiesColors[] = self::$_opportunityPieColors['1000'];

            $opportunitiesResult['data'] = $opportunitiesStagesResult;
            $opportunitiesResult['colorPattern'] = array_values($opportunitiesColors);
            $opportunitiesResult['axesAdditionalInfo'] = $axesAdditionalInfo;
        }

        return $opportunitiesResult;
    }

    /**
     * @param $onlineSalesStagesData
     * @return array
     */
    public static function prepareOnlineSalesStagePie($onlineSalesStagesData)
    {
        $opportunitiesStagesResult = array();
        $opportunitiesResult = array();
        if (!empty($onlineSalesStagesData)) {
            foreach ($onlineSalesStagesData as $opportunitiesStage) {
                $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['amount'] = $opportunitiesStage['amount'];
                $opportunitiesStagesResult[$opportunitiesStage['opportunityStageId']]['count'] = $opportunitiesStage['count'];
            }
            $opportunitiesResult['data'] = $opportunitiesStagesResult;
        }
        return $opportunitiesResult;
    }

    /**
     * prepare general stats data
     *
     * @param array $originalData origin data
     * @param bool $compareFlag flag for comparison
     * @param $compareData data to compare
     * @return array
     */
    public static function prepareStatsData($originalData, $compareFlag, $compareData)
    {
        $result = array();
        if (!empty($compareFlag)) {
            $increment = 0;
            $incrementSymbol = 'none';
            $incrementSymbolLabel = '';
            if (!empty($originalData['quantity']) && !empty($compareData['quantity'])) {
                if ($originalData['quantity'] > $compareData['quantity']) {
                    $increment = abs(round(($originalData['quantity'] / $compareData['quantity']) * 100) - 100);
                    $incrementSymbol = 'plus';
                    $incrementSymbolLabel = '+';
                } elseif ($originalData['quantity'] < $compareData['quantity']) {
                    $increment = abs(round(($compareData['quantity'] / $originalData['quantity']) * 100) - 100);
                    $incrementSymbol = 'minus';
                    $incrementSymbolLabel = '-';
                }

            } elseif (!empty($compareData['quantity'])) {
                $increment = intval($compareData['quantity'] * 100);
                $incrementSymbol = 'minus';
                $incrementSymbolLabel = '-';
            } elseif (!empty($originalData['quantity'])) {
                $increment = intval($originalData['quantity'] * 100);
                $incrementSymbol = 'plus';
                $incrementSymbolLabel = '+';
            }

            $result['increment'] = $increment;
            $result['incrementSymbol'] = $incrementSymbol;
            $result['incrementSymbolLabel'] = $incrementSymbolLabel;
        }

        if (empty($originalData['quantity'])) {
            $result['quantity'] = 0;
        } else {
            $result['quantity'] = $originalData['quantity'];
        }

        return $result;
    }

    /**
     * Prepare comparison data for bar graph
     *
     * @param array $graphsData graph data
     * @param array $names names/descriptionData data
     * @param bool $useAmountAsValue flag use amount as value
     * @return array
     */
    public static function prepareComparisonDataForBarGraphs($graphsData, $names, $useAmountAsValue = false)
    {
        $result = array();
        if (!empty($graphsData)) {
            $excludeIds = array();
            foreach ($graphsData as $graphData) {
                $increment = 0;
                $incrementSymbol = 'none';
                $incrementSymbolLabel = '';
                $id = $graphData['id'];
                $type = $graphData['type'];
                $count = 'count';
                if ($useAmountAsValue === true) {
                    $count = 'amount';
                }

                $quantity = $graphData[$count];
                if (!in_array($id, $excludeIds)) {
                    if ($type === 'current') {
                        $uniqueKey = $id . '_previous';
                    } else {
                        $uniqueKey = $id . '_current';
                    }

                    if (array_key_exists($uniqueKey, $graphsData)) {
                        $quantityToCompare = $graphsData[$uniqueKey][$count];
                    } else {
                        $quantityToCompare = 0;
                    }

                    if ($type === 'current' && !empty($quantityToCompare)) {
                        $increment = abs(round(($quantity / $quantityToCompare) * 100) - 100);
                        if ($quantity > $quantityToCompare) {
                            $incrementSymbol = 'plus';
                            $incrementSymbolLabel = '+';
                        } elseif ($quantity < $quantityToCompare) {
                            $incrementSymbol = 'minus';
                            $incrementSymbolLabel = '-';
                        }
                    } elseif ($type === 'current') {
                        $increment = intval($quantity * 100);
                        $incrementSymbol = 'plus';
                        $incrementSymbolLabel = '+';
                    }

                    if ($type === 'previous' && !empty($quantityToCompare)) {
                        $increment = abs(round(($quantity/ $quantityToCompare) * 100) - 100);
                        if ($quantityToCompare > $quantity) {
                            $incrementSymbol = 'plus';
                            $incrementSymbolLabel = '+';
                        } elseif ($quantityToCompare < $quantity) {
                            $incrementSymbol = 'minus';
                            $incrementSymbolLabel = '-';
                        }
                    } elseif ($type === 'previous') {


                        $increment = intval($quantity * 100);
                        $incrementSymbol = 'minus';
                        $incrementSymbolLabel = '-';
                    }

                    array_push($excludeIds, $id);
                    $result[$id]['increment'] = $increment;
                    $result[$id]['incrementSymbol'] = $incrementSymbol;
                    $result[$id]['incrementSymbolLabel'] = $incrementSymbolLabel;
                    $result[$id]['description'] = $names[$id];
                }
            }
        }


        return $result;
    }

    /**
     * Prepare comparison data for bar graph aggregated
     *
     * @param array $graphsData graph data aggregated
     * @param array $names names/descriptionData data
     * @param bool $useAmountAsValue flag use amount as value
     * @return array
     */
    public static function prepareComparisonDataForBarGraphsAggregated($graphsData, $names, $useAmountAsValue = false)
    {
        $result = array();
        if (!empty($graphsData)) {
            $aggregatedData = array();
            foreach ($graphsData as $graphData) {
                $id = $graphData['id'];
                $type = $graphData['type'];
                $uniqueKey = $id . '_' . $type;
                $count = 'count';
                if ($useAmountAsValue === true) {
                    $count = 'amount';
                    if ($graphData['opportunityId'] != '100') {
                        continue;
                    }
                }
                if (empty($aggregatedData[$uniqueKey][$count])) {
                    $aggregatedData[$uniqueKey][$count] = $graphData[$count];
                    $aggregatedData[$uniqueKey]['uniqueId'] = $graphData['uniqueId'];
                    $aggregatedData[$uniqueKey]['type'] = $type;
                    $aggregatedData[$uniqueKey]['full_name'] = $graphData['full_name'];
                    $aggregatedData[$uniqueKey]['description'] = $graphData['description'];
                    $aggregatedData[$uniqueKey]['opportunityId'] = $graphData['opportunityId'];
                    $aggregatedData[$uniqueKey]['id'] = $graphData['id'];
                } else {
                    $aggregatedData[$uniqueKey][$count] = $aggregatedData[$uniqueKey][$count] + $graphData[$count];
                }

            }
            $result = self::prepareComparisonDataForBarGraphs($aggregatedData, $names, $useAmountAsValue);
        }

        return $result;
    }


    /**
     * Prepare comparison data for bar graph
     *
     * @param array $comparisonData graph data
     * @return array
     */
    public static function prepareComparisonForFunnelData($comparisonData)
    {
        $result = array();
        $names = array();
        if (!empty($comparisonData)) {
            foreach ($comparisonData as $data) {
                if ($data['opportunityStageId'] != '1' && $data['opportunityStageId'] != '100') {
                    $names[$data['id']] = $data['opportunityStageDescription']. ' ('. $data['opportunityStageId'].'%'.')';
                } else {
                    $names[$data['id']] = $data['opportunityStageDescription'];
                }
            }

            $result = self::prepareComparisonDataForBarGraphs($comparisonData, $names);
        }

        return $result;
    }

    /**
     * @param $onlineSalesStagesPieDataAmount
     * @param $onlineSalesStagesPieCompareDataAmount
     * @return array
     */
    public static function prepareCompareOnlineSalesData($onlineSalesStagesPieDataAmount, $onlineSalesStagesPieCompareDataAmount) {
        $result = array();
        $pieData = $onlineSalesStagesPieDataAmount;
        $pieCompareData = $onlineSalesStagesPieCompareDataAmount;
        $incrementSymbol = 'none';
        $incrementSymbolLabel = '';

        if(!empty($pieData['count']) && $pieCompareData['count']) {
            $increment = abs(round(($pieData['count'] / $pieCompareData['count']) * 100) - 100);

            if ($pieData['count'] > $pieCompareData['count']) {
                $incrementSymbol = 'plus';
                $incrementSymbolLabel = '+';
            } elseif ($pieData['count'] < $pieCompareData['count']) {
                $incrementSymbol = 'minus';
                $incrementSymbolLabel = '-';
            }

            $result[100]['increment'] = $increment;
            $result[100]['incrementSymbol'] = $incrementSymbol;
            $result[100]['incrementSymbolLabel'] = $incrementSymbolLabel;
            $result[100]['description'] = '';

            return $result;
        }
    }

    /**
     * return separated value|decimalSeparator value
     * @param $separateValue
     * @return mixed
     * @throws Zend_Locale_Exception
     */
    public static function decimalSeparator($separateValue){
        $locale = Zend_Locale::getLocaleToTerritory(Models_Mapper_ShoppingConfig::getInstance()->getConfigParam('country'));
        $symbols = Zend_Locale_Data::getList($locale,'symbols');

        if(!empty($separateValue)) {
            $separateValueResult = str_replace('.', $symbols['decimal'], $separateValue);
            if(isset($separateValueResult)) {
                $separateValue = $separateValueResult;
            }
            return $separateValue;
        }

        return $symbols['decimal'];
    }
}
