<?php

/**
 * Class Tools_LeadSmsTools
 */
class Tools_LeadSmsTools
{
    /**
     * Parse widgets lexems
     *
     * @param $smsMessage
     * @param $leadData
     * @param $websiteUrl
     * @param $excludeTags
     * @return string
     */
    public static function addDictionarySmsFields($smsMessage, $leadData, $websiteUrl, $excludeTags = '') {
        $userMapper = Application_Model_Mappers_UserMapper::getInstance();
        $leadOwnerId = $leadData->getOwnerId();

        $leadOwnerFullname = '';
        $leadOwnerEmail = '';
        $leadOwnerFullMobilePhone = '';
        $leadOwnerFullDesktopPhone = '';
        $leadOwnerSignature = '';
        $leadOrganizationName = '';
        $leadOwnerPersonalcalendarurl = '';
        $leadOwnerAvatarlink = '';
        $leadOrganizationWebsite = '';
        $fulldesktopphone = '';
        $fullmobilephone = '';


        if(!empty($leadOwnerId)) {
            $ownerModel = $userMapper->find($leadOwnerId);

            if ($ownerModel instanceof Application_Model_Models_User) {
                $leadOwnerFullname = $ownerModel->getFullName();
                $leadOwnerEmail = $ownerModel->getEmail();
                $leadOwnerFullMobilePhone = $ownerModel->getMobileCountryCodeValue() . $ownerModel->getMobilePhone();
                $leadOwnerFullDesktopPhone = $ownerModel->getDesktopCountryCodeValue() . $ownerModel->getDesktopPhone();
                $leadOwnerSignature = $ownerModel->getSignature();
                $leadOwnerPersonalcalendarurl = $ownerModel->getPersonalCalendarUrl();
                $leadOwnerAvatarlink = $ownerModel->getAvatarLink();
            }
        }
        $organizationId = $leadData->getOrganizationId();
        if(!empty($organizationId)) {
            $leadOrganizationMapper = Leads_Mapper_LeadsOrganizationMapper::getInstance();
            $leadOrganization = $leadOrganizationMapper->find($organizationId);

            if($leadOrganization instanceof Leads_Model_LeadsOrganizationModel) {
                $leadOrganizationName = $leadOrganization->getOrganizationName();
                $leadOrganizationWebsite = $leadOrganization->getOrganizationWebsite();
            }
        }

        $fullDesktopPhone = $leadData->getLeadPhone();
        if (!empty($fullDesktopPhone)) {
            $fulldesktopphone = $leadData->getLeadPhoneCountryCodeValue() . $fullDesktopPhone;
        }

        $fullMobilePhone = $leadData->getLeadMobile();
        if (!empty($fullMobilePhone)) {
            $fullmobilephone = $leadData->getLeadMobileCountryCodeValue() . $fullMobilePhone;
        }

        $prefix = $leadData->getPrefix();
        if (empty($prefix)) {
            $prefix = '';
        }

        $position = $leadData->getLeadPosition();
        if (empty($position)) {
            $position = '';
        }

        $middlename = $leadData->getMiddleName();
        if (empty($middlename)) {
            $middlename = '';
        }

        $dictionary = array(
            '$lead:firstname'                => $leadData->getLeadFirstName(),
            '$lead:lastname'                 => $leadData->getLeadLastName(),
            '$lead:source'                   => $leadData->getLeadSource(),
            '$leadowner:fullname'            => $leadOwnerFullname,
            '$leadowner:email'               => $leadOwnerEmail,
            '$leadowner:fullmobilephone'     => $leadOwnerFullMobilePhone,
            '$leadowner:fulldesktopphone'    => $leadOwnerFullDesktopPhone,
            '$leadowner:signature'           => $leadOwnerSignature,
            '$lead:organizationname'         => $leadOrganizationName,
            '$website:url'                   => $websiteUrl,
            '$lead:organizationlogo'         => '',
            '$lead:organizationlogo:src'     => '',
            '$leadowner:personalcalendarurl' => $leadOwnerPersonalcalendarurl,
            '$leadowner:avatarlink'          => '',
            '$leadowner:avatarlink:src'      => $leadOwnerAvatarlink,
            '$lead:leadfullnamelink'         => $leadData->getLeadFirstName() . ' ' .$leadData->getLeadLastName(),
            '$lead:organizationnamelink'     => $leadOrganizationName,
            '$lead:organizationwebsite'      => $leadOrganizationWebsite,
            '$lead:fulldesktopphone'         => $fulldesktopphone,
            '$lead:fullmobilephone'          => $fullmobilephone,
            '$lead:prefix'                   => $prefix,
            '$lead:position'                 => $position,
            '$lead:middlename'               => $middlename,

        );

        $entityParser = new Tools_Content_EntityParser();

        $entityParser->addToDictionary($dictionary);

        if (!empty($excludeTags)) {
            return $entityParser->parse(strip_tags($smsMessage, $excludeTags));
        }

        return $entityParser->parse(strip_tags($smsMessage));
    }
}
