<?php

/**
 * Class Lead_LeadTablesTools
 */
class Tools_LeadTablesTools
{

    const LATEST_LEAD_TABLE_COLUMN_ORDER_NAME = 'dashboard_latest_leads';

    const ENGAGED_LEAD_TABLE_COLUMN_ORDER_NAME = 'dashboard_engaged_leads';

    public static function getLatestLeadsTableColumnHeaders()
    {
        $columnHeaders = array(
            'placeholder' => array('name' => 'placeholder', 'message' => 'tableEmptySpace', 'editable' => false),
            'id' => array('name' => 'id', 'message' => 'tableSymbolSharp', 'editable' => false),
            'name' => array('name' => 'name', 'message' => 'engagedName', 'editable' => true),
            'organization' => array('name' => 'organization', 'message' => 'engagedOrganization', 'editable' => true),
            'leadEmail' => array('name' => 'leadEmail', 'message' => 'engagedEmail', 'editable' => true),
            'leadPhone' => array('name' => 'leadPhone', 'message' => 'engagedPhone', 'editable' => true),
            'leadCreatedAt' => array('name' => 'leadCreatedAt', 'message' => 'engagedCreatedAt', 'editable' => true),
            'leadType' => array('name' => 'leadType', 'message' => 'engagedLeadType', 'editable' => true),
            'leadOwner' => array('name' => 'leadOwner', 'message' => 'engagedLeadOwner', 'editable' => true),
            'leadGroup' => array('name' => 'leadGroup', 'message' => 'tableLeadGroup', 'editable' => true),
            'actions' => array('name' => 'actions', 'message' => 'engagedActions', 'editable' => false),
            'state' => array('name' => 'state', 'message' => 'tableState', 'editable' => true),
            'city' => array('name' => 'city', 'message' => 'tableCity', 'editable' => true),
            'country' => array('name' => 'country', 'message' => 'tableCountry', 'editable' => true),
            'address' => array('name' => 'address', 'message' => 'tableAddress', 'editable' => true),
            'address1' => array('name' => 'address1', 'message' => 'tableAddress1', 'editable' => true),
            'zip' => array('name' => 'zip', 'message' => 'tableZip', 'editable' => true),
            'leadMobile' => array('name' => 'leadMobile', 'message' => 'tableMobile', 'editable' => true),
            'position' => array('name' => 'position', 'message' => 'tablePosition', 'editable' => true),
            'organizationAddress' => array('name' => 'organizationAddress', 'message' => 'tableOrganizationAddress', 'editable' => true),
            'organizationCity' => array('name' => 'organizationCity', 'message' => 'tableOrganizationCity', 'editable' => true),
            'organizationZip' => array('name' => 'organizationZip', 'message' => 'tableOrganizationZip', 'editable' => true),
            'organizationAddress1' => array('name' => 'organizationAddress1', 'message' => 'tableOrganizationAddress1', 'editable' => true),
            'organizationEmail' => array('name' => 'organizationEmail', 'message' => 'tableOrganizationEmail', 'editable' => true),
            'organizationCountry' => array('name' => 'organizationCountry', 'message' => 'tableOrganizationCountry', 'editable' => true),
            'organizationWebsite' => array('name' => 'organizationWebsite', 'message' => 'tableOrganizationWebsite', 'editable' => true),
            'organizationMobile' => array('name' => 'organizationMobile', 'message' => 'tableOrganizationMobile', 'editable' => true),
            'organizationPhone' => array('name' => 'organizationPhone', 'message' => 'tableOrganizationPhone', 'editable' => true),
            'organizationIndustry' => array('name' => 'organizationIndustry', 'message' => 'tableOrganizationIndustry', 'editable' => true),
            'organizationGroup' => array('name' => 'organizationGroup', 'message' => 'tableOrganizationGroup', 'editable' => true),

        );

        return $columnHeaders;
    }

    public static function getEngagedLeadsTableColumnHeaders()
    {
        $columnHeaders = array(
            'placeholder' => array('name' => 'placeholder', 'message' => 'tableEmptySpace', 'editable' => false),
            'id' => array('name' => 'id', 'message' => 'tableSymbolSharp', 'editable' => false),
            'name' => array('name' => 'name', 'message' => 'engagedName', 'editable' => true),
            'organization' => array('name' => 'organization', 'message' => 'engagedOrganization', 'editable' => true),
            'totalOppsAmount' => array('name' => 'totalOppsAmount', 'message' => 'tableTotalOppsAmount', 'editable' => true),
            'score' => array('name' => 'score', 'message' => 'tableScore', 'editable' => true),
            'leadEmail' => array('name' => 'leadEmail', 'message' => 'engagedEmail', 'editable' => true),
            'leadPhone' => array('name' => 'leadPhone', 'message' => 'engagedPhone', 'editable' => true),
            'leadCreatedAt' => array('name' => 'leadCreatedAt', 'message' => 'engagedCreatedAt', 'editable' => true),
            'leadLastActivity' => array('name' => 'leadLastActivity', 'message' => 'tableEngagedLastActivity', 'editable' => true),
            'engagedLifecycle' => array('name' => 'engagedLifecycle', 'message' => 'tableEngagedLifecycle', 'editable' => true),
            'leadType' => array('name' => 'leadType', 'message' => 'engagedLeadType', 'editable' => true),
            'leadOwner' => array('name' => 'leadOwner', 'message' => 'engagedLeadOwner', 'editable' => true),
            'leadGroup' => array('name' => 'leadGroup', 'message' => 'tableLeadGroup', 'editable' => true),
            'actions' => array('name' => 'actions', 'message' => 'engagedActions', 'editable' => false),
            'state' => array('name' => 'state', 'message' => 'tableState', 'editable' => true),
            'city' => array('name' => 'city', 'message' => 'tableCity', 'editable' => true),
            'country' => array('name' => 'country', 'message' => 'tableCountry', 'editable' => true),
            'address' => array('name' => 'address', 'message' => 'tableAddress', 'editable' => true),
            'address1' => array('name' => 'address1', 'message' => 'tableAddress1', 'editable' => true),
            'zip' => array('name' => 'zip', 'message' => 'tableZip', 'editable' => true),
            'leadMobile' => array('name' => 'leadMobile', 'message' => 'tableMobile', 'editable' => true),
            'position' => array('name' => 'position', 'message' => 'tablePosition', 'editable' => true),
            'organizationAddress' => array('name' => 'organizationAddress', 'message' => 'tableOrganizationAddress', 'editable' => true),
            'organizationCity' => array('name' => 'organizationCity', 'message' => 'tableOrganizationCity', 'editable' => true),
            'organizationZip' => array('name' => 'organizationZip', 'message' => 'tableOrganizationZip', 'editable' => true),
            'organizationAddress1' => array('name' => 'organizationAddress1', 'message' => 'tableOrganizationAddress1', 'editable' => true),
            'organizationEmail' => array('name' => 'organizationEmail', 'message' => 'tableOrganizationEmail', 'editable' => true),
            'organizationCountry' => array('name' => 'organizationCountry', 'message' => 'tableOrganizationCountry', 'editable' => true),
            'organizationWebsite' => array('name' => 'organizationWebsite', 'message' => 'tableOrganizationWebsite', 'editable' => true),
            'organizationMobile' => array('name' => 'organizationMobile', 'message' => 'tableOrganizationMobile', 'editable' => true),
            'organizationPhone' => array('name' => 'organizationPhone', 'message' => 'tableOrganizationPhone', 'editable' => true),
            'organizationIndustry' => array('name' => 'organizationIndustry', 'message' => 'tableOrganizationIndustry', 'editable' => true),
            'organizationGroup' => array('name' => 'organizationGroup', 'message' => 'tableOrganizationGroup', 'editable' => true),

        );

        return $columnHeaders;
    }


    public static function getLatestLeadsTableDefaultColumnNamesOrder()
    {
        return array(
            'placeholder',
            'id',
            'name',
            'organization',
            'leadEmail',
            'leadPhone',
            'leadCreatedAt',
            'leadType',
            'leadOwner',
            'actions'
        );
    }

    public static function getEngagedLeadsTableDefaultColumnNamesOrder()
    {
        return array(
            'placeholder',
            'id',
            'score',
            'name',
            'organization',
            'leadEmail',
            'leadPhone',
            'totalOppsAmount',
            'leadLastActivity',
            'actions'
        );
    }

    public static function getTableColumnsInfo($tableColumnName)
    {

        $loggedUserRoleId = Zend_Controller_Action_HelperBroker::getStaticHelper('session')->getCurrentUser()->getRoleId();
        $currentUserId = Zend_Controller_Action_HelperBroker::getStaticHelper('session')->getCurrentUser()->getId();
        $translator = Zend_Registry::get('Zend_Translate');

        if ($tableColumnName === self::LATEST_LEAD_TABLE_COLUMN_ORDER_NAME) {
            $listOfDefaultColumnNamesOrder = Tools_LeadTablesTools::getLatestLeadsTableDefaultColumnNamesOrder();
            $columnHeaders = Tools_LeadTablesTools::getLatestLeadsTableColumnHeaders();
        }

        if ($tableColumnName === self::ENGAGED_LEAD_TABLE_COLUMN_ORDER_NAME) {
            $listOfDefaultColumnNamesOrder = Tools_LeadTablesTools::getEngagedLeadsTableDefaultColumnNamesOrder();
            $columnHeaders = Tools_LeadTablesTools::getEngagedLeadsTableColumnHeaders();
        }

        $leadsCustomParamsConfigMapper = Leads_Mapper_LeadsCustomParamsConfigMapper::getInstance();
        $where = $leadsCustomParamsConfigMapper->getDbTable()->getAdapter()->quoteInto('param_type IN (?)', 'text');
        $leadCustomParams = $leadsCustomParamsConfigMapper->fetchAll($where, null, null, null, true);
        $leadCustomFields = array();

        if (!empty($leadCustomParams)) {
            foreach ($leadCustomParams as $leadCustomParam) {
                $leadCustomFields[Tools_LeadInboundEmailTools::LEAD_CUSTOM_ATTRIBUTES_PREFIX.$leadCustomParam['param_type'].'_'.$leadCustomParam['param_name']] = array('name' => Tools_LeadInboundEmailTools::LEAD_CUSTOM_ATTRIBUTES_PREFIX.$leadCustomParam['param_type'].'_'.$leadCustomParam['param_name'], 'message' => $leadCustomParam['label'].' '.$translator->translate(Leads::TRANSLATION_PREFIX.'(Lead custom field)'), 'editable' => true, 'skipVUETranslator' => true);
            }
        }

        if(!empty($leadCustomFields)) {
            $columnHeaders = $columnHeaders + $leadCustomFields;
        }

        $definedColumnOrder = $listOfDefaultColumnNamesOrder;

        $data['restrictColumnEditing'] = 1;
        if ($loggedUserRoleId === Tools_Security_Acl::ROLE_SUPERADMIN || $loggedUserRoleId === Tools_Security_Acl::ROLE_ADMIN) {
            $data['restrictColumnEditing'] = 0;
        }

        $leadsTableColumnsOrderMapper = Leads_Mapper_LeadsTableColumnsOrderMapper::getInstance();

        $userPresetsList = $leadsTableColumnsOrderMapper->findUserPresets($tableColumnName, $currentUserId);
        $presetId = 0;

        $defaultTableColumnNameData = $leadsTableColumnsOrderMapper->findDefaultPreset($tableColumnName);
        if (!empty($defaultTableColumnNameData) && !empty($defaultTableColumnNameData['fields_data'])) {
            $definedColumnOrder = json_decode($defaultTableColumnNameData['fields_data']);
            $defaultTableColumnNameData['id'] = '0';
            $userPresetsList[0] = $defaultTableColumnNameData;
        }

        if (!empty($userPresetsList)) {
            foreach ($userPresetsList as $key => $preset) {
                if (!empty($preset['fields_data'])) {
                    $userPresetsList[$key]['fields_data'] = json_decode($preset['fields_data']);
                    if (!empty($preset['is_default'])) {
                        $definedColumnOrder = json_decode($preset['fields_data']);
                        $presetId = $preset['id'];
                    }
                }
            }
        }

        $data['listOfDefaultColumnNamesOrder'] = $listOfDefaultColumnNamesOrder;
        $data['columnHeaders'] = $columnHeaders;
        $data['definedColumnOrder'] = $definedColumnOrder;
        $data['tableColumnOrderName'] = $tableColumnName;
        $data['userPresetsList'] = $userPresetsList;
        $data['presetId'] = $presetId;

        return $data;
    }

}
