<?php

/**
 * Class Lead_LeadWelcomeScreenTools
 */
class Tools_LeadWelcomeScreenTools
{

    /**
     * Is restricted access
     *
     * @return string
     */
    public static function isRestrictedAccess()
    {
        $roleId = Zend_Controller_Action_HelperBroker::getStaticHelper('session')->getCurrentUser()->getRoleId();
        $restrictedAccess = '1';
        if (in_array($roleId, array(Tools_Security_Acl::ROLE_SUPERADMIN, Tools_Security_Acl::ROLE_ADMIN))) {
            $restrictedAccess = '0';
        }

        return $restrictedAccess;
    }

    /**
     * Get total count/amount for leads
     *
     * @param array $leadIds lead ids
     * @return array
     */
    public static function getTotalOppStats($leadIds)
    {
        $leadOpportunityDataMapper = Leads_Mapper_LeadsOpportunityMapper::getInstance();
        $data = array();
        if (!empty($leadIds)) {
            $data['totalSpentInfo'] = $leadOpportunityDataMapper->getLeadTotalSales($leadIds);
            $data['totalOpportunitiesInfo'] = $leadOpportunityDataMapper->getLeadTotalOpportunities($leadIds);
        }

        return $data;

    }

    /**
     * Get currency info
     *
     * @param bool $jsFormat format locale flag
     * @return array
     */
    public static function getCurrencyInfo($jsFormat = true)
    {
        $shoppingConfig = Models_Mapper_ShoppingConfig::getInstance()->getConfigParams();

        $country = $shoppingConfig['country'];
        if(!empty($shoppingConfig['currencyCountry'])) {
            $country = $shoppingConfig['currencyCountry'];
        }

        $locale = Zend_Locale::getLocaleToTerritory($country);
        $currency = $shoppingConfig['currency'];
        if ($jsFormat === true) {
            $locale = str_replace('_', '-', $locale);
        }

        return array('locale' => $locale, 'currency' => $currency);
    }

}