import Vue from 'vue';
import App from './components/app/index.vue';
import store from './config/store/';
import VueRouter from 'vue-router';
import "regenerator-runtime/runtime";
import moment from 'moment';
import i18n from "./i18n";
import Multiselect from 'vue-multiselect'
//import Datepicker from 'vuejs-datepicker'; old library
//new lib https://sumcumo.github.io/vue-datepicker/
import DatePicker from '@sum.cumo/vue-datepicker'
import {en, es, fr} from 'vuejs-datepicker/dist/locale'

import routes from './config/routing/routes';

Vue.use(VueRouter);
Vue.use(moment);
Vue.component('multiselect', Multiselect);

const router = new VueRouter({
     routes,
     mode: 'abstract'
 });


router.beforeEach((to, from, next) => {
    if (to.matched.some(record => record.meta.requiresAuth)) {
        console.log(to);
        store.commit('checkToken');
        if (store.getters.isLoggedIn) {
            console.log(store.getters.isLoggedIn);
            next();
            return
        } else {
            next({path: '/login'})
        }
    } else {
        console.log('no auth required');
        next();
    }
});

const userWebApp =  new Vue({
    el: '#welcome-screen-config-block',
    store,
    router,
    i18n,
    render: h => h(App) // h = createElement
});
router.replace('/');
