import Vue from 'vue';
import App from './components/app/index.vue';
import store from './config/store/';
import VueRouter from 'vue-router';
import "regenerator-runtime/runtime";
import VueI18n from 'vue-i18n';
import messages from './localization';

import routes from './config/routing/routes';

Vue.use(VueRouter);
Vue.use(VueI18n);

const i18n = new VueI18n({
    locale: 'en', // set locale
    messages// set locale messages
});

const router = new VueRouter({
     routes,
     mode: 'abstract'
 });

const leadsImport =  new Vue({
    el: '#import-contacts-data-config',
    store,
    router,
    i18n,
    render: h => h(App) // h = createElement
});
router.replace('/');
