define([
    'backbone',
    'text!../templates/lead-sms-detailed-tab.html',
    'i18n!../../../nls/dashboard_'+$('#main-dashboard-system-language').val()+'_ln',
    'tinyMCE',
    'leadshortcode',
    'leadtestsms',
    'placeholder',
    'charlimit'
], function(Backbone, LeadSmsTmpl, i18n, tinymce, leadshortcode, leadtestsms, placeholder, charlimit){
    var LeadSmsFormView = Backbone.View.extend({
        el: $('#lead-detailed-view-config-tab-sms'),
        events: {
            'submit form': 'submit',
            'change #call-device-type': 'selectCallDevice'
        },
        templates: {

        },
        initialize: function(leadModel, smsTabDataModel){
            this.leadModel = leadModel;
            this.leadSmsTabData = smsTabDataModel;
        },
        render: function(){
            tinymce.remove();
            this.$el.empty();
            var websiteUrl = $('#website_url').val(),
                self = this;

            this.$el.append(_.template(LeadSmsTmpl, {'leadModel': this.leadModel, 'smsTabDataModel':  this.leadSmsTabData, 'i18n': i18n}));
            this.$el.find('form').attr('action', websiteUrl+'api/leads/leadsms/');

            tinymce.init({
                script_url              : websiteUrl+'system/js/external/tinymce/tinymce.gzip.php',
                selector                : "#lead-sms-tab-textarea",
                skin                    : 'seotoaster',
                menubar                 : false,
                browser_spellcheck      : true,
                resize                  : false,
                convert_urls            : false,
                relative_urls           : false,
                statusbar               : false,
                allow_script_urls       : false,
                force_p_newlines        : false,
                forced_root_block       : false,
                entity_encoding         : "raw",
                plugins                 :  ["fullscreen leadshortcode placeholder charlimit leadtestsms"],
                toolbar1                : "leadshortcode | fullscreen | spellcheckbtn | leadtestsms",
                image_advtab            : false,
                extended_valid_elements : false,
                setup                   : function(ed){
                    var keyTime = null;
                    ed.on('change blur keyup', function(ed, e){
                        //@see content.js for this function
                        self.dispatchEditorKeyup(ed, e, keyTime);
                        this.save();
                    });

                    ed.addButton('spellcheckbtn', {
                        icon: true,
                        image: websiteUrl+'plugins/leads/web/images/spellcheck.ico',
                        tooltip: _.isUndefined(i18n['How do I enable spell-check in SeoToaster?'])?'How do I enable spell-check in SeoToaster?':i18n['How do I enable spell-check in SeoToaster?'],
                        onclick: function() {
                            window.open('https://www.seotoaster.com/questions-and-answers/crm-faq#lead-spellchecker', '_blank');
                        }
                    })
                }
            });

            $('#lead-sms-tab-textarea').html('<span></span>').trigger('keyup');
            this.tinimce = tinymce;
            $("#lead-sms-follow-up-sequences").chosen({
                'disable_search': true
            }).on('chosen:showing_dropdown', function (e) {
                let setElements = $(e.currentTarget.nextSibling).find('li.disabled-result');
                if (setElements.length) {
                    setElements.addClass('tooltip').attr('title', _.isUndefined(i18n['Set in Workflows']) ? 'Set in Workflows' : i18n['Set in Workflows']);
                }
            });

            var mobileMasks = this.leadModel.get('mobileMasks'),
                mobileCountryCode = this.leadModel.get('lead_mobile_country_code'),
                currentMobileCountryCode = this.attributes.currentMobileCountryCode,
                currentDesktopCountryCode = this.attributes.currentDesktopCountryCode;

            if (typeof mobileMasks[mobileCountryCode] !== 'undefined') {
                $('#lead-call-number').mask(mobileMasks[mobileCountryCode].mask_value, {autoclear: false});
            } else {
                $('#lead-call-number').mask('(999) 999 9999', {autoclear: false});
            }

            if (typeof mobileMasks[currentMobileCountryCode] !== 'undefined') {
                $('#lead-from-call-mobile').mask(mobileMasks[currentMobileCountryCode].mask_value, {autoclear: false});
            } else {
                $('#lead-from-call-mobile').mask('(999) 999 9999', {autoclear: false});
            }
            var mobile = _.isUndefined(i18n['Mobile'])?'Mobile':i18n['Mobile'];
            $('#lead-from-call-mobile-number').text(mobile + ' ' + $('#lead-from-call-mobile').val());

            if (typeof mobileMasks[currentDesktopCountryCode] !== 'undefined') {
                $('#lead-from-call-desktop').mask(mobileMasks[currentDesktopCountryCode].mask_value, {autoclear: false});
            } else {
                $('#lead-from-call-desktop').mask('(999) 999 9999', {autoclear: false});
            }
            var desktop = _.isUndefined(i18n['Desktop'])?'Desktop':i18n['Desktop'];
            $('#lead-from-call-desktop-number').text(desktop + ' ' + $('#lead-from-call-desktop').val());

            var voipPhone = _.isUndefined(i18n['VOIP phone'])?'VOIP phone':i18n['VOIP phone'];
            $('#lead-from-call-voip-phone-number').text(voipPhone + ' ' + $('#lead-from-call-voip-phone').val());

        },
        dispatchEditorKeyup: function(editor, event, keyTime) {
            var keyTimer = keyTime;
            if(keyTimer === null) {
                keyTimer = setTimeout(function() {
                    keyTimer = null;
                }, 1000)
            }
        },
        selectCallDevice: function(e)
        {
            var deviceTypeEl = $(e.currentTarget),
                deviceType = deviceTypeEl.val(),
                phoneEl = deviceTypeEl.closest('form').find('input[name="lead-call-number"]'),
                mobile = '',
                mobileCountyCode = '',
                phone = '',
                phoneCountryCode ='',
                desktopMasks = this.leadModel.get('desktopMasks'),
                mobileMasks = this.leadModel.get('mobileMasks'),
                organizationMobile = '',
                organizationPhone = '';

            if (deviceType === 'mobile') {
                if (!_.isNull(this.leadModel.get('lead_mobile'))) {
                    mobile = this.leadModel.get('lead_mobile');
                }
                if (!_.isNull(this.leadModel.get('lead_mobile_country_code'))) {
                    mobileCountyCode = this.leadModel.get('lead_mobile_country_code');
                }
                if (_.isEmpty(mobileCountyCode)) {
                    $('#lead-phone-mobile-country-codes').val('AC');
                } else {
                    $('#lead-phone-mobile-country-codes').val(mobileCountyCode);
                }
                phoneEl.val(mobile);

                if (typeof mobileMasks[mobileCountyCode] !== 'undefined') {
                    phoneEl.mask(mobileMasks[mobileCountyCode].full_mask_value, {autoclear: false}).focus();
                } else {
                    phoneEl.mask('(999) 999 9999', {autoclear: false}).focus();
                }
            }

            if (deviceType === 'desktop') {
                if (!_.isNull(this.leadModel.get('lead_phone'))) {
                    phone = this.leadModel.get('lead_phone');
                }
                if (!_.isNull(this.leadModel.get('lead_phone_country_code'))) {
                    phoneCountryCode = this.leadModel.get('lead_phone_country_code');
                }
                if (_.isEmpty(phoneCountryCode)) {
                    $('#lead-phone-mobile-country-codes').val('AC');
                } else {
                    $('#lead-phone-mobile-country-codes').val(phoneCountryCode);
                }
                phoneEl.val(phone);
                if (typeof desktopMasks[phoneCountryCode] !== 'undefined') {
                    phoneEl.mask(desktopMasks[phoneCountryCode].full_mask_value, {autoclear: false}).focus();
                } else {
                    phoneEl.mask('(999) 999 9999', {autoclear: false}).focus();
                }
            }

            if (deviceType === 'organization-mobile') {
                if (!_.isNull(this.leadModel.get('organization_mobile'))) {
                    organizationMobile = this.leadModel.get('organization_mobile');
                }
                if (!_.isNull(this.leadModel.get('organization_mobile_country_code'))) {
                    mobileCountyCode = this.leadModel.get('organization_mobile_country_code');
                }
                if (_.isEmpty(mobileCountyCode)) {
                    $('#lead-phone-mobile-country-codes').val('AC');
                } else {
                    $('#lead-phone-mobile-country-codes').val(mobileCountyCode);
                }
                phoneEl.val(organizationMobile);
                if (typeof mobileMasks[mobileCountyCode] !== 'undefined') {
                    phoneEl.mask(mobileMasks[mobileCountyCode].full_mask_value, {autoclear: false}).focus();
                } else {
                    phoneEl.mask('(999) 999 9999', {autoclear: false}).focus();
                }
            }

            if (deviceType === 'organization-phone') {
                if (!_.isNull(this.leadModel.get('organization_phone'))) {
                    organizationPhone = this.leadModel.get('organization_phone');
                }
                if (!_.isNull(this.leadModel.get('organization_phone_country_code'))) {
                    phoneCountryCode = this.leadModel.get('organization_phone_country_code');
                }
                if (_.isEmpty(phoneCountryCode)) {
                    $('#lead-phone-mobile-country-codes').val('AC');
                } else {
                    $('#lead-phone-mobile-country-codes').val(phoneCountryCode);
                }
                phoneEl.val(organizationPhone);
                if (typeof desktopMasks[phoneCountryCode] !== 'undefined') {
                    phoneEl.mask(desktopMasks[phoneCountryCode].full_mask_value, {autoclear: false}).focus();
                } else {
                    phoneEl.mask('(999) 999 9999', {autoclear: false}).focus();
                }
            }
        },
        submit: function(e){
            e.preventDefault();

            var self = this,
                form = $(e.currentTarget),
                isValid = true;

            _.each(form.find('.required'), function(el){
                if (!$(el).val()){
                    isValid = false;
                }
            });

            if (!isValid){
                showMessage(_.isUndefined(i18n['Missing required field'])?'Missing required field':i18n['Missing required field'], true);
                return false;
            }

            $('#content-of-the-sms').val(tinymce.activeEditor.getContent());

            if(form.find('#testSms').val() != 1) {
                $('#lead-sms-now').prop('disabled', true);
            }

            var formParams = form.serialize()+'&secureToken='+$('#lead-grid-token').val(),
                emailSequenceId = form.find('#lead-sms-follow-up-sequences').val();

            $.ajax({
                url: form.attr('action'),
                type: 'POST',
                data: formParams,
                dataType: 'json'
            }).done(function(response) {
                $('#lead-sms-now').prop('disabled', false);
                if (response.error === 1) {
                    form.find('#testSms').val(0);
                    showMessage(response.responseText, true, 5000);
                } else {
                    showMessage(response.responseText, false, 5000);
                    if(form.find('#testSms').val() != 1){
                        self.render();
                    }
                    form.find('#testSms').val(0);
                }
            }).fail(function(response){
                showMessage(response.responseJSON, true, 5000);
                $('#lead-sms-now').prop('disabled', false);
            });
            return false;

        }
    });

    return LeadSmsFormView;
});
